

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

#define SOFTWARE	"ZIFFERN ADC_PWM+Mnenomic"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"16.03.2018 12:00"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <math.h>

#include <avr/pgmspace.h> // <--#include <progmem.h>
#include "main.h"
#include "uart.h"
#include "Befehle.h"
#include "debug.h"
#include "MAX543.h"

/*
****** SOFTWARE SWITCHES  ********
 // #define SERVO_USED	
 // #define SERVO_USED
 // #define ONEBCD_USED
 // #define INT0_EVENT_USED
*/

// GLOBALE VARIABLEN 
volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint8_t gu8Status;
uint8_t gu8Modus;


// Interrupt Section
// ********************
ISR( INT0_vect )
// ********************
{
EIMSK &= ~(1 << INT0); // Interrupt Freischalten
gu8Status |= STATUS_INT0_EVENT;
};

// Interrupt Section
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
volatile static uint32_t u32MerkeT;

//hochzhlen ? 244*/Sekunde
if( ( (gu32_Ticks++) - u32MerkeT) > TICK_500MS )
	{
	u32MerkeT = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_TICK_EVENT;
	};
// !! 244*/ Sekunde	
UART_TXRX_Check();  //langsam, aber sehen ob was kommt am UART
};


#ifdef SERVO_USED	
// *************************************
void Timer0_PWM( uint8_t u8PwmRange)
// *************************************
{  // 8BIT TIMER T0   // #define  _BV(x) (1<<(x))
OCR0A = u8PwmRange;
// CLK_1024  FAST_PWM OC0_MODE
TCCR0A = _BV(WGM00) | _BV(WGM01) | _BV(COM0A1);
TCCR0B =  _BV(CS02) | _BV(CS00); // 1024
//16Mhz / 1024 / 256 = ~ 61 Herz 
DDRD |= _BV(PD6); //OC0A
};
#endif

//********************************
uint16_t ADC_10Bit(uint8_t u8Chan)
//********************************
/*
Externe 5V REF--Dreaht von AVCC zu 5V+
// PRESCALER 3,6864 / 32 = 115200 50-200Khz gewnscht
*/
{
DDRC &= ~_BV(u8Chan);  //Portx Channel Bit Input  
PORTC &= ~_BV(u8Chan); //Pullup abschalten
//Activate ADC with Prescaler 16 --> 16Mhz/128 = 125 khz
ADMUX = (1<< REFS0) | u8Chan;    //AVCC und AREF mit C an GND
ADCSRA = _BV(ADEN) | _BV(ADPS2) | _BV(ADPS1) |_BV(ADPS0);  
//ADMUX = u8Chan | (1<<REFS0);
_delay_us(10);
ADCSRA |= _BV(ADSC);  //Start conversion 
while( ADCSRA & _BV(ADSC) ) // wait until converstion completed
	{
	//~150S
	wdt_reset();	//WATCHDOG!
	};	   
return ADC;// get converted value
};



// *************
int main(void)
// *************
{
uint8_t u8NN;
uint16_t u16DAC_Step=0;

#ifdef SERVO_USED
uint8_t u8OneBCDVal=0;
#endif
#ifdef INT0_EVENT_USED	
uint32_t  u32ZeitMerker=0;
#endif

MAX543_INITDIR();

#ifdef SERVO_USED
ENABLE_INIT();
#endif

DDRB |= LED1_BLINK;	     //Bit 0 von PORTC als Ausgang

#ifdef ONEBCD_USED
ONE_BCD_INIT();  //  1*
#endif

wdt_reset();   //WATCHDOG!
wdt_enable(5); //500mS Totmannknopf

uart_init( UART_BAUD_SELECT_DOUBLE_SPEED( UART_BAUD_RATE, F_CPU) );
ResetRxBuff();
sei(); 

//TickCounter Starten
TCCR2B = (1 << CS22) | (1 << CS21);	//Vorteiler //256 einschalten
TIMSK2 = (1 << TOIE2);	//Interrrupt aktivieren


#ifdef INT0_EVENT_USED	
PORTD &= ~(1<<PORTD2);  // Pullup weg
DDRD &= ~(1<<PORTD2);  // INPUT
EICRA |= (1 << ISC01);					 // Falling INT0
//EICRA |= (1 << ISC01) | (1 << ISC00);	// Rising INT0
EIFR  |= ( 1 << INT0 ); // EVTL INT= EVENT LSCHEN
EIMSK |= ( 1 << INT0 ); // Interrupt Freischalten
#endif


sei();	//Global Interrupt Freischalten

uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p(  PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 

//gu8Status |= STATUS_TRIGGER_OUTPUT;

#ifdef SERVO_USED	
Timer0_PWM( 23);
ENABLE_INIT();
SET_ENABLE();
#endif


gu8Modus = POOR_MANS_SINUS;

u8NN = 0;
for(;;)  //ENSLESS
	{
	sei();
	wdt_reset();	//WATCHDOG!
/*
if( ADC_10Bit(0) < 256)
	{
	gu8Modus = POOR_MANS_SINUS;
	};
*/	
	switch (gu8Modus) 
		{
		case POOR_MANS_SINUS:
			{
			u16DAC_Step++;
			u16DAC_Step %= 4096;	
			MAX543( 2048 + 2047*sin( 2* M_PI * (u16DAC_Step/ 4096.0)) );  // MACH MAL SINUS			
			break;
			};
			
		case POOR_MANS_DREIECK:
			{				
			if( u16DAC_Step > 4095 )
				{
				gu8Status &= ~STATUS_UP_DOWN;	//0=DOWN			
				};
			
			if( u16DAC_Step ==  0 )
				{
				gu8Status |= STATUS_UP_DOWN;	1=UP			
				
				}	
			
			if( gu8Status & STATUS_UP_DOWN ) 	
				{
				u16DAC_Step++;
				}
			else
				{
				u16DAC_Step--;
				};
				
			MAX543( u16DAC_Step );	
			break;
			};	
		case POOR_MANS_SAEGEZAHN_RISING:
			{
			u16DAC_Step++;
			if( u16DAC_Step > 4095 )
				{				
				u16DAC_Step = 0;				
				};
			MAX543( u16DAC_Step );	
			break;
			};	
		case POOR_MANS_SAEGEZAHN_FALLING:
			{
			u16DAC_Step--;
			if( u16DAC_Step == 0 )
				{				
				u16DAC_Step = 4095;				
				};
			MAX543( u16DAC_Step );	
			break;
			};	
		};
	//gu8Modus = POOR_MANS_SINUS;
	
		
	
	if( gu8Status & STATUS_TICK_EVENT )
		{
		gu8Status &= ~STATUS_TICK_EVENT;
		PORTB ^= LED1_BLINK;	// ab jetzt langsame ~1Hz Action

#ifdef SERVO_USED				
		OCR0A = 15 + (ADC_10Bit(0) / 60);
#endif		
#ifdef ONEBCD_USED		
		u8OneBCDVal++;
		u8OneBCDVal %= 10;

		ONE_BCD_PORTX &= ~ONE_BCD_ZIFFER_MASK;	//LSCHE DEN INHALT NUR DER ZIF.BITS
		ONE_BCD_PORTX |= (u8OneBCDVal << ONEBCD_PIN_OFFSET); //Schreibe geshiftet		
		//SET_POINTONE_BCD();
		TOGGLE_POINTONE_BCD();
#endif
		};
		
// ANDERES ZEUG IN MAIN	
#ifdef INT0_EVENT_USED	
	if( gu8Status & STATUS_INT0_EVENT )
		{
		gu8Status &= ~STATUS_INT0_EVENT;			
		uart_puts_p( PSTR(" **Gabellichtschranke Abgedeckt**\r") );
		u32ZeitMerker = gu32_Ticks;
		gu8Status |= STATUS_INT0_EVENT_ACTIVE;
		};
		
	if( (gu8Status & STATUS_INT0_EVENT_ACTIVE) &&
		( gu32_Ticks - u32ZeitMerker > 488) //2 Sec
	)
		{  // SSCHALTE AUS und aktivre danach den Interrupt )
		if( PIND & (1<<PORTD2) )
			{
			gu8Status &= ~STATUS_INT0_EVENT_ACTIVE;
			EICRA |= (1 << ISC01);					 // Falling INT0
			//EICRA |= (1 << ISC01) | (1 << ISC00);	// Rising INT0
			EIFR  |= ( 1 << INT0 ); // EVTL INT= EVENT LSCHEN
			EIMSK |= ( 1 << INT0 ); // Interrupt Freischalten
			uart_puts_p( PSTR(" **Gabellichtschranke Wieder offen**\r") );
			};
		};
	
	if( gu8Status & STATUS_TRIGGER_OUTPUT ) //TO/TF
		{			
		uart_puts_p( PSTR("ADC=") );			
		uart_puts( ultoa( ADC_10Bit(0) , gcaStr, 10 ) );			
		uart_putc( 13 ); //CR
		};
#endif 
//Toggle_Bit(1);
	};
}; // main
   