


//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

#define SOFTWARE	"ZIFFERN ADC_PWM+Mnenomic"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"16.03.2018 12:00"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <math.h>

#include <avr/pgmspace.h> // <--#include <progmem.h>
#include "main.h"
#include "uart.h"
#include "Befehle.h"
#include "debug.h"
#include "MAX543.h"
#include "SinusTabelle.h"
#include "SinusTabelle.h"
#include "ServiceFunc.h"
/*
****** SOFTWARE SWITCHES  ********
 // #define SERVO_USED	
 // #define SERVO_USED
 // #define ONEBCD_USED
 // #define INT0_EVENT_USED
*/

// GLOBALE VARIABLEN 
volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint8_t gu8Status;
uint8_t gu8Modus;
uint8_t gu8SM_Status;

uint16_t gu16SollFrequenz;

int32_t gi32SM_Position =0;

#define MOTOR_5_POL_STEPs	8
const char MCA_ARDUINO_5POL_SM[] PROGMEM = {0x08,0x0C,0x04,0x06,0x02,0x03,0x01,0x09,0};	//CONST ARRAY

const char MCA_STARTREK[] PROGMEM = {0x81,0x42,0x24,0x18,0x24,0x42,0};
#define FULL_STEP_MAX 4
const char MCA_FULLSTEPS[] PROGMEM = {0x3A,0x39,0x35,0x36,0};	//CONST ARRAY
#define HALF_STEP_MAX 4
const char MCA_HALFSTEPS[] PROGMEM = {0x3A,0x28,0x39,0x11,0x35,0x24,0x36,0x12,0};	//CONST ARRAY


// Interrupt Section
// ********************
ISR( INT0_vect )
// ********************
{
EIMSK &= ~(1 << INT0); // Interrupt Freischalten
gu8Status |= STATUS_INT0_EVENT;
};

// Interrupt Section
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
volatile static uint32_t u32MerkeT;
//volatile static uint32_t u32MerkeT_Motor;

//hochzhlen ? 244*/Sekunde
if( ( (gu32_Ticks++) - u32MerkeT) > TICK_1000MS )
	{
	u32MerkeT = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_TICK_EVENT;
	};
/*
if( ( (gu32_Ticks) - u32MerkeT_Motor) > gu16_SM_TickVariable ) // 1/24
	{
	u32MerkeT_Motor = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_MOTOR_TICK;
	};
*/	
// !! 244*/ Sekunde	
UART_TXRX_Check();  //langsam, aber sehen ob was kommt am UART
};



#define RAMPENSTEIGUNG 2
// ***** ***********************************************************
ISR( TIMER1_COMPA_vect )// signal handler	/#define SIG_OUTPUT_COMPARE1A	_VECTOR(6)
// ***** ***********************************************************
{
volatile static uint8_t u8NN;
volatile uint16_t u16IstFrq ;

u16IstFrq = round( F_CPU / 1024.0 / (float)OCR1A );

if( gu8SM_Status & RAMPE_AKTIVE )
	{	
//	if( gu16SollFrequenz > (u16IstFrq + RAMPENSTEIGUNG) )
	if( gu16SollFrequenz > u16IstFrq )
		{
		OCR1A  =  F_CPU / 1024.0 / ((float)(u16IstFrq + RAMPENSTEIGUNG));
		TCNT1 = 0;		
		}
	else
		{
		OCR1A =  F_CPU / 1024.0 / (float)gu16SollFrequenz;
		TCNT1 = 0;	
		gu8SM_Status &= ~RAMPE_AKTIVE;
		};		
	};

if( gu8SM_Status & MOTOR_DIRECTION )
	{
	u8NN++;
	gi32SM_Position++;
	}	
else
	{
	u8NN--;
	gi32SM_Position--;
	};	
u8NN %= 4;
STEPM_PORTX = (STEPM_PORTX &  ~STEPM_6BIT_MASK) | 
	SET_STEPM_BITS( (pgm_read_byte_near( MCA_FULLSTEPS + u8NN ) ) );
};



 
// *********************************
void StartTimer_1( uint16_t u16Frq )
// *********************************
{
TCCR1B = 0;
TCNT1 = 0;
STEPM_INIT();
gu8SM_Status &= ~MOTOR_ON;
gu8SM_Status &= ~RAMPE_AKTIVE;

if( u16Frq )
	{	
	gu16SollFrequenz = u16Frq;
	if( gu8SM_Status & RAMPE_ENABLED )
		{
		OCR1A = round( F_CPU / 1024.0 ); // Starte langsam /(1sekunde)
		gu8SM_Status |= RAMPE_AKTIVE;
		}
	else
		{
		OCR1A = round( F_CPU / 1024.0 / (float)gu16SollFrequenz );
		};
	
	TIMSK1 = _BV(OCIE1A); 	//Interrupt
	TCCR1B = _BV( WGM12) | _BV( CS12) | _BV(CS10); //CTC + /1024
	gu8SM_Status |= MOTOR_ON;	
	sei();
	}
else
	{
	TCCR1B = 0; // STOP CLOCK
	TIMSK1 = 0;	// DISBALE INTERRUPT T1
	STEPM_PORTX &= ~STEPM_6BIT_MASK;
	gu8SM_Status &= ~MOTOR_ON;
	};
};



#ifdef SERVO_USED	
// *************************************
void Timer0_PWM( uint8_t u8PwmRange)
// *************************************
{  // 8BIT TIMER T0   // #define  _BV(x) (1<<(x))
OCR0A = u8PwmRange;
// CLK_1024  FAST_PWM OC0_MODE
TCCR0A = _BV(WGM00) | _BV(WGM01) | _BV(COM0A1);
TCCR0B =  _BV(CS02) | _BV(CS00); // 1024
//16Mhz / 1024 / 256 = ~ 61 Herz 
DDRD |= _BV(PD6); //OC0A
};
#endif


// *************
int main(void)
// *************
{
uint8_t u8StepMotorParser=0;
uint8_t u8NN;
uint16_t u16DAC_Step=0;

#ifdef SERVO_USED
uint8_t u8OneBCDVal=0;
#endif
#ifdef INT0_EVENT_USED	
uint32_t  u32ZeitMerker=0;
#endif

MAX543_INITDIR();

#ifdef SERVO_USED
ENABLE_INIT();
#endif

DDRB |= LED1_BLINK;	     //Bit 0 von PORTC als Ausgang

#ifdef ONEBCD_USED
ONE_BCD_INIT();  //  1*
#endif

wdt_reset();   //WATCHDOG!
wdt_enable(5); //500mS Totmannknopf

uart_init( UART_BAUD_SELECT_DOUBLE_SPEED( UART_BAUD_RATE, F_CPU) );
ResetRxBuff();
sei(); 

//TickCounter Starten
TCCR2B = (1 << CS22) | (1 << CS21);	//Vorteiler //256 einschalten
TIMSK2 = (1 << TOIE2);	//Interrrupt aktivieren


#ifdef INT0_EVENT_USED	
PORTD &= ~(1<<PORTD2);  // Pullup weg
DDRD &= ~(1<<PORTD2);  // INPUT
EICRA |= (1 << ISC01);					 // Falling INT0
//EICRA |= (1 << ISC01) | (1 << ISC00);	// Rising INT0
EIFR  |= ( 1 << INT0 ); // EVTL INT= EVENT LSCHEN
EIMSK |= ( 1 << INT0 ); // Interrupt Freischalten
#endif


sei();	//Global Interrupt Freischalten

uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p(  PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 

//gu8Status |= STATUS_TRIGGER_OUTPUT;

#ifdef SERVO_USED	
Timer0_PWM( 23);
ENABLE_INIT();
SET_ENABLE();
#endif

gu8SM_Status |= RAMPE_ENABLED;  // ENTSCHEIDUNG, mit RAMPE
StartTimer_1( 200 );

gu8Modus = POOR_MANS_SINUS;
u8NN = 0;

for(;;)  //ENSLESS
	{
	sei();
	wdt_reset();	//WATCHDOG!
/*
if( ADC_10Bit(0) < 256)
	{
	gu8Modus = POOR_MANS_SINUS;
	};
*/	
	switch (gu8Modus) 
		{//gu8Modus = POOR_MANS_SINUS;	
		case POOR_MANS_SINUS:
			{
			u16DAC_Step++;
			u16DAC_Step %= 4096;	
			MAX543( 2048 + 2047*sin( 2* M_PI * (u16DAC_Step/ 4096.0)) );  // MACH MAL SINUS			
			break;
			};

		case SINUS_TABELLE:
			{
			u16DAC_Step++;
			u16DAC_Step %= SIN_8BIT_VALCNT_MAX;	
			//Anpassung von 256 auf 4096er Auflsung = 16*
			MAX543( 16* pgm_read_byte_near(MCA_SINUS + u16DAC_Step ) );  // MACH MAL SINUS			
			break;
			};			
			
		case POOR_MANS_DREIECK:
			{				
			if( u16DAC_Step > 4095 )
				{
				gu8Status &= ~STATUS_UP_DOWN;	//0=DOWN			
				};
			
			if( u16DAC_Step ==  0 )
				{
				gu8Status |= STATUS_UP_DOWN;	//1=UP			
				
				}	
			
			if( gu8Status & STATUS_UP_DOWN ) 	
				{
				u16DAC_Step++;
				}
			else
				{
				u16DAC_Step--;
				};
				
			MAX543( u16DAC_Step );	
			break;
			};	
		case POOR_MANS_SAEGEZAHN_RISING:
			{
			u16DAC_Step++;
			if( u16DAC_Step > 4095 )
				{				
				u16DAC_Step = 0;				
				};
			MAX543( u16DAC_Step );	
			break;
			};	
		case POOR_MANS_SAEGEZAHN_FALLING:
			{
			u16DAC_Step--;
			if( u16DAC_Step == 0 )
				{				
				u16DAC_Step = 4095;				
				};
			MAX543( u16DAC_Step );	
			break;
			};	
		};
	
/*
	if( gu8Status & STATUS_MOTOR_TICK )
		{		
		gu8Status &= ~STATUS_MOTOR_TICK;
		
		STEPM_INIT();		
		u8StepMotorParser++;
		u8StepMotorParser %= 4;  //#define MOTOR_5_POL_STEPs	8
		//1: LSCHE BITS
		//2.  pgm_read_byte_near( MCA_ARDUINO_5POL_SM  +  u8StepMotorParser )
		//3.  PORTX = LSCHE_VAL |  VALUE
		STEPM_PORTX = (STEPM_PORTX &= ~STEPM_6BIT_MASK) | 
					 (SET_STEPM_BITS( pgm_read_byte_near( MCA_ARDUINO_5POL_SM  +  u8StepMotorParser ) ));
		};
*/		
		
		
	if( gu8Status & STATUS_TICK_EVENT )
		{
		gu8Status &= ~STATUS_TICK_EVENT;
		PORTB ^= LED1_BLINK;	// ab jetzt langsame ~1Hz Action
				
		uart_puts_p( PSTR("OCR1A=") ); 
		uart_puts( ultoa( OCR1A, gcaNumStr, 10 ) );
		uart_puts_p( PSTR("   ,Frequenz=") ); 
		uart_puts( ultoa( round( F_CPU / 1024.0 / (float)OCR1A) , gcaNumStr, 10 ) );
		
		uart_puts_p( PSTR("   ,SollFr=") ); 
		uart_puts( ultoa( gu16SollFrequenz , gcaNumStr, 10 ) );
		
		
		uart_puts_p( PSTR("   ,Pos=") ); 
		uart_puts( ltoa( gi32SM_Position , gcaNumStr, 10 ) );
		uart_putc( 13 );
	
#ifdef SERVO_USED				
		OCR0A = 15 + (ADC_10Bit(0) / 60);
#endif		

#ifdef ONEBCD_USED		
		u8OneBCDVal++;
		u8OneBCDVal %= 10;

		ONE_BCD_PORTX &= ~ONE_BCD_ZIFFER_MASK;	//LSCHE DEN INHALT NUR DER ZIF.BITS
		ONE_BCD_PORTX |= (u8OneBCDVal << ONEBCD_PIN_OFFSET); //Schreibe geshiftet		
		//SET_POINTONE_BCD();
		TOGGLE_POINTONE_BCD();
#endif
		};
		
// ANDERES ZEUG IN MAIN	
#ifdef INT0_EVENT_USED	
	if( gu8Status & STATUS_INT0_EVENT )
		{
		gu8Status &= ~STATUS_INT0_EVENT;			
		uart_puts_p( PSTR(" **Gabellichtschranke Abgedeckt**\r") );
		u32ZeitMerker = gu32_Ticks;
		gu8Status |= STATUS_INT0_EVENT_ACTIVE;
		};
		
	if( (gu8Status & STATUS_INT0_EVENT_ACTIVE) &&
		( gu32_Ticks - u32ZeitMerker > 488) //2 Sec
	)
		{  // SSCHALTE AUS und aktivre danach den Interrupt )
		if( PIND & (1<<PORTD2) )
			{
			gu8Status &= ~STATUS_INT0_EVENT_ACTIVE;
			EICRA |= (1 << ISC01);					 // Falling INT0
			//EICRA |= (1 << ISC01) | (1 << ISC00);	// Rising INT0
			EIFR  |= ( 1 << INT0 ); // EVTL INT= EVENT LSCHEN
			EIMSK |= ( 1 << INT0 ); // Interrupt Freischalten
			uart_puts_p( PSTR(" **Gabellichtschranke Wieder offen**\r") );
			};
		};
	
	if( gu8Status & STATUS_TRIGGER_OUTPUT ) //TO/TF
		{			
		uart_puts_p( PSTR("ADC=") );			
		uart_puts( ultoa( ADC_10Bit(0) , gcaStr, 10 ) );			
		uart_putc( 13 ); //CR
		};
#endif 
//Toggle_Bit(1);
	};
}; // main
   