



#ifndef MAIN_HEADER  //Prevents multiple includes
	#define MAIN_HEADER

#define UART_USE_ENABLED

//#define UART_BAUD_RATE	9600	/* 9600 baud */
//#define UART_BAUD_RATE	2400
//#define UART_BAUD_RATE	19200U
//#define UART_#_RATE		38400U
#define UART_BAUD_RATE	115200UL	//UART_BAUD_SELECT_DOUBLE_SPEED

// 16000000 / 256 = ~244
#define TICK_10SEKUNDEN 2441U
#define TICK_2000MS 488U
#define TICK_1500MS 366U
#define TICK_1000MS 244U
#define TICK_500MS 122U
#define TICK_250MS 61U
#define TICK_100MS 24U
#define TICK_50MS 12U
#define TICK_25MS 6U
#define TICK_10MS 2U

//RUNDUNG
//1 MHZ / 256/ 2

// ***** MEINE DEFINES ******

#define ENABLE_DIRX 	DDRC
#define ENABLE_PORTX 	PORTC
#define ENABLE_BIT	 	(1<<4)
#define ENABLE_INIT() 	(ENABLE_DIRX |= ENABLE_BIT)
#define SET_ENABLE()	(ENABLE_PORTX |= ENABLE_BIT)
#define CLR_ENABLE()	(ENABLE_PORTX &= ~ENABLE_BIT)


#define ONE_BCD_DDRX		DDRD
#define ONE_BCD_PORTX		PORTD
#define ONEBCD_PIN_OFFSET	3
#define ONE_BCD_BITS		0b11111000  //0xF8
#define ONE_BCD_ZIFFER_MASK	0b01111000	//0x78
#define ONE_BCD_POINT_BIT	0b10000000	//0x80

#define ONE_BCD_INIT()	(ONE_BCD_DDRX |= ONE_BCD_BITS)

#define SET_POINTONE_BCD()		(ONE_BCD_PORTX |= ONE_BCD_POINT_BIT)
#define CLR_POINTONE_BCD()		(ONE_BCD_PORTX &= ~ONE_BCD_POINT_BIT)
#define TOGGLE_POINTONE_BCD()	(ONE_BCD_PORTX ^= ONE_BCD_POINT_BIT) //XOR


#define LED1_BLINK	(1<<PB5)	//LED an BIT 5

#define STATUS_TICK_EVENT		0x01
#define STATUS_TRIGGER_OUTPUT	0x02
#define STATUS_INT0_EVENT		0x04
#define STATUS_INT0_EVENT_ACTIVE	0x08
#define STATUS_UP_DOWN				0x10
#define STATUS_MOTOR_TICK			0x20
#define STATUS_LIGHTSHOW_FLAG	0x40
//gu8Status

// STATEMACHINE
#define STATEMACH_NIX			0
#define POOR_MANS_SINUS			1
#define POOR_MANS_DREIECK		2
#define POOR_MANS_SAEGEZAHN_RISING		3		
#define POOR_MANS_SAEGEZAHN_FALLING 	4
#define SINUS_TABELLE			5
#define STATEMACH_STARTREK		7
#define STATEMACH_BLINK			8
#define STATEMACH_FLASHLIGHT	9
#define STATEMACH_BREIT_LIGHT	10
#define STATEMACH_SHIFT_LR		11
#define STATEMACH_DISCO			12

//gu8Modus


#define STEPM_PORTX				PORTB
#define STEPM_DDRX				DDRB
#define STEPM_MASK_OFFSET		(0)
#define STEPM_MASK_USED_BITS	(6)			//E2,E1,4-3-2-1
#define STEPM_6BIT_MASK			0b00111111	//E2,E1,4,3,2,1,0

#define STEPM_INIT()		(STEPM_DDRX |= STEPM_6BIT_MASK)
#define SET_STEPM_BITS(x)	( (x) << STEPM_MASK_OFFSET)


#define MOTOR_ON 		0x01
#define MOTOR_DIRECTION 0x02
//#define MOTOR_STOP		0x04
#define RAMPE_ENABLED	0x08
#define RAMPE_AKTIVE	0x10
#define SOLL_FRQ_OK		0x20
//gu8SM_Status &= ~MOTOR_ON;


extern volatile uint32_t gu32_Ticks;
extern volatile uint16_t gu16_TickVariable;

extern uint8_t gu8Modus;

extern volatile uint8_t gu8Status;
extern volatile uint8_t gu8Status;
extern volatile uint32_t gu32_u8Status;
extern uint16_t gu16SollFrequenz;;

extern void StartTimer_1( uint16_t u16Frq );
extern uint8_t gu8SM_Status;
#endif  //MAIN_HEADER
