
//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------


#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include <stdlib.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include <math.h>
#include "main.h"
#include "uart.h"
#include "Befehle.h"
#include "ServiceFunc.h"
#include "debug.h"



// ********************
ISR( TIMER0_COMPA_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{
PORTD &= ~(1<< PD6); // OC0A
//Toggle_Bit(1);
};

#ifdef SERVO_USED
// jedes PORT-BIT kann eigentlich verwendet werden
// *************************************
void Timer0_PWM_Start( uint8_t u8PwmRange) //Normal Mode
// *************************************
{  // 8BIT TIMER T0   // #define  _BV(x) (1<<(x))
OCR0A = u8PwmRange;
DDRD |= (1<< PD6); // OC0A
// CLK_256  FAST_PWM OC0_MODE
//TCCR0A = 0; // Clear OC0A COMp-MATCH
TCCR0A = 0; // NOP
//16Mhz /256 / 256 = ~ 244 Herz 
TCCR0B = (1<< CS02); //256 = ~244HZ
TIMSK0 = (1<< OCIE0A) | (1<< TOIE0); //OVL  + COMPA
};
#endif


//********************************
uint16_t ADC_10Bit(uint8_t u8Chan)
//********************************
/*
Externe 5V REF--Dreaht von AVCC zu 5V+
// PRESCALER 3,6864 / 32 = 115200 50-200Khz gewnscht
*/
{
DDRC &= ~_BV(u8Chan);  //Portx Channel Bit Input  
PORTC &= ~_BV(u8Chan); //Pullup abschalten
//Activate ADC with Prescaler 16 --> 16Mhz/128 = 125 khz
ADMUX = (1<< REFS0) | u8Chan;    //AVCC und AREF mit C an GND
ADCSRA = _BV(ADEN) | _BV(ADPS2) | _BV(ADPS1) |_BV(ADPS0);  
//ADMUX = u8Chan | (1<<REFS0);
ADCSRA |= _BV(ADSC);  //Start conversion 
while( ADCSRA & _BV(ADSC) ) // wait until converstion completed
	{
	//~150S
	wdt_reset();	//WATCHDOG!
	};	   
return ADC;// get converted value
};

