


//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
 
#define SOFTWARE	"4xBCD+Schrittmotor + Matrix"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"21.03.2018 12:00"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <math.h>

#include <avr/pgmspace.h> // <--#include <progmem.h>
#include "main.h"
#include "uart.h"
#include "Befehle.h"
#include "debug.h"
#include "MAX543.h"
#include "SinusTabelle.h"
#include "SinusTabelle.h"
#include "ServiceFunc.h"
#include "max7219.h"
#include "rc5_ATM328.h"
#include "MY_RC5_Func_ATM328.h"
#include "ds18b20-Pin.h"
#include "OutPort74-595.h"
#include "4xBCD-Multiplex.h"

/*
****** SOFTWARE SWITCHES  ********
 // #define SERVO_USED	
 // #define SERVO_USED
 // #define ONEBCD_USED
 // #define INT0_EVENT_USED
*/

// GLOBALE VARIABLEN 
volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint16_t gu16_TickVariable =24;
volatile uint8_t gu8Status;
volatile uint8_t gu8BCD_UpdateRate = 0;

volatile uint8_t gu8StateMach;
volatile uint8_t gu8SM_Status;
volatile uint8_t gu8Modus;

uint16_t gu16SollFrequenz;

PGM_P gpmcaPattern;
uint16_t gu16Parser;  // *( Prser + nn )
uint16_t gu16PatternSize; // Achtung eine 0 muss im Feld sein

#define MOTOR_5_POL_STEPs	8
const char MCA_ARDUINO_5POL_SM[] PROGMEM = {0x08,0x0C,0x04,0x06,0x02,0x03,0x01,0x09,0};	//CONST ARRAY
#define FULL_STEP_MAX 4
const char MCA_FULLSTEPS[] PROGMEM = {0x3A,0x39,0x35,0x36,0};	//CONST ARRAY
#define HALF_STEP_MAX 4
const char MCA_HALFSTEPS[] PROGMEM = {0x3A,0x28,0x39,0x11,0x35,0x24,0x36,0x12,0};	//CONST ARRAY

const char MCA_STARTREK[] PROGMEM = {0x81,0x42,0x24,0x18,0x24,0x42,0};
const char MCA_Blink[] PROGMEM = {0xAA,0x55,0};
const char MCA_FLASH_LIGHT[] PROGMEM = {0X00,0xFF,0}; // GEFAHR -- No strlen
const char MCA_BREIT_LIGHT[] PROGMEM = {0x18,0x3C,0xE7,0xFF,0xE7,0x3C,0x18,0};   //die 0 nicht vergessen bei Strlen_P
const char MCA_KNIGHT_RIDER[] PROGMEM = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,0};


//So ist es richtig
const char MCA_DISCO[] PROGMEM =
{
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,

0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,

0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,

0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,

0x05,0x05,0xAA,0xAA,
0x05,0x05,0xAA,0xAA,
0x05,0x05,0xAA,0xAA,
0
};


/*
// Interrupt Section
// ********************
ISR( INT0_vect )
// ********************
{
EIMSK &= ~(1 << INT0); // Interrupt Freischalten
gu8Modus |= STATUS_INT0_EVENT;
};
*/

// Interrupt Section
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
volatile static uint32_t u32MerkeT;
volatile static uint32_t u32MerkeT2;
volatile static uint32_t u32MerkeT_BCD;
//volatile static uint32_t u32MerkeT_Motor;

//hochzhlen ? 244*/Sekunde
if( ( (gu32_Ticks++) - u32MerkeT) > TICK_2000MS )
	{
	u32MerkeT = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_TICK_EVENT;
	};

if( ( gu32_Ticks - u32MerkeT2) > gu16_TickVariable ) // 1/24
	{
	u32MerkeT2 = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_LIGHTSHOW_FLAG;
	};

if( ( gu32_Ticks - u32MerkeT_BCD) > gu8BCD_UpdateRate ) //25*/Sec
	{
	u32MerkeT_BCD = gu32_Ticks;	//neue Zeit merken		
	BCD_4x_Multiplex();	// Array muss gefllt sein
	};
	
UART_TXRX_Check();  //langsam, aber sehen ob was kommt am UART	
// !! 244*/ Sekunde	
};


#define RAMPENSTEIGUNG 2

// ***** ***********************************************************
ISR( TIMER1_COMPA_vect )// signal handler	/#define SIG_OUTPUT_COMPARE1A	_VECTOR(6)
// ***** ***********************************************************
{
volatile static uint8_t u8NN;
volatile uint16_t u16IstFrq ;
u16IstFrq = round( F_CPU / 1024.0 / (float)OCR1A );
if( gu8SM_Status & RAMPE_AKTIVE )
	{	
//	if( gu16SollFrequenz > (u16IstFrq + RAMPENSTEIGUNG) )
	if( gu16SollFrequenz > u16IstFrq )
		{
		OCR1A  = round( F_CPU / 1024.0 / ((float)(u16IstFrq + RAMPENSTEIGUNG)) );
		TCNT1 = 0;		
		}
	else
		{
		OCR1A = round( F_CPU / 1024.0 / (float)gu16SollFrequenz );
		TCNT1 = 0;	
		gu8SM_Status &= ~RAMPE_AKTIVE;
		};
		
	};

if( gu8SM_Status & MOTOR_DIRECTION )
	{
	u8NN++;
	}	
else
	{
	u8NN--;
	};	
u8NN %= 4;
STEPM_PORTX = (STEPM_PORTX &  ~STEPM_6BIT_MASK) | 
	SET_STEPM_BITS( (pgm_read_byte_near( MCA_FULLSTEPS + u8NN ) ) );
};



 
// *********************************
void StartTimer_1( uint16_t u16Frq )
// *********************************
{
TCCR1B = 0;
TCNT1 = 0;
STEPM_INIT();
gu8SM_Status &= ~MOTOR_ON;
gu8SM_Status &= ~RAMPE_AKTIVE;

if( u16Frq )
	{	
	gu16SollFrequenz = u16Frq;
	if( gu8SM_Status & RAMPE_ENABLED )
		{
		OCR1A = round( F_CPU / 1024.0 ); // Starte langsam /(1sekunde)
		gu8SM_Status |= RAMPE_AKTIVE;
		}
	else
		{
		OCR1A = round( F_CPU / 1024.0 / (float)gu16SollFrequenz );
		};
	
	TIMSK1 = _BV(OCIE1A); //Interrupt
	TCCR1B = _BV( WGM12) | _BV( CS12) | _BV(CS10); //CTC + /1024
	gu8SM_Status |= MOTOR_ON;	
	sei();
	}
else
	{
	TCCR1B = 0; // STOP CLOCK
	TIMSK1 = 0;	// DISBALE INTERRUPT T1
	STEPM_PORTX &= ~STEPM_6BIT_MASK;
	gu8SM_Status &= ~MOTOR_ON;
	};
};



#ifdef SERVO_USED	
// *************************************
void Timer0_PWM( uint8_t u8PwmRange)
// *************************************
{  // 8BIT TIMER T0   // #define  _BV(x) (1<<(x))
OCR0A = u8PwmRange;
// CLK_1024  FAST_PWM OC0_MODE
TCCR0A = _BV(WGM00) | _BV(WGM01) | _BV(COM0A1);
TCCR0B =  _BV(CS02) | _BV(CS00); // 1024
//16Mhz / 1024 / 256 = ~ 61 Herz 
DDRD |= _BV(PD6); //OC0A
};
#endif


#define FLOAT_PRECDIGITS_MAX	5 // +123.4 DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);
#define FLOAT_DIGITS_MAX		2 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);
// *********************
char *FloatToNumStr(double fVal)
// *************
{
dtostrf(fVal, FLOAT_PRECDIGITS_MAX, FLOAT_DIGITS_MAX, gcaNumStr ); //[-]d.ddd
return gcaNumStr;
};

// *********************
void StatusMaschine(void)
// *********************
{
uint16_t u16DAC_Step=0;

	switch (gu8StateMach) 
		{//gu8StateMach = POOR_MANS_SINUS;	
		case  STATEMACH_NIX:
			{
			break;
			};
			
		case POOR_MANS_SINUS:
			{
			u16DAC_Step++;
			u16DAC_Step %= 4096;	
			//MAX543( 2048 + 2047*sin( 2* M_PI * (u16DAC_Step/ 4096.0)) );  // MACH MAL SINUS			
			break;
			};
			
		case STATEMACH_STARTREK:
		{
		gpmcaPattern = MCA_STARTREK;
		gu16PatternSize = sizeof( MCA_STARTREK ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_BLINK:
		{
		gpmcaPattern =  MCA_Blink;
		gu16PatternSize = sizeof( MCA_Blink ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_FLASHLIGHT:
		{
		gpmcaPattern = MCA_FLASH_LIGHT;
		gu16PatternSize = 2;		// nur 2 Bytr im Array
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_BREIT_LIGHT:
		{
		gpmcaPattern =  MCA_BREIT_LIGHT;
		gu16PatternSize = sizeof( MCA_BREIT_LIGHT ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case  STATEMACH_SHIFT_LR:
		{
		gpmcaPattern = MCA_KNIGHT_RIDER;
		gu16PatternSize = sizeof( MCA_KNIGHT_RIDER ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
		
	case STATEMACH_DISCO:
		{
		gpmcaPattern = MCA_DISCO;
		gu16PatternSize = sizeof( MCA_DISCO ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	};
};




// *************
//FORMAT  "23.98"
void GenerateBCDVal(char *pStr)
// *************
{
//"23.45"  KEIN Punkt
gu8aBCD_Value[0]= *(pStr+0) - 48; // x0.00 48=ASCII 0
gu8aBCD_Value[1]= *(pStr+1) - 48; // 0x.00 48=ASCII 0
gu8aBCD_Value[2]= *(pStr+3) - 48; // 00.x0  48=ASCII 0
gu8aBCD_Value[3]= *(pStr+4) - 48; // 00.0x 48=ASCII 0

};



// *************
int main(void)
// *************
{
uint8_t u8StepMotorParser=0;
uint8_t u8NN;

#ifdef SERVO_USED
uint8_t u8OneBCDVal=0;
#endif
#ifdef INT0_EVENT_USED	
uint32_t  u32ZeitMerker=0;
#endif

//MAX543_INITDIR();

#ifdef SERVO_USED
ENABLE_INIT();
#endif

//DDRB |= LED1_BLINK;	     //Bit 0 von PORTC als Ausgang

#ifdef ONEBCD_USED
ONE_BCD_INIT();  //  1*
#endif

wdt_reset();   //WATCHDOG!
wdt_enable(5); //500mS Totmannknopf

// DS18B20 AN PORTC BIT 0
Set_DS18B20_Pin( DS18B20_BIT ) ;
ds18b20_reset();

OUT_74595_InitDDRegs();

uart_init( UART_BAUD_SELECT_DOUBLE_SPEED( UART_BAUD_RATE, F_CPU) );
ResetRxBuff();

//TickCounter Starten
TCCR2B = (1 << CS22) | (1 << CS21);	//Vorteiler //256 einschalten
TIMSK2 = (1 << TOIE2);	//Interrrupt aktivieren
sei(); 


#ifdef INT0_EVENT_USED	
PORTD &= ~(1<<PORTD2);  // Pullup weg
DDRD &= ~(1<<PORTD2);  // INPUT
EICRA |= (1 << ISC01);					 // Falling INT0
//EICRA |= (1 << ISC01) | (1 << ISC00);	// Rising INT0
EIFR  |= ( 1 << INT0 ); // EVTL INT= EVENT LSCHEN
EIMSK |= ( 1 << INT0 ); // Interrupt Freischalten
#endif


sei();	//Global Interrupt Freischalten

uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p(  PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 

//gu8Status |= STATUS_TRIGGER_OUTPUT;

#ifdef SERVO_USED	
Timer0_PWM( 23);
ENABLE_INIT();
SET_ENABLE();
#endif

gu8SM_Status |= RAMPE_ENABLED;
//StartTimer_1( 200 );

//gu8StateMach = POOR_MANS_SINUS;

MAX7219_Init();
MAX7219_Clear ();


//MCUCR = MCUCR_INT1_FALLING_EDGE; //ISC00=0;  FALLING EDGE --> INT0, INT1   //NICHT mit MCUCSR verwechseln !
rc5_init( RC5_ALL );
//gstRC5.u8RC5_State_Flags = RC5_READY_FLAG;
gstRC5.u8RC5_State_Flags = RC5_EVENT_DONE_FLAG;
gstRC5.u32EventTime = gu32_Ticks;



/*
gpmcaPattern =  MCA_DISCO;
gu16PatternSize = strlen_P( MCA_DISCO );
gu16Parser = 0;
*/

gu8StateMach = STATEMACH_DISCO;

u8NN = 0;
for(;;)  //ENDLESS
	{
	sei();
	wdt_reset();	//WATCHDOG!
	
	// Auslagerung wegen zu langer Interruptdauer
	if( gu8Status & STATUS_ORDER_EVENT)
	{
	CheckOrder( gcaRxStr );//gcaRxStr = accumulated str
	ResetRxBuff();
	gu8Status &= ~STATUS_ORDER_EVENT;
	};
	
	//StatusMaschine();

	//RC5_Mainlopp_Polling();
	gu8Status &= ~STATUS_LIGHTSHOW_FLAG;
	if( gu8Status & STATUS_LIGHTSHOW_FLAG)  // schnellere Aufruf
		{
		gu8Status &= ~STATUS_LIGHTSHOW_FLAG;
		/// Sinus_Servo( u8NN % (uint8_t)XRES );  u8NN++;		
		MAX7219_Clear();
		MAX7219_Write( 1, pgm_read_byte_near( (PGM_P)(gpmcaPattern + ((gu16Parser++) % gu16PatternSize) )));
		MAX7219_Write( 2, gu8SM_Status );
		MAX7219_Write( 3, gu8Status );
		MAX7219_Write( 4, gu8aBCD_Value[0]);
		MAX7219_Write( 5, gu8aBCD_Value[1]);
		MAX7219_Write( 6, gu8aBCD_Value[2]);
		MAX7219_Write( 7, gu8aBCD_Value[3]);		
		//Show_Byte( pgm_read_byte_near( (PGM_P)(gpmcaPattern + ((gu16Parser++) % gu16PatternSize) )) ); 
		//=pgm_read_byte_near( MCA_STARTREK + ( gu16Parser % 6 ) );
		};
		
	if( gu8Status & STATUS_TICK_EVENT )
		{
		gu8Status &= ~STATUS_TICK_EVENT;
		//PORTB ^= LED1_BLINK;	// ab jetzt langsame ~1Hz Action				
		uart_puts_p( PSTR("\r\nTemp=") );	
		uart_puts( FloatToNumStr(  ds18b20_gettemp( DS18B20_BIT ) ));	
		
		GenerateBCDVal( gcaNumStr );
			
		uart_putc( 13 );
				
#ifdef SMOTROR_TEST_MESSAGE_USED				
		uart_puts_p( PSTR("OCR1A=") ); 
		uart_puts( ultoa( OCR1A, gcaNumStr, 10 ) );
		uart_puts_p( PSTR("   ,Frequenz=") ); 
		uart_puts( ultoa(  F_CPU / 1024.0 / (float)OCR1A , gcaNumStr, 10 ) );
		
		uart_puts_p( PSTR("   ,SollFr=") ); 
		uart_puts( ultoa( gu16SollFrequenz , gcaNumStr, 10 ) );
		
		uart_putc( 13 );
#endif
#ifdef SERVO_USED				
		OCR0A = 15 + (ADC_10Bit(0) / 60);
#endif		

#ifdef ONEBCD_USED		
		u8OneBCDVal++;
		u8OneBCDVal %= 10;

		ONE_BCD_PORTX &= ~ONE_BCD_ZIFFER_MASK;	//LSCHE DEN INHALT NUR DER ZIF.BITS
		ONE_BCD_PORTX |= (u8OneBCDVal << ONEBCD_PIN_OFFSET); //Schreibe geshiftet		
		//SET_POINTONE_BCD();
		TOGGLE_POINTONE_BCD();
#endif
		};
		
// ANDERES ZEUG IN MAIN	

//Toggle_Bit(1);
	};
}; // main


/*
if( ADC_10Bit(0) < 256)
	{
	gu8StateMach = POOR_MANS_SINUS;
	};
*/

/*
	if( gu8Status & STATUS_MOTOR_TICK )
		{		
		gu8Status &= ~STATUS_MOTOR_TICK;
		
		STEPM_INIT();		
		u8StepMotorParser++;
		u8StepMotorParser %= 4;  //#define MOTOR_5_POL_STEPs	8
		//1: LSCHE BITS
		//2.  pgm_read_byte_near( MCA_ARDUINO_5POL_SM  +  u8StepMotorParser )
		//3.  PORTX = LSCHE_VAL |  VALUE
		STEPM_PORTX = (STEPM_PORTX &= ~STEPM_6BIT_MASK) | 
					 (SET_STEPM_BITS( pgm_read_byte_near( MCA_ARDUINO_5POL_SM  +  u8StepMotorParser ) ));
		};
*/		
		
   