


//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
 /*
 http://rn-wissen.de/wiki/index.php?title=V-USB:_Ein_Firmware_USB-Treiber_f%C3%BCr_AVR
`*/
#define SOFTWARE	"MIDI
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"21.03.2018 12:00"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <math.h>

#include <avr/pgmspace.h> // <--#include <progmem.h>
#include "main.h"
#include "uart.h"
#include "Befehle.h"
#include "debug.h"


#include "usbdrv.h" //Der USB-Treiber
/*
****** SOFTWARE SWITCHES  ********
 // #define SERVO_USED	
 // #define SERVO_USED
 // #define ONEBCD_USED
 // #define INT0_EVENT_USED
*/

// GLOBALE VARIABLEN 
volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint8_t gu8Status;

volatile uint8_t gu8StateMach;
volatile uint8_t gu8Modus;

/*
// Interrupt Section
// ********************
ISR( INT0_vect )
// ********************
{
EIMSK &= ~(1 << INT0); // Interrupt Freischalten
gu8Modus |= STATUS_INT0_EVENT;
};
*/

// Interrupt Section
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
volatile static uint32_t u32MerkeT;
volatile static uint32_t u32MerkeT2;
volatile static uint32_t u32MerkeT_BCD;
//volatile static uint32_t u32MerkeT_Motor;

//hochzhlen ? 244*/Sekunde
if( ( (gu32_Ticks++) - u32MerkeT) > TICK_2000MS )
	{
	u32MerkeT = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_TICK_EVENT;
	};
	
UART_TXRX_Check();  //langsam, aber sehen ob was kommt am UART	
// !! 244*/ Sekunde	
};


#define RAMPENSTEIGUNG 2


USB_PUBLIC uchar usbFunctionSetup(uchar data[8])
{
usbRequest_t    *rq = (void *)data;
static uchar    replyBuf[2];

    usbMsgPtr = replyBuf;
    if(rq->bRequest == 0){
	replyBuf[0] = rq->wValue.bytes[0];
        replyBuf[1] = 0x0;

	OCR1A=rq->wValue.bytes[0];
	eeprom_write_byte(0,OCR1A);
	return 2;
    }
    else if (rq->bRequest == 1) {
	replyBuf[0] = OCR1A;
        replyBuf[1] = 0x0;
	return 2;
    }
    return 0;
}



// *************
int main(void)
// *************
{
uint8_t u8NN;


//MAX543_INITDIR();



//DDRB |= LED1_BLINK;	     //Bit 0 von PORTC als Ausgang


wdt_reset();   //WATCHDOG!
wdt_enable(5); //500mS Totmannknopf


uart_init( UART_BAUD_SELECT_DOUBLE_SPEED( UART_BAUD_RATE, F_CPU) );
ResetRxBuff();

//TickCounter Starten
TCCR2B = (1 << CS22) | (1 << CS21);	//Vorteiler //256 einschalten
TIMSK2 = (1 << TOIE2);	//Interrrupt aktivieren

sei();	//Global Interrupt Freischalten

uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p(  PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 

u8NN = 0;
for(;;)  //ENDLESS
	{
	sei();
	wdt_reset();	//WATCHDOG!
	
	// Auslagerung wegen zu langer Interruptdauer
	if( gu8Status & STATUS_ORDER_EVENT)
		{
		CheckOrder( gcaRxStr );//gcaRxStr = accumulated str
		ResetRxBuff();
		gu8Status &= ~STATUS_ORDER_EVENT;
		};
		
	if( gu8Status & STATUS_TICK_EVENT )
		{
		gu8Status &= ~STATUS_TICK_EVENT;
		//PORTB ^= LED1_BLINK;	// ab jetzt langsame ~1Hz Action				
		};
//Toggle_Bit(1);
	};
}; // main

