
#include <avr/sfr_defs.h>
#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <math.h>
#include <avr/pgmspace.h> // <--#include <progmem.h>


#include "main.h"
#include "debug.h"
#include "max7219.h"
#include "Sparkfun_8x7_Font.h"
#include "SparkFun_8x7_Matrix.h"

//Teile in zwei 4Bit SEGMENTE
#define SF_MTX8x_DDRX_LOW	DDRD
#define SF_MTX8x_DDRX_HIGH	DDRC

//Nutze PORT 
#define SF_MTX8x_PORTX_LOW	PORTC
#define SF_MTX8x_PORTX_HIGH	PORTC

#define SF_MTX8x_BIT_OFFSET_LOW		2 / Einfach wegen PortNutzung
#define SF_MTX8x_BIT_OFFSET_HIGH	2

#define SF_MTX8x7_LOW_MASK	0x0F
#define SF_MTX8x7_HIGH_MASK	0xF0

#define MTX8x7_DDRX_CLEAR_LOW() (SF_MTX8x_DDRX_LOW &= ~(SF_MTX8x7_LOW_MASK << SF_MTX8x_BIT_OFFSET_LOW))
#define MTX8x7_DDRX_CLEAR_HIGH() SF_MTX8x_DDRX_HIGH &= ~(SF_MTX8x7_LOW_MASK << SF_MTX8x_BIT_OFFSET_LOW))

#define MTX8x7_PORTX_CLEAR_LOW()	(SF_MTX8x_PORTX_LOW &= ~(SF_MTX8x7_LOW_MASK << SF_MTX8x_BIT_OFFSET_LOW))
#define MTX8x7_PORTX_CLEAR_HIGH()	(SF_MTX8x_DDRX_HIGH &= ~(SF_MTX8x7_LOW_MASK << SF_MTX8x_BIT_OFFSET_LOW))

/* We need to create a global instance so that the ISR knows what to talk to */
SparkFun_LED_8x7 Plex


ISR( TIMER0_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein


};



/**
 * @brief Define static member for the location of the LEDs
 */
 //charlieLed SparkFun_LED_8x7::charlie_leds_[]
const charlie_leds_[] = {
                            {0,1}, {0,2}, {0,3}, {0,4}, {0,5}, {0,6}, {0,7},   
                            {1,0}, {1,2}, {1,3}, {1,4}, {1,5}, {1,6}, {1,7},
                            {2,0}, {2,1}, {2,3}, {2,4}, {2,5}, {2,6}, {2,7},
                            {3,0}, {3,1}, {3,2}, {3,4}, {3,5}, {3,6}, {3,7},
                            {4,0}, {4,1}, {4,2}, {4,3}, {4,5}, {4,6}, {4,7},
                            {5,0}, {5,1}, {5,2}, {5,3}, {5,4}, {5,6}, {5,7},
                            {6,0}, {6,1}, {6,2}, {6,3}, {6,4}, {6,5}, {6,7},
                            {7,0}, {7,1}, {7,2}, {7,3}, {7,4}, {7,5}, {7,6}
                            };

/**
 * @brief Constructor - Instantiates LED array object
 */
SparkFun_LED_8x7()
{
    /* Initialize members */
    scrolling_ = 0;
    shift_count_ = 0;
    shift_delay_ = 200; // Arbitrary long wait before scrolling
    scroll_index_ = 0;
    scroll_len_ = 0;

}


/**
 * @brief Returns the byte at the specified location from the font PROGMEM
 *
 * @param[in] idx the index for the character
 * @param[in] offset number of bytes off from the beginning of the character
 * @return byte at the specified location
 */
unsigned char SparkFun_LED_8x7::getPGMFontByte(int idx, int offset /* = 0 */)
{
    return pgm_read_byte(pgm_read_word(&char_table[idx]) + offset);
}

/**
 * @brief Swaps the given bytes
 *
 * @param[in, out] a first byte (becomes b)
 * @param[in, out] b second byte (becomes a)
 */
void SparkFun_LED_8x7::swap(uint8_t &a, uint8_t &b) 
{
    uint8_t t = a;
    a = b;
    b = t;
}


