


//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
 /*
`*/
#define HARDWARE	"Sparkfunk LEdMatrix 8x7"
#define SOFTWARE	"Sparkfunk LEdMatrix 8x7"
#define DATUM		"23.03.2018 12:00"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <math.h>
#include <avr/pgmspace.h> // <--#include <progmem.h>

#include "main.h"
#include "uart.h"
#include "Befehle.h"
#include "debug.h"
#include "max7219.h"
#include "SparkFun_8x7_Matrix.h"
#include "MixedPortByte.h"

/*
****** SOFTWARE SWITCHES  ********
 // #define SERVO_USED	
 // #define SERVO_USED
 // #define ONEBCD_USED
 // #define INT0_EVENT_USED
*/

// GLOBALE VARIABLEN 
volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint8_t gu8Status;

volatile uint8_t gu8StateMach;
volatile uint8_t gu8Modus;

PGM_P gpmcaPattern;
uint8_t gu8Parser=0;  // *( Prser + nn )
uint8_t gu8PatternSize; // Achtung eine 0 muss im Feld sein
const char MCA_STARTREK[] PROGMEM = {0x81,0x42,0x24,0x18,0x24,0x42,0};


/*
// Interrupt Section
// ********************
ISR( INT0_vect )
// ********************
{
EIMSK &= ~(1 << INT0); // Interrupt Freischalten
gu8Modus |= STATUS_INT0_EVENT;
};
*/

// Interrupt Section
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
volatile static uint32_t u32MerkeT;
volatile static uint32_t u32MerkeT2;
volatile static uint32_t u32MerkeT_BCD;
//volatile static uint32_t u32MerkeT_Motor;

//hochzhlen ? 244*/Sekunde
if( ( (gu32_Ticks++) - u32MerkeT) > TICK_2000MS )
	{
	u32MerkeT = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_TICK_EVENT;
	};
	
UART_TXRX_Check();  //langsam, aber sehen ob was kommt am UART	
// !! 244*/ Sekunde	
};


#define RAMPENSTEIGUNG 2




// *************
int main(void)
// *************
{
uint8_t u8NN;
MixedPortByteInit();

MAX7219_Init();
MAX7219_Clear ();
//DDRB |= LED1_BLINK;

wdt_reset();   //WATCHDOG!
wdt_enable(5); //500mS Totmannknopf


uart_init( UART_BAUD_SELECT_DOUBLE_SPEED( UART_BAUD_RATE, F_CPU) );
ResetRxBuff();

//TickCounter Starten
TCCR2B = (1 << CS22) | (1 << CS21);	//Vorteiler //256 einschalten
TIMSK2 = (1 << TOIE2);	//Interrrupt aktivieren

sei();	//Global Interrupt Freischalten

uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p(  PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 

gpmcaPattern = MCA_STARTREK;
gu8Parser=0;
gu8PatternSize = strlen_P( MCA_STARTREK );

u8NN = 0;
for(;;)  //ENDLESS
	{
	wdt_reset();	//WATCHDOG!
	
	// Auslagerung wegen zu langer Interruptdauer
	if( gu8Status & STATUS_ORDER_EVENT)
		{
		CheckOrder( gcaRxStr );//gcaRxStr = accumulated str
		ResetRxBuff();
		gu8Status &= ~STATUS_ORDER_EVENT;
		};
		
	if( gu8Status & STATUS_TICK_EVENT )
		{
		gu8Status &= ~STATUS_TICK_EVENT;
		MAX7219_Clear();
		MAX7219_Write( 1, pgm_read_byte_near( (PGM_P)(gpmcaPattern + ((gu8Parser++) % gu8PatternSize) )));
		MAX7219_Write( 2, gu8Modus  );
	//PORTB ^= LED1_BLINK;	// ab jetzt langsame ~1Hz Action				
		};
//Toggle_Bit(1);
	};
}; // main

