
//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
#define SOFTWARE	"DEebounce PB0 mit LED an PB5"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"13.03.2018 18:00"
#define AUTOR		"=/\= Christof Ermer =/\= "
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr/io.h>
#include <util/delay.h>

#include "main.h"
#include "debug.h"


// DEFINE SECTION --> main.h
#define PRESSED_DETECT		0x01
#define RELEASED			0x02
#define RELEASE_DETECT		0x04
#define RELEASED_SONDER_JOB	0x08
#define SWITCH_VALID		0x10
#define SWITCH_INTERRUPT_EVENT	0x80
//gu8SWFlag

#define READ_SWITCH_MAX   20
#define RELEASE_COUNT_MIN 200

#define LED_DDRX 	DDRD
#define LED_PORT 	PORTD


#define TASTER_DDRX			DDRB
#define TASTER_PINX			PINB
#define TASTER_PULLUP_PORTX	PORTB

#define TASTER_BIT 		(1<< PORTB0) //oder mehrere Bits
#define INTERNE_LED_BIT	(1<< PORTB5)

#define INT_LED_ON()	(PORTB |= INTERNE_LED_BIT)
#define INT_LED_OFF()	(PORTB &= ~INTERNE_LED_BIT)


// GLOBAL VARS
uint8_t gu8SWFlag;
	
//MAKRO
#define  TASTER_INIT_INPUT()	(TASTER_DDRX &= ~TASTER_BIT) 
#define  TASTER_PULLUP()		(TASTER_PULLUP_PORTX |= TASTER_BIT)
#define  TASTER_GEDRUECKT()		(!(TASTER_PINX & TASTER_BIT)) //TRUE wenn gedrckt



// ********************************
void Debounce( void ) // momentan nur EINE Taste
// Reihenfolge ist NICHT EGAL, erst Released Check, dann...
// ********************************
{  
static uint8_t u8Cnt;  // static = Wert bleibt beim nchsten Durchlauf erahlten

// ---------
if( TASTER_GEDRUECKT() && (gu8SWFlag & RELEASED) )	// UND && vergleich
	{	
	gu8SWFlag &= ~( RELEASED | RELEASE_DETECT );
	gu8SWFlag |= PRESSED_DETECT;
	u8Cnt=0;
	};

// ---------
// Schau mal, ob das Schon bekannt ist, wenn nein, dann setze Flag
if( !TASTER_GEDRUECKT() 	&&  
	!(gu8SWFlag & RELEASED)	&&
	!(gu8SWFlag & RELEASE_DETECT)
) 
	{
	u8Cnt=0;
	gu8SWFlag |= RELEASE_DETECT;
	};
	

// ---------
if( !TASTER_GEDRUECKT() && (gu8SWFlag & RELEASE_DETECT) )  
	{
	if( u8Cnt < RELEASE_COUNT_MIN )
		{ 
		u8Cnt++;
		_delay_ms(1);
		}
	else
		{
	// LASSE VALID FLAG,aber lsche-->
		gu8SWFlag &= ~( PRESSED_DETECT | RELEASE_DETECT); // mehrere Lschen
		gu8SWFlag |= RELEASED | RELEASED_SONDER_JOB;		//mehrere setzen
		};
	}

//NUr wenn zuvor Release checked
// ---------
// Jetzt Zhle gltige Switch-tests
if( TASTER_GEDRUECKT() && (gu8SWFlag & PRESSED_DETECT) )
	{
	if( u8Cnt < READ_SWITCH_MAX )
		{
		u8Cnt++;
		_delay_ms(1);
Toggle_Bit( 2 );	
		}	
	else
		{
		// Jetzt scheint es X.mal der selbe Wert gewesen zu sein 
		gu8SWFlag &= ~PRESSED_DETECT;
		gu8SWFlag |= SWITCH_VALID;  	// TASTE ERKANNT !!!!!
Toggle_Bit( 3 );
		};
	}
};


// ***************
int main(void)
// ***************
{
LED_DDRX = 0xFF;

TASTER_INIT_INPUT();	//DDRB &= ~(1<< PORTB0)	--> DDRB &= ~TASTER;
TASTER_PULLUP();		//PORTB |= (1<< PORTB0)	

DDRB |= INTERNE_LED_BIT; // OUT

gu8SWFlag = RELEASED;	// Init
while( 1 )
	{	
	Debounce();
	if( gu8SWFlag & SWITCH_VALID )	//FLAG  DA
		{
		INT_LED_ON();
		_delay_ms(1000);
		gu8SWFlag &= ~SWITCH_VALID; //FLAG  CLEAR
		};		
		
	if( gu8SWFlag &  RELEASED_SONDER_JOB )	//FLAG  DA
		{
		gu8SWFlag &= ~RELEASED_SONDER_JOB; //FLAG  CLEAR
		_delay_ms(100);
		INT_LED_OFF();
		};
		
	LED_PORT = gu8SWFlag; // Monitore die Flags an extern LEDleiste
	};
	
};	//main
// *** MAIN END ***
