
//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
#define SOFTWARE	"DEebounce PB0 mit LED an PB5"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"13.03.2018 18:00"
#define AUTOR		"=/\= Christof Ermer =/\= "
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr/io.h>
#include <util/delay.h>
#include <math.h>

#include "main.h"
#include "debug.h"
#include "Debounce1Sw.h"

// GLOBAL VARS

//********************************
uint16_t ADC_10Bit(uint8_t u8Chan)
//********************************
/*
Externe 5V REF--Dreaht von AVCC zu 5V+
// PRESCALER 3,6864 / 32 = 115200 50-200Khz gewnscht
*/
{
DDRC &= ~_BV(u8Chan);  //Portx Channel Bit Input  
PORTC &= ~_BV(u8Chan); //Pullup abschalten
//Activate ADC with Prescaler 16 --> 16Mhz/128 = 125 khz
ADMUX = (1<< REFS0) | u8Chan;    //AVCC und AREF mit C an GND
ADCSRA = _BV(ADEN) | _BV(ADPS2) | _BV(ADPS1) |_BV(ADPS0);  
//ADMUX = u8Chan | (1<<REFS0);
ADCSRA |= _BV(ADSC);  //Start conversion 
while( ADCSRA & _BV(ADSC) ) // wait until conversion completed
	{
	//~150S
	//wdt_reset();	//WATCHDOG!
	};	   
return ADC;// get converted value  16 BIT
};



// ***************
int main(void)
// ***************
{
LED_DDRX = 0xFF;

TASTER_INIT_INPUT();	//DDRB &= ~(1<< PORTB0)	--> DDRB &= ~TASTER;
TASTER_PULLUP();		//PORTB |= (1<< PORTB0)	

DDRB |= INTERNE_LED_BIT; // OUT

gu8SWFlag = RELEASED;	// Init

while( 1 )
	{	
	//Debounce();
	LED_PORT =  (1<< ( (uint8_t)round( ( ADC_10Bit(0) / 128.0)) ) );
	
/*
	if( gu8SWFlag & SWITCH_VALID )	//FLAG  DA
		{
		INT_LED_ON();
		_delay_ms(1000);
		gu8SWFlag &= ~SWITCH_VALID; //FLAG  CLEAR
		};		
		
	if( gu8SWFlag &  RELEASED_SONDER_JOB )	//FLAG  DA
		{
		gu8SWFlag &= ~RELEASED_SONDER_JOB; //FLAG  CLEAR
		_delay_ms(100);
		INT_LED_OFF();
		};
		
	LED_PORT = gu8SWFlag; // Monitore die Flags an extern LEDleiste
*/	
	};
};	//main
// *** MAIN END ***
