
#include <avr/sfr_defs.h>
#include <avr/io.h>
#include <util/delay.h>

#include "debug.h"
#include "Debounce1Sw.h"

//Globals
uint8_t gu8SWFlag;
	
// ********************************
void Debounce( void ) // momentan nur EINE Taste
// Reihenfolge ist NICHT EGAL, erst Released Check, dann...
// ********************************
{  
static uint8_t u8Cnt;  // static = Wert bleibt beim nchsten Durchlauf erahlten



TASTER_INIT_INPUT();	//DDRB &= ~(1<< PORTB0)	--> DDRB &= ~TASTER;
TASTER_PULLUP();		//PORTB |= (1<< PORTB0)	

// ---------
if( TASTER_GEDRUECKT() && (gu8SWFlag & RELEASED) )	// UND && vergleich
	{	
	gu8SWFlag &= ~( RELEASED | RELEASE_DETECT );
	gu8SWFlag |= PRESSED_DETECT;
	u8Cnt=0;
	};

// ---------
// Schau mal, ob das Schon bekannt ist, wenn nein, dann setze Flag
if( !TASTER_GEDRUECKT() 	&&  
	!(gu8SWFlag & RELEASED)	&&
	!(gu8SWFlag & RELEASE_DETECT)
) 
	{
	u8Cnt=0;
	gu8SWFlag |= RELEASE_DETECT;
	};
	

// ---------
if( !TASTER_GEDRUECKT() && (gu8SWFlag & RELEASE_DETECT) )  
	{
	if( u8Cnt < RELEASE_COUNT_MIN )
		{ 
		u8Cnt++;
		_delay_ms(1);
		}
	else
		{
	// LASSE VALID FLAG,aber lsche-->
		gu8SWFlag &= ~( PRESSED_DETECT | RELEASE_DETECT); // mehrere Lschen
		gu8SWFlag |= RELEASED | RELEASED_SONDER_JOB;		//mehrere setzen
		};
	}

//NUr wenn zuvor Release checked
// ---------
// Jetzt Zhle gltige Switch-tests
if( TASTER_GEDRUECKT() && (gu8SWFlag & PRESSED_DETECT) )
	{
	if( u8Cnt < READ_SWITCH_MAX )
		{
		u8Cnt++;
		_delay_ms(1);
Toggle_Bit( 2 );	
		}	
	else
		{
		// Jetzt scheint es X.mal der selbe Wert gewesen zu sein 
		gu8SWFlag &= ~PRESSED_DETECT;
		gu8SWFlag |= SWITCH_VALID;  	// TASTE ERKANNT !!!!!
Toggle_Bit( 3 );
		};
	}
};



	
/*
	if( gu8SWFlag & SWITCH_VALID )	//FLAG  DA
		{
		INT_LED_ON();
		_delay_ms(1000);
		gu8SWFlag &= ~SWITCH_VALID; //FLAG  CLEAR
		};		
		
	if( gu8SWFlag &  RELEASED_SONDER_JOB )	//FLAG  DA
		{
		gu8SWFlag &= ~RELEASED_SONDER_JOB; //FLAG  CLEAR
		_delay_ms(100);
		INT_LED_OFF();
		};
		
	LED_PORT = gu8SWFlag; // Monitore die Flags an extern LEDleiste
*/	