
//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
/*
file:///C:/WinAVR-20100110/doc/avr-libc/avr-libc-user-manual/modules.html*/

#define SOFTWARE	"DEebounce PB0 mit LED an PB5"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"13.03.2018 18:00"
#define AUTOR		"=/\= Christof Ermer =/\= "
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <math.h>
#include <stdlib.h>

#include "main.h"
#include "debug.h"
#include "Debounce1Sw.h"

// GLOBAL VARS


#define TICK_EVENT		0x01
#define HANSWURST		0x02
//gu8Status;



volatile uint32_t gu32_Tick;
volatile uint8_t gu8Status;

// ************************
ISR( TIMER0_OVF_vect )
// ************************
{
volatile static uint32_t u32_Jetzt=0;

gu32_Tick++;
Toggle_Bit(1);

if( (gu32_Tick - u32_Jetzt) > 244 ) // ~Timeroverflow~
	{
	u32_Jetzt = gu32_Tick;
	gu8Status |= TICK_EVENT;	
	};	
};


//********************************
uint16_t ADC_10Bit(uint8_t u8Chan)
//********************************
/*
Externe 5V REF--Dreaht von AVCC zu 5V+
// PRESCALER 3,6864 / 32 = 115200 50-200Khz gewnscht
*/
{
DDRC &= ~_BV(u8Chan);  //Portx Channel Bit Input  
PORTC &= ~_BV(u8Chan); //Pullup abschalten
//Activate ADC with Prescaler 16 --> 16Mhz/128 = 125 khz
ADMUX = (1<< REFS0) | u8Chan;    //AVCC und AREF mit C an GND
ADCSRA = _BV(ADEN) | _BV(ADPS2) | _BV(ADPS1) |_BV(ADPS0);  
//ADMUX = u8Chan | (1<<REFS0);
ADCSRA |= _BV(ADSC);  //Start conversion 
while( ADCSRA & _BV(ADSC) ) // wait until conversion completed
	{
	//~150S
	//wdt_reset();	//WATCHDOG!
	};	   
return ADC;// get converted value  16 BIT
};



// ***************
int main(void)
// ***************
{
uint8_t u8NN=0;
LED_DDRX = 0xFF;
DDRB |= INTERNE_LED_BIT; // OUT



// Timer0 Tick Init
//#include <avr/interrupt.h>   nicht vergessen
cli();	//clear int
TCNT0=0;
TIMSK0 |= (1<<TOIE0); // Interrupt Scharf
TCCR0B = (1<<CS02);	// /256
sei();	// global Enable Int

// Timer2 OC2A Init CTC MODUS = 
TCNT2=0;
OCR2A = 127;
DDRB |= _BV(PORTB3);	//OUT OC2A  PIN-11 Arduino
TCCR2A = _BV(COM2A0)  | _BV(WGM21);  // TOGGLE OC2A, CTC
//TIMSK2 |= (1<<TOIE0);
//TCCR2B = (1<<CS22) | (1<<CS21) | (1<<CS20);  // CLOCK= /1204
TCCR2B = (1<<CS22) | (1<<CS21) ;  // CLOCK= /256

//gu8SWFlag = RELEASED;	// Init
OCR2A = 0xFF;

while( 1 )
	{	
	//Debounce();
	
	if( gu8Status & TICK_EVENT )
		{
		gu8Status &= ~TICK_EVENT;
		//Hier ist Platz fr jede Sekunde Jobs
		LED_PORT = (1<< u8NN);
		u8NN++;
		u8NN %= 8;
		}
	
	//LED_PORT =  (1<< ( (uint8_t)round( ( ADC_10Bit(0) / 128.0)) ) );
	//OCR2A = (uint8_t)round( ( ADC_10Bit(0) / 4 ) );
	//OCR2A = 30 + ((random() % 256) - 30);
	//_delay_ms( (uint8_t)round( ADC_10Bit(0) ));
	OCR2A--;
	_delay_ms( 50 );
	};
};	//main
// *** MAIN END ***
