

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
#define SOFTWARE	"DEebounce PB0 mit LED an PB5"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"13.03.2018 18:00"
#define AUTOR		"=/\= Christof Ermer =/\= "
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr/io.h>
#include <util/delay.h>
#include <math.h>

#include "main.h"
#include "debug.h"
#include "Debounce1Sw.h"
#include "avr/interrupt.h"

// GLOBAL VARS




#define  BUZ11_Enable_DDRX DDRC
#define  BUZ11_Enable_PORTX PORTC
#define  BUZ11_Enable_PIN	4
#define  BUZ11_Enable_BIT (1<< BUZ11_Enable_PIN)
//#define  INIT_BUZ11
#define  BUZ11_ENABLE_SERVO() (BUZ11_Enable_PORTX |= BUZ11_Enable_BIT)
#define  BUZ11_DISABLE_SERVO() (BUZ11_Enable_PORTX &=~ BUZ11_Enable_BIT)






volatile uint32_t gu32_Tick;
volatile uint8_t gu8Status;

// ************************
ISR( TIMER0_OVF_vect)
// ************************
{
volatile static uint32_t u32_Jetzt;

gu32_Tick++;
Toggle_Bit(1);

if( (gu32_Tick - u32_Jetzt) > 244 ) //timer overflow
	{
	u32_Jetzt = gu32_Tick;
	gu8Status |= TICK_EVENT;	
	};	
};



//********************************
uint16_t ADC_10Bit(uint8_t u8Chan)
//********************************
/*
Externe 5V REF--Dreaht von AVCC zu 5V+
// PRESCALER 3,6864 / 32 = 115200 50-200Khz gewnscht
*/
{
DDRC &= ~_BV(u8Chan);								//Portx Channel Bit Input  
PORTC &= ~_BV(u8Chan); 								//Pullup abschalten
														//Activate ADC with Prescaler 16 --> 16Mhz/128 = 125 khz
ADMUX = (1<< REFS0) | u8Chan;    						//AVCC und AREF mit C an GND
ADCSRA = _BV(ADEN) | _BV(ADPS2) | _BV(ADPS1) |_BV(ADPS0);  
														//ADMUX = u8Chan | (1<<REFS0);
ADCSRA |= _BV(ADSC);  									//Start conversion 
while( ADCSRA & _BV(ADSC) ) 							// wait until conversion completed
	{
	//~150S
	//wdt_reset();	//WATCHDOG!
	};	   
return ADC;// get converted value  16 BIT
};

// PIN auf Ausgang 
#define	GABLELLICHTSCHRANKEN_DDRX	DDRD   
#define	GABLELLICHTSCHRANKEN_PINX	PIND
#define GABLELLICHTSCHRANKEN_BIT	(1<<PORTD2)
#define GABLELLICHTSCHRANKEN_INIT() 	(GABLELLICHTSCHRANKEN_DDRX &= ~GABLELLICHTSCHRANKEN_BIT)
#define GABELLSCHRANKE_READ_TRUE()	(GABLELLICHTSCHRANKEN_PINX & GABLELLICHTSCHRANKEN_BIT)

// ***************
int main(void)
// ***************
{
//uint8_t u8NN=0;
uint32_t u32ZeitMerker = 0;

GABLELLICHTSCHRANKEN_INIT();

//LED_DDRX = 0xFF;
DDRB |= INTERNE_LED_BIT; // OUT
DDRB &= ~_BV(2);


// Timer0 Tick Init

cli(); 								// clear interupt
TCNT0=0;
TIMSK0 |= (1<<TOIE0); 				// interupt scharf
TCCR0B = (1<<CS02);				// /256
sei();								 //global anable interupt


TCNT2=0;
OCR2A = 25;
DDRB |= _BV(PORTB3);
TCCR2A = _BV(COM2A1) | _BV(WGM21) | _BV(WGM20); // falling OC2A, CTC

TCCR2B = (1<<CS22) | (1<<CS21)| (1<<CS20);

BUZ11_ENABLE_SERVO();

while( 1 )
	{
	if(gu8Status & TICK_EVENT)
		{
		gu8Status &=~ TICK_EVENT;
		}
			
	if( !(gu8Status & STATUS_HYSTERESE)	 )
		{
		if( GABELLSCHRANKE_READ_TRUE() )
			{		
			OCR2A = 15;
			u32ZeitMerker = gu32_Tick;
			gu8Status |= STATUS_HYSTERESE;
			}
		else
			{
			OCR2A = 28;	
			
			u32ZeitMerker = gu32_Tick;
			
			gu8Status |= STATUS_HYSTERESE;		
			//OCR2A = 15 + (uint8_t)round( ( ADC_10Bit(0) / 60 ));
			};
		};
		
	if(	(gu8Status & STATUS_HYSTERESE) && 
		( (gu32_Tick - u32ZeitMerker) > HYTERESE_TIME) //1/2 Sec
	)
		{
		gu8Status &= ~STATUS_HYSTERESE;
		};
	};
};	//main
// *** MAIN END ***

