

#ifndef SWUART_HEADER	//1. Headereinbindung
#define SWUART_HEADER

#define SWUART_USED
//http://www.rn-wissen.de/index.php/Software-UART_mit_avr-gcc


/*
ZBIt = F_CPU / BAUDRATE 16MhZ/9600 = 1666,66666666666..
*/

//Extern Globals
//extern uint8_t gau8MultiPWM[ PWM_CHANNELS ]; // 7 PWMs
/*

F_CPU
ist die Taktrate des AVR und muss irgendwo definiert worden sein, entweder ber ein 
#define oder per Kommandozeile mit -DF_CPU=...
#define BAUDRATE ...
Die Baudrate, gleich fr Receiver und Transmitter.
#define SUART_TXD
Wenn dieses Define gesetzt ist, wird der Transmitter aktiv bzw. die fr ihn notwendigen Code-Sequenzen werden eingeblendet.
#define SUART_RXD
Wenn dieses Define gesetzt ist, wird der Receiver aktiv bzw. die fr ihn notwendigen Code-Sequenzen werden eingeblendet.
*/

// #define BAUDRATE 38400
//#define BAUDRATE 38400
//MIDI Baudrate 31250 Bit/s 
#define BAUDRATE 31250		//midistandard
//#define BAUDRATE 38400
#define SUART_TXD
#define SUART_RXD

/// Folgende Zeile einkommentieren, falls FIFO verwendet werden soll 
//#include "fifo.h"
#ifdef  _FIFO_H_
	#include "fifo.h" 	
#endif

extern void SWuart_init(void);

#ifdef SUART_TXD
    extern void SWuart_putc (const char);
#endif // SUART_RXD

#ifdef SUART_RXD
    extern int SWuart_getc_wait (void);
    extern int SWuart_getc_nowait(void);
#endif // SUART_RXD



#define nop() __asm volatile ("nop")

#ifdef SUART_TXD
    #define SUART_TXD_PORT PORTB
    #define SUART_TXD_DDR  DDRB
    #define SUART_TXD_BIT  PB1
    static volatile uint16_t outframe;
#endif // SUART_TXD 

#ifdef SUART_RXD
    #define SUART_RXD_PORT PORTB
    #define SUART_RXD_PIN  PINB
    #define SUART_RXD_DDR  DDRB
    #define SUART_RXD_BIT  PB0
    static volatile uint16_t inframe;
    static volatile uint8_t inbits, received;

    #ifdef _FIFO_H_
        #define INBUF_SIZE 4
        static uint8_t inbuf[INBUF_SIZE];
        fifo_t infifo;
    #else // _FIFO_H_ 
        static volatile uint8_t indata;
    #endif // _FIFO_H_ 
#endif // SUART_RXD 

#endif //SWUART_HEADER