
#ifndef MAIN_HEADER  //Prevents multiple includes
#define MAIN_HEADER

#define USE_ERROR_FLAG			0 
#define USE_TOGGLE_FLAG			0

//TickCounter  MUSS SEIN !!!
#define TIMER0_USED				0 		
#define TIMER1_USED				0
#define TIMER2_TICK_USED		1	
#define UART_USE_ENABLED		1
#define EEPROM_USED				0
#define ADC_USED_ENABLED		1

#define TEXT_SERVICE_USE_ENABLED		1
//sfr |= _BV(bit)  ---  sfr &= ~(_BV(bit))
#define UART_ERRORMSG					0
//#define MSG							0
#define LCD_4Bit_Module_USED			0
#define LCD_MSG_USED					0 //Never  forget, PB3 ist mit 10K pulldown zu schalten
//Timeout von LCD wird simuliert
#define COM_TX_ENABLED					0
#define LCD_MENUE_USED					0
#define ENDORDER_CMD_ECHO_ENABLED		1
//TWI


/*
REGISTER = WERT;
sbi (PORTB, 2);   // Setzt Pin 2 auf Logisch 1 (EIN)
cbi (PORTB, 2);   // Setzt Pin 2 auf Logisch 0 (AUS)
PIN
X = PORT // inp (PINB)--> bPortD = inp (PIND);

Wobei es hier sehr wichtig ist, als Portadresse nicht etwa das
Portregister PORTx zu verwenden,sondern die Porteingangsadresse PINx.
Dies ist ein oft gemachter Fehler!
*/


/*
Jedes Port hat drei Register
DDxN
PORTXn
PINxn
IF PortX ist INPUT an PORTX= set to 1, PullUP IS ENABLED
*/


/*
Text verbraucht Speicher
Statt Pointer geht evtl auch diese Form
TESTEN !!!
const uint8_t MCA_CRLFSTR[] __attribute__ ((section (".text"))) = {13,10,0};
//Versus diesr Form, die Speicher verbraucht !! ROCKEN ALS EINFGESTRING DEFINIERT.
#define MCA_CRLFSTR (const char){CR,LF,0}  //redefined 

*/


//For compatibility for OLDER Compilers
//#define	sbi(sfr, bit)   (_SFR_BYTE(sfr) |= _BV(bit))
//#define	cbi(sfr, bit)   (_SFR_BYTE(sfr) &= ~_BV(bit))


#define STRMAX 64
#define NUMMAX 64
#define RX_STRMAX 64

#define DELIMITER		','
#define DELIMITERSTR	","
#define COMAMNDSIZEMAX  10 //0Zehn Commands

#define BYTE_LIMIT 255				//uint8_t					uint8_t
#define WORD_LIMIT 65535			//unsigned short				uint16_t
#define DWORD_LIMIT 4294967295UL	//unsigned long					uint32_t
//Wird benutz um T2 berlauf zu berwachen !!
#define BEFORE_DWORD_LIMIT 429496000UL	//unsigned long					uint32_t
#define QWORD_LIMIT 18446744073709551615ULL	//unsigned long long 	uint64_t

#define LOW_NIPPEL_MASK		0x0F
#define HIGH_NIPPEL_MASK	0xF0

//TYPEN DEKLARATION


//Tastatur
typedef struct
	{
	uint32_t ulEventTime;	//offen/geschlossen Zeit des Schalter fr Debounce
	uint8_t ucKeyStat[3];		//Status, Fr das Speichern des Status der Taste
	uint8_t ucKey;			// Tasten
	}KEYSTRUCT_TYPE;

typedef struct
	{
	char ucaCmd[COMAMNDSIZEMAX +1];
	uint8_t ucCmdID;
	float fCmdVal_1;
	float fCmdVal_2;
//uint8_t ucCmdID;
	}COMMAND_TYPE;


typedef struct
	{	
	uint8_t ucaInEEPROMStr[12];	//Fr strlen( EEPROMVALID) = 11 + 1
	}EEPROM_STR_TYPE;	

/*
typedef struct
	{	
	uint8_t ucaInEEPROMStr[12];	//Fr strlen( EEPROMVALID) = 11 + 1
	}EEPROM_STR_TYPE;	
*/

//TTT
// Hardwareassignment
//#define           11059200L Hz   
//#define           3686400L Hz   
//F_CPU  in makefile !!!
//CPU = 16000000L
#define SYSCLK			F_CPU
//#define UART_BAUD_RATE	9600
//#define UART_BAUD_RATE	19200
#define UART_BAUD_RATE	57600
//#define UART_BAUD_RATE	115200


#define DISABLE_ALL_PULLUP_MAC	(SFIOR |= _BV(PUD));
#define ENABLE_ALLUP_SCL_MAC	(SFIOR &= ~(_BV(PUD)));

//DELAY
//#define TCCR2_CLK_64	0x04	//675 = 0,0014814814814814814814814814814815   mS Interrrupt
// 1 TICK = 1.4814814814814814814814814814815 ms 
//NUR UNGEFHR
//BERECHUNG Xtime(ms) / 1.48....
#define TIMEOUT_1_5MS 	1 
#define TIMEOUT_2_9MS 	2
#define TIMEOUT_4_4MS 	3
#define TIMEOUT_10_3MS 	7
#define TIMEOUT_100_7MS	68
#define TIMEOUT_500_7MS	338
#define TIMEOUT_1S 		675		//!!  uint16_t
#define TIMEOUT_5S 		3375	//!!  uint16_t

//REGISTER
#define TCCR0_FAST_PWM	0x48	//Mode 3
#define TCCR0_OC0_MODE	0x20	//Clear ON compare Match
#define TCCR0_OC0_DISCONNECT_MODE	0x00
#define TCCR0_CLK_STOP	0x00	
#define TCCR0_CLK_0		0x01	
#define TCCR0_CLK_8		0x02	
#define TCCR0_CLK_64	0x03	
#define TCCR0_CLK_256	0x04	
#define TCCR0_CLK_1024	0x05	
#define TCCR0_EXT_CLK_FALL_T0	0x06	
#define TCCR0_EXT_CLK_RISE_T0	0x07	

#define TCCR2_WGM_NORMAL		0x00
#define TCCR2_CTC_MODE			0x08 //0000 1000
#define TCCR2_COM_NORMALPORT	0x00
#define TCCR2_CLK_STOP			0x00
#define TCCR2_FASTPWM			0x48	//Mode 3
#define TCCR2_CS_BIST			0x0x	//Mode 3
#define TCCR2_CLK_1024	0x07	
#define TCCR2_CLK_256	0x06	
#define TCCR2_CLK_128	0x05
#define TCCR2_CLK_64	0x04	//
#define TCCR2_CLK_32	0x03
#define TCCR2_CLK_8		0x02	//	1/F = 
#define TCCR2_CLK_0		0x01	
#define TCCR2_CLK_STOP	0x00	
//TIMER2 WIRD BERECHNET /z.B:OverFLow SYSCLK /  256 / TCCR2_CLK_64 =  OVL/Sec
// 1/OVLS = 1/ = 
//-----> 

//#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CTC_MODE				0x08	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1		0x01	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_8		0x02	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_64		0x03	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_256		0x04	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1024	0x05	//Clock Select Bits



//INTERUPT CTRL REG //NICHT mit MCUCSR verwechseln !
#define MCUCR_LOWLEVEL_INT0		0x00	
#define MCUCR_ANYCHANGE_INT0	0x01 //=_BV(ISC01) 	
#define MCUCR_FALLING_EDGE_INT0	0x02	
#define MCUCR_RISING_EDGE_INT0	0x03

#define MCUCR_LOWLEVEL_INT1		0x00	
#define MCUCR_ANYCHANGE_INT1	0x04 //=_BV(ISC10) 	
#define MCUCR_FALLING_EDGE_INT1	0x08	
#define MCUCR_RISING_EDGE_INT1	0x0C

#define GATE_ANYCHANGE_INT1_MODE_MAC	(MCUCR |= MCUCR_ANYCHANGE_INT1)


//Global Interrrupt CTRL REG
#define GICR_INT0_ON_MAC	(GICR |= _BV(INT0)) //_BV(INT0)
#define GICR_INT0_OFF_MAC	(GICR &= ~(_BV(INT0)))
#define GICR_INT1_ON_MAC	(GICR |= _BV(INT1))
#define GICR_INT1_OFF_MAC	(GICR &= ~(_BV(INT1)))
#define GICR_INT_0u1_OFF_MAC	(GICR &= 0x3F)  //SIEHE DATENBLATT


#define RCO_B_INT_ON_MAC	GICR_INT0_ON_MAC 
#define RCO_B_INT_OFF_MAC	GICR_INT0_OFF_MAC
#define GATE_INT1_ON_MAC	GICR_INT1_ON_MAC
#define GATE_INT1_OFF_MAC	GICR_INT1_OFF_MAC


#define OVERFLOW_CNT_ON_INT0_MAC	RCO_B_INT_ON_MAC
#define OVERFLOW_CNT_OFF_INT0_MAC	RCO_B_INT_OFF_MAC

#define GATE_ALL_EVENT_ON_INT1_MAC	GATE_INT1_ON_MAC
#define GATE_ALL_EVENT_OFF_INT1_MAC	GATE_INT1_OFF_MAC

//GIFR  I_FLAG
#define GIFR_INTF0_SET_MAC	(GIFR |= _BV(INTF0)) //_BV(INT0)
#define GIFR_INTF0_CLR_MAC	(GIFR &= ~(_BV(INTF0)))
#define GIFR_INTF1_CLR_MAC	(GIFR |= _BV(INTF1))
#define GIFR_INTF1_SET_MAC	(GIFR &= ~(_BV(INTF1)))
#define GIFR_INTF_0u1_CLR_MAC	(GIFR &= 0x3F) //Siehe Datenblatt = letzten beiden Bits



//PORTB 
#define MOSI_I         3//BIT3
#define MISO_0         4//BIT4
#define SCK_I          5//BIT5

//#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1		0x01	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_8		0x02	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_64		0x03	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_256		0x04	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1024	0x05	//Clock Select Bits



//EEPROM
#define EEPROM_SECTION  __attribute__ ((section (".eeprom")))
#define IEEPROM_SIZE	512	//Interne EEPROM
#define EE_DUMMYLOAD 0x5AA5 //unwahrsch. wert 0101 1010 1010 0101
//If using 8 block by 512 max = 64 Byte/block
//#define IEEPROM_SECTIONSIZE	64   //by 8 Section




//INTERRUPT
#define INTx_INPORT	PIND
//#define INT1_MASK	0x08  //PD3
//#define INT0_MASK	0x04  //PD2
#define INT0_PIN_NR	PD2
#define INT1_PIN_NR	PD3


//PORTB
#define TWI_DIRREG		DDRC
#define TWI_OUT_PORT	PORTC
#define TWI_IN_PORT		PINC
#define TWI_SDA			PC4		//PC4	OUT
#define TWI_SCL			PC5		//PC5	IN

/*
#define Clr_TWI_SDA_MAC	 	TWI_OUT_PORT &= ~PC_SDA_BIT;	 
#define Set_TWI_SDA_MAC	 	TWI_OUT_PORT |= PC_SDA_BIT;	 
#define TWI_SCL_IS_HIGH		(TWI_IN_PORT & PC_SCL_BIT )
#define TWI_SCL_IS_LOW		(!(TWI_IN_PORT & PC_SCL_BIT))
*/


//PORTD TX/RX ERST MAL FR  FLAGS
#define PD0_RX_BIT	0x01	//PIN2
#define PD1_TX_BIT	0x02	//PIN3


//========================================================================

//TIMERS
//TIMER2  = is 61 miliseconds Timer ~approx.
// 16MhZ / 1024 / 256  = 61,03515625 Hz
// T= 1/f = 0.016384 ms / Interrupt
#define TIMER2_INT_FREQUENCY	61.03515625
#define TIMER2_INTPERIODE		0.016384 //1/TIMER2_INT_FREQUENCY BY EVERY OVERFLOW = 1 Second!
#define ONE_SECOND_TICKS		61	//1/ TIMER2_INTPERIODE
#define LONG_10DELAY_TICKS		610	//1/ TIMER2_INTPERIODE
#define SM_AFTERSTOPDELAY_TICKS	2	//~16ms 1=TIMER2_INTPERIODE,

//PORT_ASSIGMNEMTS
//Bit usage, use by sbi, cbi

//MACRO
// HARWARE MAKROS

//#define LED_GRUEN_ON_MAC	sbi(LED_PORT, LED_GRUEN);
//#define LED_GRUEN_OFF_MAC	cbi(LED_PORT, LED_GRUEN);

//-----------------------

//MASKENBITS


//FLAG MEANING USED VOR INTERRUPT
/*
BIT 7
BIT 6
BIT 5
BIT 4
BIT 3
BIT 2
BIT 1
BIT 0 = INT0 = 0x01
*/

#define WDTO_2S   7 //WatchDog
//SOFTWARE USED DEFINES


#define ASC_CR	13
#define ASC_LF	10

//COMMAND
#define STXSIZEMAX	3
#define ETX			ASC_CR

#define DELIMITER		','
#define DELIMITERSTR	","


//delay.h 8-bit count, 
//EIn Aufruf von _delay_loop_2 = 4 Cyclen lan = 0.00000025 = 0.250 NanoSecunden
/*
#define OneCycletime	0.0000000625  // 1 / F_CPU
#define DELAYCYCLE_3	0.0000001875 //375ns fr eine Pause //CPU_CYCLE_TIME *3 fr 8 Bit
#define DELAYCYCLE_4 	0.00000025 //500ns fr eine!!! Pause= _delay_loop_2(1); //CPU_CYCLE_TIME *4 fr 16Bit
// 500nS sind 8 * OneCycletime
//1ms= 16000 * OneCycletime
#define DELAY_1NS		4	//4 * 4 Cycles
#define DELAY_1000NS	4000 //()
*/

//244,140625

#define PULS_PER_10TEL_SEc_T2	2440
#define PULS_PER_SEcONDTick_T2	244
#define PULS_500MS_Tick_T2		122
#define PULS_250MS_TICK_T2		61
#define PULS_100MS_TICK_T2		24
#define PULS_50MS_TICK_T2		12


#define FLOAT_OVERFLOW_2_19 0x7FFFFUL //= liegt VOR berlauf !!! 524287	Um es Vor!! DEM BERLAUF ABZUFANGEN
#define HALF_FLOAT_OVERFLOW 0x3FFFFUL

#define BITS_PER_BYTE	8
#define PORTB_BYTEs		8
#define PORTC_BYTEs		8
#define PORTD_BYTEs		8



//CHECK PUD = PULLUPDISSABLE in SFIOR 
//PORTA  	//1=OUT 6BIT
//1=OUT
#define PORTA_DDRX_OUTMASK		0X00	//3 und 4 auf INPUT
#define PORTA_PRESET_PULLMASK	0x00

//CHECK PUD = PULLUPDISSABLE in SFIOR 
//PORT B  	//1=OUT 6BIT
//1=OUT
#define PORTB_DDRX_OUTMASK		0X01 			
#define PORTB_PRESET_PULLMASK	0X00	

//PORT C 	TWI //1=OUT  0 = IN  6BIT
//STARTWERTE
#define PORTC_DDRX_OUTMASK		0xFF
#define PORTC_PRESET_PULLMASK	0X00

//PORT D	//1=OUT 8 BIT 
//TX/RX & zusatzhardware
#define PORTD_DDRX_OUTMASK		0b11100010	 			
//#define PORTD_PRESET_PULLMASK	0b00011100	//mit PullUp
#define PORTD_PRESET_PULLMASK	0b00000000	//Ohne Pullup


//TEST AND DEBUG SECTION
// PORTD 7.BIT
//#define USE_TOGGLE_FLAG					0	//ToggleTEST_BIT(xx);
#if  USE_TOGGLE_FLAG == 1 	
	#define TESTBIT_DIRREG		DDRB
	#define TESTBIT_PORT		PORTB
	#define TESTBIT_BIT			0x01
	#define TESTBIT_INVERT_BIT	0xFE
	#define INIT_TESTBIT_REG_MAC	(TESTBIT_DIRREG |= TESTBIT_BIT);
	#define SET_TESTBIT_MAC			(TESTBIT_PORT |= TESTBIT_BIT);
	#define CLR_TESTBIT_MAC			(TESTBIT_PORT &= TESTBIT_INVERT_BIT);
	extern void ToggleTEST_BIT(uint8_t ucCnt);
#endif


//TIMER
#define TIMSK_TOIE0_FLAG	0x01
#define TIMSK_OCIE0_FLAG	0x02
#define TIMSK_TOIE1_FLAG	0x04
#define TIMSK_OCIE1B_FLAG	0x08
#define TIMSK_OCIE1A_FLAG	0x10
#define TIMSK_TICIE1_FLAG	0x20
#define TIMSK_TOIE2_FLAG	0x40
#define TIMSK_OCIE2_FLAG	0x80

#define TIMSK_T0_CLR_ALL_MASK 0b11111100
#define TIMSK_T1_CLR_ALL_MASK 0b11000011
#define TIMSK_T2_CLR_ALL_MASK 0b00111111


#define TIFR_TOV0_TIMER_OVERFLOW_FLAG	0x01
#define TIFR_OCF0_OUT_PCOMPARE_FLAG		0x02
#define TIFR_TOV1_TIMER_OVERFLOW_FLAG	0x04
#define TIFR_OCF1A_OUTP_COMPARE_A_FLAG	0x10
#define TIFR_OCF1B_OUTP_COMPARE_B_FLAG	0x08
#define TIFR_TOV2_TIMER_OVERFLOW_FLAG	0x40
#define TIFR_OCF2_OUTP_COMPARE_FLAG		0x80

//INTERRUPT MODE
//#define MCUCR_INT0_LOWLEVEL_CLRMASK	0xFC
#define MCUCR_INT0_LOWLEVEL		0x00
#define MCUCR_INT0_ANY_CHANGE	0x01
#define MCUCR_INT0_FALLING_EDGE	0x02
#define MCUCR_INT0_RISING_EDGE	0x03
#define MCUCR_INT0_CLEAR_MASK	0xFC

//#define MCUCR_INT1_LOWLEVEL_CLRMASK	0xF3
#define MCUCR_INT1_LOWLEVEL		0x00
#define MCUCR_INT1_ANY_CHANGE	0x04
#define MCUCR_INT1_FALLING_EDGE	0x08	//_BV(ISC11)
#define MCUCR_INT1_RISING_EDGE	0x0C
#define MCUCR_INT1_CLEAR_MASK	0xF3
 

#define GICR_INT1_FLAG	0x80
#define GICR_INT0_FLAG	0x40
#define GICR_INT2_FLAG	0x20

#define GIFR_INTF1_FLAG	0x80
#define GIFR_INTF0_FLAG	0x40
#define GIFR_INTF2_FLAG	0x20

//TIMERS
#define TCCR0_FAST_PWM	0x48	//Mode 3
#define TCCR0_OC0_MODE	0x20	//Clear ON compare Match
#define TCCR0_OC0_DISCONNECT_MODE	0x00
#define TCCR0_CLK_1024	0x05	//~61,035 PWM
#define TCCR0_CLK_256	0x04	//244,14Hz PWM
#define TCCR0_CLK_64	0x03	//976,56Hz PWM
#define TCCR0_CLK_8		0x02	//7812 Hz PWM
#define TCCR0_CLK_0		0x01	//62500 PWM
#define TCCR0_CLK_STOP_MASK	0xF8	

#define TCCR2_WGM_NORMAL	0x00
#define TCCR2_CTC_MODE		0x08 //0000 1000
#define TCCR2_COM_NORMALPORT	0x00
#define TCCR2_FASTPWM		0x48	//Mode 3
#define TCCR2_CS_BIST		0x0x	//Mode 3
#define TCCR2_CLK_0			0x01
#define TCCR2_CLK_8			0x02
#define TCCR2_CLK_32		0x03
#define TCCR2_CLK_64		0x04
#define TCCR2_CLK_128		0x05
#define TCCR2_CLK_256		0x06
#define TCCR2_CLK_1024		0x07
#define TCCR2_CLK_STOP_MASK	0xF8

//TCCR1A

#define TCCR1A_CTC_MODE			0x00	//WGM11 WGM10  = 0
#define TCCR1A_FAST_PWM_ICR1	0x02 //WGM11
#define TCCR1A_FAST_PWM_OCR1A	0x03 //WGM11 WGM10 

//#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CTC_MODE				0x08	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1		0x01	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_8		0x02	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_64		0x03	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_256		0x04	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1024	0x05	//Clock Select Bits
#define TCCR1B_CLK_STOP_MASK		0xF8

#define TC1_USED_CLOCKS_PER_SEC		15625	//16^6 / 1024


//ADC //AT8
#define ADMUX_MUX0	0
#define ADMUX_MUX1	1
#define ADMUX_MUX2	2
#define ADMUX_MUX3	3
#define ADMUX_MUX4	4
#define ADMUX_MUX5	5
#define ADMUX_MUX_1_23V	0xE0
#define ADMUX_MUX_GND	0xF0
#define ADMUX_ADLAR	0x20
#define ADMUX_REFS0	0x40
#define ADMUX_REFS1	0x80
#define ADC_MUX_MASK	0x0F

//PRESCALER
#define ADCSRA_ADPS0	0x01
#define ADCSRA_ADPS1	0x02
#define ADCSRA_ADPS2	0x04
#define ADCSRA_ADIE		0x08
#define ADCSRA_ADIF		0x10		//INTERRRUPT FLAG
#define ADCSRA_ADFR		0x20	//FREE RUNNNG SEL
#define ADCSRA_ADSC		0x40	//START  //while (ADCSRA & _BV(ADSC) ) 
#define ADCSRA_ADEN		0x80	//Enable

#define  ADCSRA_PRESCALER_2		0x01
#define  ADCSRA_PRESCALER_4		0x02
#define  ADCSRA_PRESCALER_8		0x03
#define  ADCSRA_PRESCALER_16	0x04
#define  ADCSRA_PRESCALER_32	0x05
#define  ADCSRA_PRESCALER_64	0x06
#define  ADCSRA_PRESCALER_128	0x07
//WERT IN ADCW


//Status
#define KEYSTAT_PRESSED				0x01	//	pressed
#define KEYSTAT_PRESSED_DETECT		0x02
#define KEYSTAT_RELEASED			0x04
#define KEYSTAT_RELEASE_DETECT		0x08
#define KEYSTAT_INTEVENT			0x10	// one int
#define KEYSTAT_NO_KEYTRIGGER_EVENT	0x20	// Key erkannt,nachtasten erst nach Abarbeitung
#define KEYSTAT_VALID				0x80	// Now Start Action
//gstKey.ucKey


//EVALUIERUNGBOARD...

#define BOARD_HW_PORT_OUT	PORTD
#define BOARD_HW_PORT_IN	PIND

#define RX_BIT		PD0
#define TX_BIT		PD1
#define KEY1_BIT	PD2
#define KEY2_BIT	PD3
#define KEY3_BIT	PD4
#define LED1_BIT	PD5
#define LED2_BIT	PD6
#define SUMMER_BIT		PD7

#define I2C_CLOCK_BIT	PC0
#define I2C_DATA_BIT	PC1

#define KEY1_MASKE	0x04
#define KEY2_MASKE	0x08
#define KEY3_MASKE	0x10
#define LED1_MASKE	0x20
#define LED2_MASKE	0x40
#define SUMMER_MASKE	0x80



#define FUNTESBYTEA5  0xA500000000ULL	 //A = 1010     5 = 0101
#define FUNTESBYTE5A  0x5A00000000ULL	 //A = 1010     5 = 0101
#define FUENFTES_BYTE_MASK 0xFF00000000ULL   // 11111111------- 32 Bit nur NULLen ----
                           

#define MODE_TEST_KLAVIERTON 0x10	
#define MODE_TEST_SHIFTBORD	0x20
//uint8_t gu8ProgMode;



#ifdef UART_USE_ENABLED
extern void LongToNumStr(int32_t lVal);
extern void FloatToNumStr(double fVal);
extern void PrintCR(void);
extern void PrintStrCR(const char* pStr);
extern void Print_PStrCR(PGM_P pmStr);
extern void PrintLongCR(int32_t lVal);
extern void PrintFloatCR(double fVal);
#endif


//___________________________________________________
#endif  //MAIN_HEADER
