

//stand 23.10.2014  ERMER Christof

/*

NEUE BEFEHLE

formen:
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("STV")))

uart_puts_p( PSTR("ASURO\r") );

ERROR DETECT
bersprechen der TX DIODE auf IR_RX gefunden.
immer wieder RX Lschen


*/

/* 
BEFEHLE 
22.087.2014

Befelsform:
Kommando,u16Val-1,u16Val-2<13>  <13>  //<13> = CR = \r = 13
Bsp:
Motor,123,34<CR>
Ping<CR>
GetSW>CR>

Diese Datei dient zum einfachen Auffinden und Zufgen der Befehle.
Deshalb wurden die Bfehle in diese Datei ausgelagert.
*/

#include <stdint.h> 
#include <ctype.h>
#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

//#include <stdio.h>
#include <math.h>
#include <stdlib.h>
//#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>
#include <avr\wdt.h>
#include <util\delay.h>


//#include "avr_register.h"	//with Hardware assigns
#include "main.h"			//with Hardware assigns
#include "uart.h"
//#include "TxtFunc.h"
#include "myasuro.h"
#include "statmach.h"
#include "Befehle.h"
#include "debug.h"


/*
EIne Besonderheit des AVR Mikrocontrollers ist die unterschiedliche Bheandklung von Zeichen=Strings, 
die entweder im Flash-Speicher  Stehen, und somit von dort gelesen werden,
oder die im RAM stehen,
Es gibt also also C-Funktionen die Strings behandeln doppelt.
einmal mit "Programm Memmory Handling" und
quasi Normal: ohen besonderem, dafr RAM-Verbrauchende Stringbehandlung.

Hier liegt musterglitig ein "const cahr" string , d
der aber im "Programm-Flash" abgespeichert wird und nicht im "RAM".
*/

//	\r return
//	\r\n return, line fedd
//	\r\n \t  return, line fedd, tabulator


// GLOBALE VARIABLEN
//CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };
char gcaStr[STRMAX + 1]; //+1 for the 0
char gcaNumStr[NUMMAX + 1]; //+1 for the 0

#ifdef UART_USE_ENABLED
char* gpcRxPars;
char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
#endif
COMMAND_TYPE gsCmd; // Hier liegen die Befehle und Parameter ab

//Rckgabevariablen
unsigned int u16Value;		// UINT 16 Bit

//CONSTANTEN
const char MCA_TRENNLINIE[] PROGMEM = "-------------\r";
const char MCA_PORTX[] PROGMEM	= " x=B,C,D\r";
//const char MCA_STOP[] PROGMEM	= "Stop mit: SS\r\n";



// *********************************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// *********************************
{ //Input von der Seriellen Schnittstlle, in der Form:  "BEFEHL,WERT" BSP: "SFR,1000"
//========================
TokensRXStr(pcStrOrder);   //TxtFunc.h
//========================"MS
ResetRxBuff();
/* 
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PING") )  )
	{	
	uart_puts_p( PSTR("PONG\r") );	
	return;
	};
*/
// IR hat gelegentlich bersprechen.... tx-->rx
//deshalb die Delays und die Buffferlscherei


#ifdef PWM_ON_D11_USED
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("rr")))
	{
	Drehe((uint8_t)gsCmd.i16CmdVal_1,(int16_t)gsCmd.i16CmdVal_2);
	};
#endif

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("IRD"))) //PWM IR Detector
	{
	gu8PWM_D11_Val = (uint8_t)gsCmd.i16CmdVal_1;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("IRS"))) //IR_SENIBILITY_DEFAULT
	{
	gu16IR_Sensibility = (uint16_t)gsCmd.i16CmdVal_1;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SMS"))) //SET MotorSpeed only
	{
	gu8PWM_Left = gsCmd.i16CmdVal_1;
	gu8PWM_Right  = gsCmd.i16CmdVal_2;
	return;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SS"))) //SET Statemachine
	{
	gu8StateMachine = gsCmd.i16CmdVal_1;
	return;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GSS"))) //SET Statemachine
	{
	uart_puts( itoa( gu8StateMachine, gcaStr, 10 ) );	//RAM STRING
	uart_putc( 13 ); //CR
	};



if( (!strcasecmp_P( gsCmd.ucaCmd, PSTR("MD"))) 	|| //MotorDir
(!strcasecmp_P( gsCmd.ucaCmd, PSTR("MotorDir")))	//MotorDir
)
	{
	gsCmd.i16CmdVal_1 = TransposeASUROVals( gsCmd.i16CmdVal_1 );
	gsCmd.i16CmdVal_2 = TransposeASUROVals( gsCmd.i16CmdVal_2 );	
	MotorDir(gsCmd.i16CmdVal_1, gsCmd.i16CmdVal_2);
	return;
	};
	
if( (!strcasecmp_P( gsCmd.ucaCmd, PSTR("MS"))) 	||  //MotorSpeed
	(!strcasecmp_P( gsCmd.ucaCmd, PSTR("MotorSpeed"))) //MotorSpeed
)
	{
	gu8PWM_Left = gsCmd.i16CmdVal_1;
	gu8PWM_Right = gsCmd.i16CmdVal_2;
	MotorSpeed(gu8PWM_Left, gu8PWM_Right);
	return;
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("OEO"))) //ODO TX ON OFF
	{
	gu8TxFlag |= TX_ODO_EVENT_ON;
	return;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("OEF")))//ODO TX ON OFF
	{
	gu8TxFlag &= ~TX_ODO_EVENT_ON;
	return;
	};	

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("OO"))) //ODO TX ON OFF
	{
	gu8TxFlag |= ODO_TRAFFIC_ON;
	return;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("OF")))//ODO TX ON OFF
	{
	gu8TxFlag &= ~ODO_TRAFFIC_ON;
	return;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SO"))) //SWITCH TX ON OFF
	{
	gu8TxFlag |= SW_TRAFFIC_ON;
	return;
	};

#ifdef DEBUG_TX_TRAFFIC_USED

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("DO"))) //0,1 SWITCH EVENT TRAFFIC
	{
	gu8TxFlag |= DEBUG_TRAFFIC_ON;
	};	


if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("DF"))) //0,1 SWITCH EVENT TRAFFIC
	{
	gu8TxFlag &= ~DEBUG_TRAFFIC_ON;
	};	
#endif
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SET"))) //0,1 SWITCH EVENT TRAFFIC
	{
	if(gsCmd.i16CmdVal_1)
		{
		gu8TxFlag |=  SW_EVENT_TRAFFIC_ON;
		}
	else
		{
		gu8TxFlag &= ~SW_EVENT_TRAFFIC_ON;
		};
	};	

#ifdef METALL_SUCHE_USED	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("MM"))) //0,1 SWITCH EVENT TRAFFIC
	{
	if(gsCmd.i16CmdVal_1)
		{
		gu8TxFlag |= METALL_SUCHE_TRAFFIC_ON ;
		}
	else
		{
		gu8TxFlag &= ~METALL_SUCHE_TRAFFIC_ON ;
		};
	};	
#endif
 
#ifdef GEIGERZAEHLER_USED
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GG"))) //0,1 SWITCH EVENT TRAFFIC
	{
	if(gsCmd.i16CmdVal_1)
		{
		gu8TxFlag |= GEIGERZAEHLER_TRAFFIC_ON ;
		}
	else
		{
		gu8TxFlag &=~GEIGERZAEHLER_TRAFFIC_ON ;
		};
	};	
#endif


if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SF"))) //SWITCH TX ON OFF
	{
	gu8TxFlag &= ~SW_TRAFFIC_ON;
	return;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("IO"))) //IR SENS TX ON OFF
	{
	gu8TxFlag |= IR_TRAFFIC_ON;
	return;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("IF"))) //IR SENS TX ON OFF
	{
	gu8TxFlag &= ~IR_TRAFFIC_ON;
	return;
	};
	

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("DEVICE")))  // GET
	{
	uart_puts_p( PSTR("ASURO\r") );
	return;
	};
	
// hier werden einfach die myasuro Funktionen gespiegelt.
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("Init")))
	{
	Init();
	return;
	};

#if STATUSLED_USED
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("StatusLED")))
	{
	StatusLED(gsCmd.i16CmdVal_1);
	return;
	};
#endif
	
#ifdef FRONTLED_USED
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("FrontLED")))
	{
	FrontLED(gsCmd.i16CmdVal_1);
	return;
	};
#endif

#ifdef BACKLED_USED
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("BackLED")))
	{
	BackLED(gsCmd.i16CmdVal_1, gsCmd.i16CmdVal_2);
	return;
	};
#endif

#ifdef 	LINEDATA_USED
//void LineData(unsigned int *data);
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("LineData")))
	{
	LineData( &gau16LIneData ); // Adresspointer
	uart_puts( itoa(gau16LIneData[0] , gcaStr, 10 ) );
	uart_putc(',' );	
	uart_puts( itoa(gau16LIneData[1] , gcaStr, 10 ) );
	uart_putc( 13 );
	return;
	};
#endif

#ifdef  ODOMETRIEDATA
/*
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("OdometrieData"))) //OdometrieData//@ 1.tes aufrufen
	{
//	OdometrieData( gau16OdoData ); // Array bergabe	 ORGINAL AUSGESCHALTET
	MyOdometrieData( gau16OdoData ); // Array bergabe		
	return;
	};


if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("ODO"))) //OdometrieData//@ 1.tes aufrufen
	{
//	OdometrieData( gau16OdoData ); // Array bergabe	 ORGINAL AUSGESCHALTET
	MyOdometrieData( gau16OdoData ); // Array bergabe		
	return;
	};
*/

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GODO")))	//Set DDRB
	{
	uart_puts( itoa(gi16ODO_LR_Cnt, gcaStr, 10 ) );
	uart_putc( 13 );
	return;
	};	

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GODOLR"))) //get Links DANN
	{
	MyOdometrieData( gau16OdoData ); // Array bergabe
	uart_puts( itoa( gau16OdoData[0] , gcaStr, 10 ) );
	uart_putc(',' );	
	uart_puts( itoa( gau16OdoData[1] , gcaStr, 10 ) );
	uart_putc( 13 );	
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GetODOL"))) //get Links DANN
	{
	uart_puts( itoa( gau16OdoData[0] , gcaStr, 10 ) );
	uart_putc( 13 );	
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GetODOR"))) //Get Rechts
	{
	uart_puts( itoa( gau16OdoData[1] , gcaStr, 10 ) );
	uart_putc( 13 );	
	return;
	};
#endif

#ifdef POLL_SWITCH_USED
if( (!strcasecmp_P( gsCmd.ucaCmd, PSTR(" GPS"))) || //get PollSwitch
	(!strcasecmp_P( gsCmd.ucaCmd, PSTR("PollSwitch")))
)
	{
	uart_puts( itoa( PollSwitch(), gcaStr, 10 ) );
	uart_putc( 13 );
	return;
	};
#endif

/*
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("StartSwitch")))
	{
	StartSwitch();
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("StopSwitch")))
	{
	StopSwitch();
	return;
	};
*/
/*
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("Sleep")))
	{
	int iNN = gsCmd.i16CmdVal_1;
	do
	{
	_delay_ms(1);
	wdt_reset();	//WATCHDOG!
	}while(iNN--);
	return;
	};
*/

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("TT"))) //TICKS anzeigen
	{
	uart_puts( ultoa( gu32_Ticks, gcaStr, 10 ) );
	uart_putc( 13 ); //CR
	return;
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GSM")))	//get State Machine
	{
	uart_puts( itoa( gu8StateMachine, gcaStr, 10 ) );	//RAM STRING
	uart_putc( 13 ); //CR
	return;	
	};
/*
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GOCR1A"))) // GET
	{
	uart_puts( itoa( OCR1A, gcaStr, 10 ) );
	uart_putc( 13 );
	return;
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GOCR1B")))  // GET
	{	
	uart_puts( itoa( OCR1B, gcaStr, 10 ) );
	uart_putc( 13 );
	return;
	};
*/

#ifdef ADC_USED_ENABLED	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("ADC") )  )    //ADC,0..3
	{	
	uart_puts_p( PSTR("ADC=") );
	uart_puts( itoa( ADC_AT8_10Bit( ADC_5V_AN_C | gsCmd.i16CmdVal_1), gcaStr, 10 ) );
	uart_putc( 13 );
	return;
	};
#endif

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("BLT")))
	{
	gu32BlinkTime = gsCmd.i16CmdVal_1;
	return;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("STV")))
	{
	gu8TasterVal = gsCmd.i16CmdVal_1;
	return;
	};

/*	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("IROFF")))
	{
	gu8ProgModeFlag |= IR_40KHZ_OFF;
	TCCR2 = (1 << WGM21) | (1 << CS20); // OFF Toggle OC2
	DDRB |= (1<<PB3);  // PORT OUT
	PORTB &=  ~(1<<PB3); // OFF = IR OUT
	return;
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("IRON")))
	{
	TCCR2 = (1 << WGM21) | (1 << COM20) | (1 << CS20);
	gu8ProgModeFlag &= ~STOP_UART_RX;
	return;
	};*/
	
#ifdef DIRECT_PORTUSE_ENABLED
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SDDRB")))	//Set DDRB
	{
	lkjkjlasd
	DDRB = gsCmd.i16CmdVal_1 & 0xFF;
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SDDRC")))	//Set DDRC
	{
	DDRC = gsCmd.i16CmdVal_1 & 0xFF;
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SDDRD")))	//Set DDRD
	{
	DDRD = (gsCmd.i16CmdVal_1 & 0xFF) & 0xFE ; //Rx
	return;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GPB")))	//GET PORTB
	{
	uart_puts( ltoa(PINB, gcaStr, 10 ) );
	uart_putc( 13 );
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GPC")))	//GET PORTC
	{
	uart_puts( ltoa(PINC, gcaStr, 10 ) );
	uart_putc( 13 );
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GPD")))	//GET PORTC
	{
	uart_puts( ltoa(PIND, gcaStr, 10 ) );
	uart_putc( 13 );
	return;
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SPB")))	//SET PORTB
	{
	PORTB = gsCmd.i16CmdVal_1 & 0xFF;
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SPC")))	//SET PORTB
	{
	PORTC = gsCmd.i16CmdVal_1 & 0xFF;
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SPD")))	//SET PORTB
	{
	PORTD = (PORTD & 0x03) | (gsCmd.i16CmdVal_1 & 0xFC);// erhalte RX/TX	
	return;
	};	
#endif //DIRECT_PORTUSE_ENABLED
	
#ifdef MENUE_USED	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("??") )  ) //Menue
	{	
//DisableRx();	
	uart_puts_p( MCA_TRENNLINIE );	

	uart_puts_p( PSTR("Asuro Menue\r") );	 //\r\n
	uart_puts_p( MCA_TRENNLINIE );	
	uart_puts_p( PSTR("?? = Dieses Menue\r") );	
	uart_puts_p( PSTR("IRD") );  //PWM IR Detector
	uart_puts_p( PSTR("GODO\r") );
	uart_puts_p( PSTR("Device\r") );
	uart_puts_p( PSTR("SDDRx SetDirRegx") );	 // Set DDRX
	uart_puts_p( MCA_PORTX );
	uart_puts_p( PSTR("GPx x= GetPortx") );	// get Portx
	uart_puts_p( MCA_PORTX );
	uart_puts_p( PSTR("SPx SetPortx") );		//Set PortX
	uart_puts_p( MCA_PORTX );
	uart_puts_p( PSTR("Init\r") );				
	uart_puts_p( PSTR("StatusLED,x\r") );	
	uart_puts_p( PSTR("FrontLED,x\r") );	
	uart_puts_p( PSTR("BackLED,l,r\r") );	
	uart_puts_p( PSTR("MD+=MotorDir,l,r\r") );	
	uart_puts_p( PSTR("MS+MotorSpeed,l,r\r") );	
	uart_puts_p( PSTR("ret=LineData\r") );	
	uart_puts_p( PSTR("@1.->OD+OdometrieData\r") );	
	uart_puts_p( PSTR("retL,retR => GetODO\r") );	
	uart_puts_p( PSTR("retL=GetODOL\r") );	
	uart_puts_p( PSTR("OO OF\r") );	//ODO TX ON OFF
	uart_puts_p( PSTR("SO SF\r") );	//SWITCH TX ON OFF
	uart_puts_p( PSTR("IO IF\r") );	 //IR SENS TX ON OFF
	uart_puts_p( PSTR("retR=GetODOR\r") );	
	uart_puts_p( PSTR("retR=GetODOR\r") );	

	uart_puts_p( PSTR("ret=PollSwitch\r") );	
/*	uart_puts_p( PSTR("StartSwitch\r") );	
	ResetRxBuff();
	_delay_ms(20);
	uart_puts_p( PSTR("StopSwitch\r") );	
	ResetRxBuff();
	_delay_ms(20);
*/
	uart_puts_p( PSTR("Sleep\r") );
	uart_puts_p( PSTR("GETSWITCH\r") );
	uart_puts_p( PSTR("BLT\r") );
	uart_puts_p( PSTR("IROFF\r") );
	uart_puts_p( PSTR("IRON\r") );
	uart_puts_p( PSTR("SBAUD\r\n") ); // BlinkTime TICK_500MS 141	
//EnableTxRx();
	ResetRxBuff();
	return;
	};
#endif

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SBAUD")))
	{
	uart_init( UART_BAUD_SELECT((uint32_t)gsCmd.i16CmdVal_1, F_CPU) );
	ResetRxBuff();
	return;
	};
/*
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("")))
	{
	};
*/	
 }; // ORDER



// **************************
void ClearUartRxBuff(void) // neu, 26.08.2014
// **************************
{
while( !(uart_getc() & UART_NO_DATA) ) {wdt_reset();};
};

// **************************
void ResetRxBuff(void)
// **************************
{
ClearUartRxBuff();
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};

/*
// *******************************************************************
void DisableRx(void)
// *******************************************************************
{
gu8ProgModeFlag |= STOP_UART_RX;
UART0_CONTROL &= ~((1<<RXEN) | (1<<RXCIE));
ResetRxBuff();
};

// *******************************************************************
void EnableTxRx(void)
// *******************************************************************
{
ResetRxBuff();
UART0_CONTROL = (1<<RXCIE)|(1<<RXEN)|(1<<TXEN);
gu8ProgModeFlag &= ~STOP_UART_RX; 
};
*/


#ifdef UART_USE_ENABLED
//Funktionen Definition
// *******************************************************************
void UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#ifdef USE_ERROR_MSG
	if ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		uart_puts_p(  PSTR("UartErr\r") );
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 10: // LF raus=nix machen
				{				
				break;
				};	           				
			case 13: // order!! from Terminal
				{				
				CheckOrder( gcaRxStr );//gcaRxStr = accumulated str
				//EnableTxRx();
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x00FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}
	else  // To much data Rx, than clear simple all
		{
		//overflow of RX clears all
		ResetRxBuff();
		};
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};

#endif // UART_USE_ENABLED


/* Diese Funktion zerlegt den Befehls-String in einzelne Module */
// *******************************************************************
void TokensRXStr(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
//uint16_t uiCnt =0;
const char caDelimiter[]=",";
char * pStrTok; // fr strtok_r
char * pcCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*

if( (pStrTok = strtok_r( pcStrOrder, caDelimiter , &pcCh)) != NULL) // Trenne 1.Token in Command
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}
else
	{
	*gsCmd.ucaCmd = 0;
	};
gsCmd.ucaCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10

//fr 2 fVal Variablen nach dem Kommando
gsCmd.i16CmdVal_1 = 0;
gsCmd.i16CmdVal_2 = 0;
if( (pStrTok = strtok_r( NULL,  caDelimiter, &pcCh)) != NULL)
	{
	//gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	gsCmd.i16CmdVal_1 = atoi(pStrTok);
	};

if( (pStrTok = strtok_r( NULL,  caDelimiter, &pcCh)) != NULL)
	{
//	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	gsCmd.i16CmdVal_2 = atoi(pStrTok);
	};
};


// ***********************************************
// Jetzt nur fr Direction , maximale Kompatibilitt
int16_t TransposeASUROVals( int16_t i16Val )
// ***********************************************
{
if(i16Val < -1) //-2
	{
	return FREE;
	};

if(i16Val == 0)
	{
	return BREAK;
	};
	
if(i16Val == 1)
	{
	return FWD;
	};
if(i16Val == -1)
	{
	return RWD;
	};
return 0;
};

