
/*
Dies IST DAS MAX7219 rogramm
*/

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

#include <stdint.h>
#include <avr/sfr_defs.h>
#include <avr\io.h>

#include <stdlib.h>
#include <avr\interrupt.h>
#include <avr\wdt.h>
#include <util\delay.h>

#include "max7219.h"
#include "debug.h"

// GLOBALE VARIABLEN 
/*
D15 D14
X
D13 D12
X X
D11 D10 D9 D8
ADDRESS
D7 D6 D5 D4
X
D3 D2 D1 D0
MSB DATA LSB
*/


/*
Balkengrafik
date 0= aus
1..8
gu8MatrixCData = ~( 255U << data  );
MAX7219_Write(gsGeigerCnt.u8GeigerValParser + 1, gu8MatrixCData);
*/

// **********************
void MAX7219_Init(void)
// **********************
{
//INIT_MAX7219_DIR(); //MAKRO
MAX7219_DIN_DIRREG |= (1<< MAX7219_DIN);
MAX7219_LOAD_CS_DIRREG |= (1<< MAX7219_LOAD_CS);
MAX7219_CLK_DIRREG |= (1<< MAX7219_CLK);

MAX7219_Write(REG_SCAN_LIMIT, 7); // set up to scan all eight digits
MAX7219_Write(REG_DECODE, 0x00); // set to "no decode" for all digits
MAX7219_Write(REG_SHUTDOWN, 1); //ShutdownStop
MAX7219_Write(REG_DISPLAY_TEST, 0); //DisplayTestStop
MAX7219_SetBrightness(6); // INTENSITY_MAX 0x0F
MAX7219_Clear();
//MAX7219(
};



// **********************
void MAX7219_Clear (void)
// **********************
{
char i;
for (i=1; i < 9; i++)
	{
    MAX7219_Write(i, 0x00);	//+ 1 siehe Datenballt , turn all segments off
	};
};


// **********************
void MAX7219_SetBrightness (char brightness)
// **********************
{
  MAX7219_Write(REG_INTENSITY, (brightness & 0x0f) );           // set brightness
}

// ***************************************************
extern void MAX7219_Write( unsigned char u8Register, unsigned char u8Data)
// ***************************************************
{
unsigned int u16OutDat;
unsigned char u8NN = 15;

u16OutDat = u8Data;
u16OutDat |= ( ((unsigned int)(u8Register)) << 8);

CLR_MAX7219_LOAD_CS();
//CLR_MAX7219_CLK();
_delay_us(1);
do
	{
	if( u16OutDat & (1U << u8NN) )
		{
		SET_MAX7219_DIN();
		}
	else
		{
		CLR_MAX7219_DIN();
		};
	_delay_us(1);
	SET_MAX7219_CLK();
	_delay_us(1);
	CLR_MAX7219_CLK();		
	}while( u8NN--);
_delay_us(1);
SET_MAX7219_LOAD_CS();
};

