

// Modifikatetd by Christof Ermer thema MINT 23.10.2014
/*
 =/CE\=  
 Hystorie
meine zufgungen zur Speicherung der Daten 
--> gau16OdoData
Am Ende dieser Datei
nderungen tragen meist: //CE
*/

/*******************************************************************************
*
* File Name:   asuro.h
* Project  :   ASURO
*
*
* Ver.     Date         Author           Comments
* -------  ----------   --------------   ------------------------------
* 1.00	   14.08.2003   Jan Grewe		 build
* 2.00     14.10.2003   Jan Grewe        LEFT_VEL, RIGHT_VEL -> MotorSpeed(unsigned char left_speed, unsigned char right_speed);
*										 LeftRwd(),LeftFwd(),RightRwd(),RigthFwd() -> MotorDir(unsigned char left_dir, unsigned char right_dir);
*                                        GREEN_ON,GREEN_OFF,RED_ON,RED_OFF -> StatusLED(unsigned char color);
*                                        LED_RED_ON, LED_RED_OFF -> FrontLED(unsigned char color);
*                                        Blink(unsigned char left, unsigned char right) -> BackLED(unsigned char left, unsigned char right);
*                                        Alles in Funktionen gefasst => leichter verstndlich ?!?!
* 2.10     17.10.2003   Jan Grewe        new Timer funktion void Sleep(unsigned char time36kHz)  
*
*
* Copyright (c) 2003 DLR Robotics & Mechatronics
*****************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                                    *
 ***************************************************************************/

#ifndef ASURO_H
	#define ASURO_H

//CE
//Damit wird Software ab/dazu geschaltet

#ifdef CHRISTOF_FIRMWARE_USED
#define PWM_ON_D11_USED //gu8PWM_D11_Val trgt die PWMZeit fr Servos
// --> remeber IR_DISTANCE_USED in main.h
#endif

//#define FRONTLED_USED
//#define STATUSLED_USED
#define GREENLED_USED_ONLY
//#define REDLED_USED_ONLY

//#define BACKLED_USED

#define ODOMETRIEDATA_USED
//#define LINEDATA_USED
//#define ODOMETRIEDATA_USED_ORG_USED //Anstelle MyOdometrieData
//#define  POLL_SWITCH_USED	

#include <avr/io.h>
#include <avr\interrupt.h> 

#define ADC_USED_ENABLED


#define  FALSE	0
#define  TRUE	1

#define  OFF    0
#define  ON     1

#define GREEN	1
#define RED		2
#define YELLOW  3

//Christof Ermer
//Schalte die unntze UART behandlung weg..
// #ifdef ORGINAL_ASURO_FNCTION_ENABLED	
// oder gebe diese wieder frei 
// define ORGINAL_ASURO_FNCTION_ENABLED

/* Init function Processor will be initalized to work correctly */
extern  void Init(void);

/* Set Status LED (OFF,GREEN,RED,YELLOW)*/
/* example code set Status LED GREEN */
/* StatusLED(GREEN); */
extern  void StatusLED(unsigned char color);
/* function for front LED */
/* example code front LED On */
/* FrontLED(ON); */
extern  void FrontLED(unsigned char status);

/* function for Back LEDs */
/* example code right LED On left LED Off */
/* BackLED(OFF,ON); */
extern void BackLED(unsigned char left, unsigned char right);

/* Set motor direction (FWD,RWD,BREAK,FREE)*/
/* example code set Direction for right motor to rewind */
/* MotorDir(BREAK,RWD); */
extern  void MotorDir(unsigned char left_dir, unsigned char right_dir);

/* range for motor speed 0..255 */
/* example code set speed for left motor to 150 */
/* MotorSpeed(150,0); */
extern  void MotorSpeed(unsigned char left_speed, unsigned char right_speed);

/* function for serial communication */
//extern void SerWrite(unsigned char *data,unsigned char length);
/* timeout = 0 => bloking mode !!! */
//extern void SerRead(unsigned char *data, unsigned char length, unsigned int timeout);

/* function to read out line follow phototransistors (left,rigth) */
extern void LineData(unsigned int *data);

/* function to read out odometrie phototransistors (left,rigth) */
extern void OdometrieData(unsigned int *data);

/* function to read out switches */
extern unsigned char PollSwitch(void);

// for working with Interrupt
//extern void StartSwitch(void);
//extern void StopSwitch(void);

/* Sleep function using 36kHz counter */
//extern void Sleep(unsigned char timer36kHz);
/* ----------- END ------------ */

/* --------------- INTERNAL ------------- */


// ----------- ORG DEFINES ------------
#define GREEN_LED_ON()  (PORTB |= GREEN_LED)
#define GREEN_LED_OFF() (PORTB &= ~GREEN_LED)
#define RED_LED_ON()    (PORTD |=  RED_LED)
#define RED_LED_OFF()   (PORTD &= ~RED_LED)
//CE
//#define TOGGLE_RED_LED()   (PORTD ^= RED_LED)
#define TOGGLE_GREEN_LED()   (PORTB ^= GREEN_LED)


//@CE TAUSch  //verworfen 10.07.2014
//#define FWD		(1 << PB4) /* (1 << PD4) */
//ORG
#define FWD		((1 << PB5)) /* (1 << PD5) */
#define RWD		((1 << PB4)) /* (1 << PD4) */
#define BREAK	0x00
#define FREE	((1 << PB4) | (1 << PB5)) /* (1 << PD4) | (1 << PD5)*/

#define IRTX        (1 << PB3)
#define GREEN_LED   (1 << PB0)
#define RED_LED     (1 << PD2) // obacht enthlt auch INT0

#define PWM 	  ((1 << PB1) | (1 << PB2))
#define RIGHT_DIR ((1 << PB4) | (1 << PB5))
#define LEFT_DIR  ((1 << PD4) | (1 << PD5))

#define SWITCHES   (1 << PD3)
#define SWITCH_ON()  (PORTD |= SWITCHES)
#define SWITCH_OFF() (PORTD &= ~SWITCHES)

#define BATTERIE  (1 << MUX0) | (1 << MUX2) //ADC5
#define SWITCH    (1 << MUX2)							//ADC4
#define IR_LEFT	  (1 << MUX0) | (1 << MUX1)	//ADC3
#define IR_RIGHT  (1 << MUX1)							//ADC2
#define FRONT_LED (1 << PD6)

//=/CE\=
#define FRONT_LED_ON() (PORTD |= FRONT_LED)
#define FRONT_LED_OFF() (PORTD &= ~FRONT_LED)
//=/CE\=
#define LINE_FOTOTRANS_DIR_()	(DDRC &= ~(1<<PC2) | (1<<PC3)) // FOTOTRANS ALS rans als EINGANG
#define ODOMETRIE_LED 	  (1 << PD7)
#define ODOMETRIE_LED_ON()  (PORTD |= ODOMETRIE_LED)
#define ODOMETRIE_LED_OFF() (PORTD &= ~ODOMETRIE_LED)

#define WHEEL_LEFT   1		//(1<<MUX0) ADC1
#define WHEEL_RIGHT  0		//0 ADC0


// -------------------------------
// OWN DEFINES von CHristof Ermer 
// -------------------------------
// ------------ MY DEFINES ------------

// =======================================

#define ODO_HYSTERESE	100U // Erfahrungswert -_> ~0..700

#define ODOS_LEFT_LOWHIGH	0x01 // 0 = LOW; 1= HIGH
#define ODOS_RIGHT_LOWHIGH	0x02 // 0 = LOW; 1= HIGH
#define ODOS_LEFT_EVENT		0x04 
#define ODOS_RIGHT_EVENT	0x08 
#define ODOS_LEFT_DIR	0x10 // 0 = FOWRWARD 1= BAckward
#define ODOS_RIGHT_DIR	0x20 // 0 = FOWRWARD 1= BAckward
//#define BACKLED_LEFT	0x40 // NUR LAMEPENFLAG
//#define BACKLED_RIGHT	0x80
//gu8ODO_Status;


//Erzeuge aus 7KHZ 50 Herz PWM
/*
#define PWM_1MS 72
// #define PWM_2MS	144 
#define PWM_LINKS 	170
#define PWM_MITTE	110 // 108  // ((PWM_2MS- PWM_1MS) + PWM_1MS)
#define PWM_RECHTS	60
*/
#define PWM_1MS 50
#define PWM_2MS	150
//#define PWM_1MS 36
//#define PWM_2MS	176
//#define PWM_MITTE	108  // ((PWM_2MS- PWM_1MS) + PWM_1MS)

#define PWM_LINKS 	160
#define PWM_MITTE	110 // 108  // ((PWM_2MS- PWM_1MS) + PWM_1MS)
#define PWM_RECHTS	60


#define SERVO_DIRREG DDRD
#define SERVO_D11_PORT PORTD
#define SERVO_D11_PIN _BV(PD6)
#define SERVO_D11_HIGH()	(SERVO_D11_PORT |= SERVO_D11_PIN)
#define SERVO_D11_LOW()		(SERVO_D11_PORT &= ~SERVO_D11_PIN)
//gsAsuro.extern volatile asuro_t gsAsuro;
//extern volatile asuro_t gsAsuro; 
//extern volatile asuro_t * gpsAsuro; 

extern volatile unsigned char u8Count72kHz;	//Byte Variable !!
extern unsigned char gu8TasterVal;

//CE
extern volatile uint32_t gu32_Ticks;
extern unsigned int gau16OdoData[2];	// 2*INT Array
#ifdef PWM_ON_D11_USED   //gu8PWM_D11_Val trgt die PWMZeit fr Servos
extern unsigned char gu8PWM_D11_Val;
#endif

#ifdef  ODOMETRIEDATA_USED
extern void MyOdometrieData(unsigned int *data);
extern int gi16ODO_LR_Cnt;
extern int long gi32ODO_Cnt_Left;
extern int long gi32ODO_Cnt_Right;
extern uint8_t gu8ODO_Status;
#endif

#ifdef 	LINEDATA_USED
extern int gau16LIneData[2];	// 2*INT Array
#endif

#ifdef ADC_USED_ENABLED
	#define ADC_BANDGAP_VOLTAGE	2.56  // zur verrechnung
	#define ADC_EXTERN_5V	0x00
	#define ADC_5V_AN_C		0x40 //(1<< REFS0)
	#define ADC_INTERN_BANDGAP_2_56V	0xC0 //((1<< REFS1) | (1<< REFS0))	
extern uint16_t ADC_AT8_10Bit(uint8_t u8Chan); // 0..7
#endif

extern void SleepMS(uint32_t u32mSeconds);

#endif /* ASURO_H */

