 
 
 //STATEMACHINE  28.10.2014
//Achtung alle benutzen Datentypen bentigen die Header

#include <stdint.h> 
#include "main.h"
#include <avr\wdt.h>
#include <util\delay.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

//#include <stdio.h>
//#include <math.h>
#include <stdlib.h>
//#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>


#include "uart.h"
#include "main.h"
#include "Befehle.h"
#include "myasuro.h"
#include "statmach.h"

//Globals 
unsigned int gu16StateFlags;  // general USE
uint8_t	gu8StateMachine;  //NUR EIN STATUS 0..255
volatile uint16_t gu16IR_Sensibility;

unsigned char gu8StateFlag;

volatile uint32_t gu32ServoDelay;

volatile uint32_t gu32StateWait;
volatile uint32_t gu32ActiveTime;
volatile uint32_t gu32TimeOut;

uint8_t gu8PWM_Left = 200;
uint8_t gu8PWM_Right = 200;
// in  STATE_GUCKE_GERADE  gu8PWM_Left = 180; gu8PWM_Right = 180;
uint16_t gu16Niedrigerster_IR;
uint8_t gu8NiedrigsterPWM_IR;

// *********************
uint8_t Zufall(uint16_t u16Weite)
// *********************
{
return gu32_Ticks % u16Weite;
} 


#define DREHERECHTS 1
#define DREHELINKS 0
// *********************
void Drehe( uint8_t u8Dir, uint16_t u16Weite )
// *********************
{
if( u8Dir )  //rechts
	{
	MotorSpeed(0,0);
	_delay_ms(10);
	MotorDir(FWD,RWD);
	MotorSpeed(200,200);
	}
else  //LINKS
	{
	MotorSpeed(0,0);
	_delay_ms(10);
	MotorDir(RWD,FWD);
	MotorSpeed(200,200);
	};
	
SleepMS( 20 + u16Weite / 2 ); //Schmutzig

MotorDir(BREAK,BREAK);
MotorSpeed(0,0);
_delay_ms(10);
MotorDir(RWD,RWD);
uart_puts_p(PSTR("Dreh=OK\r"));
uart_putc( 13 );
};

void KurzZurueckFahren(unsigned char u8AbstandMS )
{
MotorSpeed(0,0);
MotorDir(FWD,FWD);
MotorSpeed(200,200);
_delay_ms(u8AbstandMS);
MotorSpeed(0,0);
_delay_ms( 1 );
MotorDir(RWD,RWD);
}

// --------------STATE MACHINE  -----------------
void StateMachine(void)
// --------------STATE MACHINE  -----------------
{
switch( gu8StateMachine ) 
	{
    case STATE_MACH_NIX: //sleep well
		{
		MotorSpeed(0,0);
		gu8PWM_D11_Val = PWM_MITTE; //Servo=gerade
		break;
     case STATE_TRY_AGAIN : 	//auf gehts....
		{
		if( gu8PWM_Left < 190 )
			{
			gu8PWM_Left	= gu8PWM_Right = 190;
			};
		MotorSpeed(0,0);	
	//		gu8StateFlag  = 0;
		gu8StateMachine = STATE_GUCKE_GERADE;
		break;
		}; 
  case STATE_GUCKE_GERADE : //schau erst mal
		{
		gu8PWM_D11_Val = PWM_MITTE;	 
		SleepMS( 300 );
		if ( GetIR_Sens() < IR_ZUNAHE ) //200 ?
			{			
			gu8StateMachine = STATE_FAHRE_RUECKWAERTS;
			break;
			}
		else
			{
			uart_puts_p(PSTR("IRSuCH\r"));
			gu8StateMachine = STATE_IR_SEARCH_START;
			};
		break;
		};
  
  case STATE_SACKGASSE_STECKEFEST:
		{
		uart_puts_p(PSTR("SACKGASS=\r"));
		
		KurzZurueckFahren( ZUNAHE_FAHRZEIT_MS );
		Drehe( Zufall(2), 30 + Zufall(80) ); // 100 + Zufall(100)
		// WAS TU ICH DENN NUN ??
		// Zumindest Text ausgeben 
		gu8StateMachine = STATE_TRY_AGAIN;
		break;
		};

    case STATE_IR_SEARCH_START:
		{
		gu8PWM_D11_Val = PWM_MITTE;		
		SleepMS( 100 );
		if ( GetIR_Sens() < IR_ZUNAHE ) //200 ?
			{
			gu8StateMachine = STATE_FAHRE_RUECKWAERTS;
			break;
			};		
		gu8PWM_D11_Val = PWM_RECHTS;
		KurzZurueckFahren( IRSUCH_RUECK_FAHRZEIT_MS );
		SleepMS( 100 );
		gu16Niedrigerster_IR = 1023; //Falsch stellen
		gu8StateMachine = STATE_IR_SEARCH_ACTIVE;
		break;
		};
   case STATE_IR_SEARCH_ACTIVE:
		{
		if( (gu32_Ticks - gu32StateWait) > IR_SEARCH_DELAY ) //100
			{
			gu32StateWait = gu32_Ticks;			
			//uart_puts_p(PSTR("IRSUCH=\r"));
//			uart_puts( itoa(  GetIR_Sens(), gcaStr, 10 ) );
//			uart_putc( 13 );			
/*
#define PWM_LINKS 	160
#define PWM_MITTE	110
#define PWM_RECHTS	6
*/			
			if( gu8PWM_D11_Val < PWM_LINKS  )
				{
				if( GetIR_Sens() < gu16Niedrigerster_IR )
					{
					gu16Niedrigerster_IR = GetIR_Sens();
					gu8NiedrigsterPWM_IR = gu8PWM_D11_Val; //speicher auch PWM
					};
				gu8PWM_D11_Val += 5;
				uart_puts_p(PSTR("IRsuchZUNAHE\r"));
				SleepMS( 50 );
				}
			else
				{
				if( gu16Niedrigerster_IR < IR_ZUNAHE ) // Auswertung
					{
					gu8StateMachine = STATE_FREIERPLATZ_GEFUNDEN;	
					break;
					}
				else
					{
					gu8PWM_D11_Val = PWM_MITTE;
					//Nichts gefunden //Situation bld in der Ecke stehen
					gu8StateMachine = STATE_SACKGASSE_STECKEFEST;
					break;
					};
				}; // else
			};//if
		break;
		};

	case STATE_FREIERPLATZ_GEFUNDEN :  
	// Versuche in die richtige Richtung zu drehen.
		{ 
/*
#define PWM_LINKS 	160
#define PWM_MITTE	110 // 108  // ((PWM_2MS- PWM_1MS) + PWM_1MS)
#define PWM_RECHTS	60
*/
		// SREVO 170 110 60
		if( gu8NiedrigsterPWM_IR < PWM_MITTE )
			{ // RECHTS
			Drehe( DREHERECHTS, (PWM_MITTE - gu8NiedrigsterPWM_IR) );
			}
		else	//LINKS
			{
			Drehe( DREHELINKS, (gu8NiedrigsterPWM_IR - PWM_MITTE ) );
			};
		gu8StateMachine  = STATE_TRY_AGAIN;	
		break;
		};
	
	
    case STATE_IR_AUTOSTOP:
		{  // ???????? GEHT IR SENS ?
		if( (gu32_Ticks - gu32ActiveTime)  > TICK_50MS ) //TICK_1000MS=282
			{
			gu32ActiveTime = gu32_Ticks;
			MotorDir(FREE,FREE);
			_delay_ms( 2 );
			if( GetIR_Sens() > IR_ZUNAHE )
				{
				MotorSpeed(BREAK,BREAK); // von 0.0
				SleepMS( 5 ) ;
				uart_puts_p(PSTR("IRAutStop\r"));
				gu8StateMachine  = STATE_OBJEKT_ZUNAHE;		
				break;
				};
			MotorDir(RWD,RWD);
			MotorSpeed(gu8PWM_Left, gu8PWM_Right);
			};
		break;
		};		
 
    case STATE_OBJEKT_ZUNAHE:
		{
		gu8StateMachine = STATE_IR_SEARCH_START;
		break;
		};
   	
	case STATE_FAHRE_VORWAERTS:
		{
		SleepMS( 10);
		MotorDir(BREAK, BREAK);
		SleepMS( 10);
		MotorDir(FWD,FWD);
		MotorSpeed(gu8PWM_Left, gu8PWM_Right);
		gu8StateMachine = STATE_IR_AUTOSTOP;  // durch was sinnvolles ersetzen
		break;
		};
		
	case  STATE_FAHRE_RUECKWAERTS:
		{
		MotorDir(BREAK, BREAK);
		uart_puts_p(PSTR("RWD\r"));
		SleepMS( 10);
		MotorDir(RWD,RWD);
		MotorSpeed(gu8PWM_Left, gu8PWM_Right);
		gu8StateMachine = STATE_IR_AUTOSTOP;  // durch was sinnvolles ersetzen
		break;
		};		
/*	
	case STATE_DREHE_LINKS:
		{
		SleepMS( 100);
		MotorDir(FREE,FREE);
		MotorDir(RWD,FWD);
		MotorSpeed(gu8PWM_Left, gu8PWM_Right);
		gu8StateMachine = STATE_IR_AUTOSTOP;  // durch was sinnvolles ersetzen
		break;
		};		
	case STATE_DREHE_RECHTS:
		{
		SleepMS( 100);
		MotorDir(FREE,FREE);
		MotorDir(FWD,RWD);
		MotorSpeed(gu8PWM_Left, gu8PWM_Right);
		gu8StateMachine = STATE_IR_AUTOSTOP;  // durch was sinnvolles ersetzen
		break;
		};	*/
/*		
#ifdef PWM_ON_D11_USED
	case  STATE_FAHREGERADE_MIT_IR_RADAR:
		{
		gu8PWM_D11_Val = PWM_MITTE;
		SleepMS(1);
		if( GetIR_Sens() > gu16IR_Sensibility )
			{
			MotorSpeed(FREE,FREE); //STOP
			//AUF DER STELLE Drehe , 
			if(gu32_Ticks % 2) //REINER ZUFALL 0,1
				{
				MotorDir(RWD,FWD); //rechts
				}
			else
				{
				MotorDir(FWD,RWD);	//links
				};			
			//AUF DER STELLE DreheN , 
			MotorSpeed(gu8PWM_Left, gu8PWM_Right);	
			SleepMS(200 + gu32_Ticks % 1000); //REINER ZUFALL wie lang, mindes 200mS
			MotorSpeed(FREE,FREE); //STOP
			}
		else
			{
			MotorDir(FWD,FWD); // GRADE
			MotorSpeed(gu8PWM_Left,gu8PWM_Right);
			};			
		break;
		};	
#endif //#ifdef PWM_ON_D11_USED
*/

#ifdef PWM_ON_D11_USED	
	case STATE_SCHWENKE_DAS_IR_RADAR:
		{
#ifdef DEMO_MOVE_IR_RADAR
		MotorSpeed(0,0); // erst mal halten.
		// Dann mit dem Servo wackeln.
		if( (gu32_Ticks - gu32IRSenseChk)  >  TICK_10MS) //PULS_500MS_TICK
			{
			gu32IRSenseChk = gu32_Ticks; //Zeit merken !!	
			/*
			gu8PWM_D11_Val  // DAS SOLL MAL ZUM STEPWEISEN DreheufallN FHREN
			#define PWM_1MS	172
			#define PWM_2MS	144
			#define PWM_MITTE	108  // ((PWM_2MS- PWM_1MS) + PWM_1MS)
			*/
			if( gu8ProgModeFlag & SERVO_DIRECTION )  // RECHTS RUM
				{
				if(gu8PWM_D11_Val < PWM_2MS) 
					{
					gu8PWM_D11_Val+=1;
					gu32ServoDelay = gu32_Ticks;
					}		
				else
					{
					gu8ProgModeFlag &= ~SERVO_DIRECTION; // wieder linksrum
					};
				}
			else // LINKSRUM
				{
				if(gu8PWM_D11_Val > PWM_1MS ) 
					{
					gu8PWM_D11_Val-=1;
					gu32ServoDelay = gu32_Ticks;
					}		
				else
					{
					gu8ProgModeFlag |= SERVO_DIRECTION; // wieder rechtsrum
					};
				};
			};
		};
#endif //DEMO_MOVE_IR_RADAR
		break;
		};
/*
    case STATE_AUTOSTART:
		{		
		_delay_ms(1);
		if(  ( (gu32_Ticks - gu32TimeOut) > VOMSTART_TIMEOUT) && // 30Sek.
				!(gu8StateFlag & STATE_DONE_AUTOSTART)
		)
			{
			gu8StateFlag |= VOMSTART_TIMEOUT;
			gu8StateMachine = STATE_TRY_AGAIN;
			};
		break;
		};
*/
		
#endif //#ifdef PWM_ON_D11_USED

	};//switch
};//StateMachine 

