
#ifndef OUTPUTSHIFT_74595_HEADER
#define OUTPUTSHIFT_74595_HEADER


#include "main.h"
#include <util\delay.h>

//---------------------------------------------
// 74HC595 OPUTSHIFT SECTION
//---------------------------------------------
/*
Bezeichnungen

SER =	DS		= 14	Data
RCK =	ST_CP	= 12	Store Clock
SCK =	SH_CP	= 11	Shift Clock
SCL = /MR 	= 10  Master Reset, Shift Clear
		/OE 	= 13	Output Enable
*/
#define NUMBER_OF_74595				4

#define TTL74595_DIR_REG			DDRD
#define TTL74595_DIR_REG_BITMSK	0xF0
	
#define TTL74595_SERDATA_PORT		PORTD	
#define TTL74595_SCK_PORT			PORTD
#define TTL74595_RCK_PORT			PORTD
#define TTL74595_SCL_PORT			PORTD

#define TTL74595_SERDATA_BIT	0x10	//Daten rausshiften
#define TTL74595_SCK_BIT		0x20	//Shift clock ( LowToHigh transition )
#define TTL74595_SCL_BIT		0x40	//PD4 Shift Reset ( Activ Low, clearsdata ion Shift Register) eigentlich unntig.
#define TTL74595_RCK_BIT		0x80 	// Latch Data to Output ( LowToHigh transition )

#define TTL74595_INITDIRREG()	( TTL74595_DIR_REG |= TTL74595_DIR_REG_BITMSK )

#define TTL74595_SERDATA_LOW()	( TTL74595_SERDATA_PORT &= ~TTL74595_SERDATA_BIT ) //Daten rausshiften
#define TTL74595_SERDATA_HIGH()	( TTL74595_SERDATA_PORT |= TTL74595_SERDATA_BIT ) //Daten rausshiften

#define TTL74595_SCK_LOW()		( TTL74595_SCK_PORT &= ~TTL74595_SCK_BIT ) //Shift clock
#define TTL74595_SCK_HIGH()	( TTL74595_SCK_PORT |= TTL74595_SCK_BIT ) //Shift clock

#define TTL74595_RCK_LOW()		( TTL74595_RCK_PORT &= ~TTL74595_RCK_BIT ) // Latch Data to Output
#define TTL74595_RCK_HIGH()	( TTL74595_RCK_PORT |= TTL74595_RCK_BIT ) // Latch Data to Output

#define TTL74595_SCL_LOW()		( TTL74595_SCL_PORT &= ~TTL74595_SCL_BIT ) //Clear	ShiftReg mit HighFlanke RCK
#define TTL74595_SCL_HIGH()	( TTL74595_SCL_PORT |=  TTL74595_SCL_BIT ) 	//Enable SHiftreg

extern uint8_t gu8aTTL74595[ NUMBER_OF_74595 ];//Gobales Array mit Bytezahl der benutzen Shiftregister
extern void Write_OUT74HC595( uint8_t * pca74HC595 );  // mit pointer auf array

#endif //OUTPUTSHIFT_74595_HEADER