

#ifndef OUTPUTSHIFT_74595__HEADER
#define OUTPUTSHIFT_74595_HEADER

#include "main.h"

//---------------------------------------------
// 74HC595 OPUTSHIFT SECTION
//---------------------------------------------
/*
Bezeichnungen

SER =	DS		= 14	Data
RCK =	ST_CP	= 12	Store Clock
SCK =	SH_CP	= 11	Shift Clock
SCL = /MR 	= 10  Master Reset, Shift Clear
		/OE 	= 13	Output Enable
*/

#define EXT_NUMBER_OF_74595	4

#define EXT_TTL74595_DIR_REG	DDRC	//EXT_TTL74595_DIR_REG_BITMSK_SET_SCK_RCK
#define EXT_TTL74595_DIR_REG_BITMSK_SET_SCK_RCK_SCL	0x0F

#define Ext_TTL74595_SERDATA_PORT	PORTC	//DS		Seriell Data
#define EXT_TTL74595_SCK_PORT			PORTC	//SH_CP	Shift Clock
#define EXT_TTL74595_RCK_PORT			PORTC	//ST_CP	Store Clock
#define EXT_TTL74595_SCL_PORT			PORTC	//MR		Shift Clear

#define EXT_TTL74595_SERDATA_BIT		0x01	//Daten rausshiften
#define EXT_TTL74595_SCK_BIT			0x02	//Shift Clock ( LowToHigh transition )
#define EXT_TTL74595_RCK_BIT			0x04 	//Store Clock  Latch Data to Output ( LowToHigh transition )
#define EXT_TTL74595_SCL_BIT			0x08	//Shift Clear PD3( Activ Low, clearsdata ion Shift Register) eigentlich unntig.


#define TTL74595_INITDIRREG()	(EXT_TTL74595_DIR_REG |= EXT_TTL74595_DIR_REG_BITMSK_SET_SCK_RCK_SCL)


#define Ext_TTL74595_SERDATA_LOW()	( Ext_TTL74595_SERDATA_PORT &= ~EXT_TTL74595_SERDATA_BIT ) //Daten rausshiften
#define Ext_TTL74595_SERDATA_HIGH()	( Ext_TTL74595_SERDATA_PORT |= EXT_TTL74595_SERDATA_BIT ) //Daten rausshiften

#define EXT_TTL74595_SCK_LOW()	( EXT_TTL74595_SCK_PORT &= ~EXT_TTL74595_SCK_BIT ) //Shift clock
#define EXT_TTL74595_SCK_HIGH()	( EXT_TTL74595_SCK_PORT |= EXT_TTL74595_SCK_BIT ) //Shift clock

#define EXT_TTL74595_RCK_LOW()	( EXT_TTL74595_RCK_PORT &= ~EXT_TTL74595_RCK_BIT ) // Latch Data to Output
#define EXT_TTL74595_RCK_HIGH()	( EXT_TTL74595_RCK_PORT |= EXT_TTL74595_RCK_BIT ) // Latch Data to Output

#define EXT_TTL74595_SCL_LOW()	( EXT_TTL74595_SCL_PORT &= ~EXT_TTL74595_SCL_BIT ) //Clear	ShiftReg  Shift Clear
#define EXT_TTL74595_SCL_HIGH()	( EXT_TTL74595_SCL_PORT |= EXT_TTL74595_SCL_BIT ) 	//Enable Shiftreg


extern uint8_t gu8aExt_TTL74595[ EXT_NUMBER_OF_74595 ];//Gobales Array mit Bytezahl der benutzen Shiftregister
void Ext_Write_OUT74HC595( uint8_t * pcaExt74HC595 );  // mit pointer auf array

#endif //OUTPUTSHIFT_74595_HEADER