

//------------------------------------------------------------------------------
// Programmed by Christof Ermer 
// Tel:01792431170
// Regensburg Februar 2011
//------------------------------------------------------------------------------

///SYSINFO
//C:\AVR_Projekte\AA_AVR_PRJ_2011
#define PROGPLOCATION "C:\AVR_Projekte\AA_AVR_PRJ_2011\AT8_Proben_4x8_Schalter_4X-74595-Lupton"
#define FUNKTION	"** Proben 4x8 Multiplexer **"
#define PROJEKTNAME "AT16_Proben_4x8_Schalter_4X-74595-Lupton"
#define INSTITUT	"** Universitaet Regensburg **"
#define AUTOR		"** Christof Ermer **"
#define VERSION	"v1.0"
#define DATUM		"14.09.2011"
#define UHRZEIT	"16:00"
#define BAUDRATE "Baud=9600 8N1"

//#define AVR_ATmega16

/* ********* immmer wieder Auf A0..D0 die Relais aktiviert !?
Fehler einghekreist, Befel mit nur einem Buchstaben kann fehler auslsen

Ein Array fr den 74595 wird abgelegt um vllig linear die Situation zu spiegeln
Die Ausgabe fr das Relaisboard wird dann umkodiert.
*/

/* WISSENWERTES


Auflsung ADC +/- 16384 = 0x3FFF = 2500mV
URef = 1,25
	
*/

// SCHALTER 
//IN MAIN.H

/* DIES & DAS 
if( ? : );
 !!! SET COPT IN  FUSE BITS TO ENABLE XTAL !!!!!!!!!!!!!
*/

/*HiSTORY
// **** Hystorie Hystorie Hystorie Hystorie Hystorie Hystorie ****************
BAUDRATE = 9600 
*/

//#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdarg.h>
#include <string.h>

#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <avr\pgmspace.h> //<--#include <progmem.h>

#include <util\delay.h>
#include <avr\interrupt.h>
#include <avr\wdt.h>
//#include <avr\eeprom.h>	
//#include <avr\twi.h>
//#include <avr\signal.h> //#include <signal.h>

#include "main.h"		//with Hardware assigns
#include "uart.h"
//#include "74595.h"
#include "74595_extern.h"
//#include "lcd.h"


//Prototypen
void MatrixConvertierung(void);

void CheckOrder(char* pcStr);

#ifdef TIMER2_USED
void StartTickTimer(void);	//0.1 Seconds  interrupt
uint32_t GetTickDifference(uint32_t ulTime);
#endif

#if TIMERX_USED == 1
void Timer_Init(void); 
#endif


#ifdef UART_USE_ENABLED
void MakePrefix(void);
void UART_TXRX_Check(void);
void ResetRxBuff(void);
void PrintCR(void);
void PrintFloatCR(double fVal);
void PrintHexCR(uint16_t uiVal);
void Print_PStrCR(PGM_P pmStr);
void PrintStrCR(const char* pStr);
void FloatToNumStr(double fVal);
void LongToNumStr(int32_t lVal);
void ULongToNumStr(uint32_t ulVal);
void PrintLongCR(int32_t lVal);
void PrintULongCR(int32_t ulVal);
void U16ToHexNumStr(uint16_t u16Val);
#endif

uint16_t gu16TickSpeed;

//uint8_t gu8aText_74595[ NUMBER_OF_74595 ];//Gobales Array mit Bytezahl der benutzen Shiftregister

///CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//Kodiermatrix	Erzeuge Externe Zurodnung aus der internen linearen LEDZUordnung
const uint8_t MCA_MATRIX[4][8] PROGMEM = { // col,row
// 1. Nipple ist BitPosition als Aufzhlung, 2. Nipple ist Y Row ZUordnung= arrayField 
// Dann Algorythmus zum Umcodieren aufrufen
{0x03,0x07,0X13,0x17,0x23,0x27,0x33,0x37,},	//A  0,0 = A3 = row-0 col-3 = x03
{0x02,0x06,0x12,0x16,0x22,0x26,0x32,0x36,},	//B
{0x01,0x05,0x11,0x15,0x21,0x25,0x31,0x35,},	//C
{0x00,0x04,0x10,0x14,0x20,0x24,0x30,0x34,}	//D

}; //data = pgm_read_byte(&(mCylonScan[i][j]));


#define NUMBER_OF_74595	4
static uint8_t gu8aTTL74595[ NUMBER_OF_74595 ];//Gobales Array mit Bytezahl der benutzen Shiftregister



#ifdef TEXT_SERVICE_USE_ENABLED
const char MCA_DELIMITER_MSG[] PROGMEM	= ",";
//static const char MCA_ASK_MSG[] PROGMEM	= "?";	
//static const char MCA_ISTGLEICH_MSG[] PROGMEM	= "=";

//static const char MCA_ERROR_MSG[] PROGMEM	= "ERROR";
//static const char MCA_WRONG_MSG[] PROGMEM	= "WRONG";
#endif


// GLOBALE VARIABLEN 
static char gcaNumStr[NUMMAX + 1]; //+1 for the 0
static char gcaStr[STRMAX + 1]; //+1 for the 0

#ifdef UART_USE_ENABLED
static char* gpcRxPars;
static char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
static COMMAND_TYPE gsCmd;
#endif

#ifdef TIMER2_USED
//static uint8_t gcaSegmentStr[SEGMENTSTRMAX + 1]; //+1 for the 0
volatile static uint32_t gu32_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings
#endif

#ifdef USE_ERROR_FLAG
uint8_t gbErrorFlag;
#endif



//**********************************************
//MY GLOBAL VARS
//**********************************************
//uint8_t gu8PrgMode ;
//volatile static uint8_t gu8PrgStatus ;


#ifdef TIMER2_USED
// ****************************************************************
ISR(SIG_OVERFLOW2) //volatile....nihct mehr 
// *******************************************************************
{
sei();
// 16MhZ / 1024 /1024 / 256  = 22,88818359375 Hz
// T= 1/f = 0.016384 ms / Interrupt
gu32_Ticks++;  //Wegens Ausfallgefahr bei berlauf = MINUS
#ifdef UART_USE_ENABLED
UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
#endif
};
#endif


// *************************************
void StartTickTimer(void)
// *************************************
{//Normal MODE OC2 Disconnect Prescale 1024
unsigned char sreg;
sreg = SREG; //loakaler Speicher
cli();
//8000000 / 64/ 1024 = 61,03515625 Hz
TCCR2 = TCCR2_CLK_256;	//frq 15625, NORMAL MODE=NO OCR0
TIMSK |= TIMSK_TOIE2_FLAG;
SREG = sreg;
sei();
};


#ifdef UART_USE_ENABLED
// *******************************************************************
void ResetRxBuff(void)
// *******************************************************************
{
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};
#endif

#ifdef UART_USE_ENABLED
// *******************************************************************
void UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#ifdef UART_ERRORMSG
	if ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		Print_PStrCR( PSTR("UartErr") );
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 32: //remove SPACE, do nothing
				{
				break;
				};	           				
			case 10: //remove LF, do nothing
				{
				break;
				};	           				
			case 13: // order!! from Terminal
				{
				CheckOrder(gcaRxStr);//gcaRxStr = accumulated str
				ResetRxBuff();
				break;
				};	 
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x0FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}// if (pcRxPars < (gcaRxStr + RXSTRMAX))
	else  // To much data Rx, than clear simple all
		{
	 //overflow of RX clears all
		ResetRxBuff();	// Clear Rx Parspointer in Buff an terminate RxStr with 0
		};//if(gpcRxPars < (gcaRxStr + RXSTRMAX))
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};
#endif



#ifdef UART_USE_ENABLED  //MAKLEFILE ANPASSEN

// **********************************************
void FloatToNumStr(double fVal)
// *************
{
dtostrf(fVal, FLOAT_PRAEDIGITS_MAX, FLOAT_DIGITS_MAX, gcaNumStr ); //[-]d.ddd
};

// **********************************************
void LongToNumStr(int32_t lVal)
// **********************************************
{ 
ltoa(lVal, gcaNumStr, 10 );
};

// **********************************************
void ULongToNumStr(uint32_t ulVal)
// **********************************************
{ 
ultoa(ulVal, gcaNumStr, 10 );
};



// *******************************************************************
void PrintCR(void)
// *******************************************************************
{
uart_putc( ASC_CR );
};

// *******************************************************************
void PrintStrCR(const char* pStr)
// *******************************************************************
{
uart_puts(pStr);
PrintCR();
};


// *******************************************************************
void Print_PStrCR(PGM_P pmStr)
// *******************************************************************
{
uart_puts_p(pmStr);
PrintCR();
};


// *******************************************************************
void PrintFloatCR(double fVal)
// *******************************************************************
{
FloatToNumStr(fVal); PrintStrCR(gcaNumStr);
};

// *******************************************************************
void PrintLongCR(int32_t lVal)
// *******************************************************************
{
LongToNumStr(lVal); PrintStrCR(gcaNumStr);
};

// *******************************************************************
void PrintULongCR(int32_t ulVal)
// *******************************************************************
{
ULongToNumStr(ulVal); PrintStrCR(gcaNumStr);
};

/*

// *******************************************************************
void PrintHexCR(uint16_t uiVal)
// *******************************************************************
{
U16ToHexNumStr(uiVal); 
PrintStrCR(gcaNumStr);
};
*/

#endif


// **********************************************
void U16ToHexNumStr(uint16_t u16Val)
// **********************************************
{
utoa( u16Val, gcaNumStr, 10 );
};

// *******************************************************************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
/*
int8_t caCmd[COMAMNDSIZEMAX +1];
	uint8_t ucCmdID;
	float fCmdVal_1;
	float fCmdVal_2;
*/
char * pStrTok; // fr strtok_r
char * pucCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*

strcpy(gcaStr, pcStrOrder);
strcpy_P(gcaNumStr, MCA_DELIMITER_MSG); //HILFSWEISE gcaNumStr fr ","

if( (pStrTok = strtok_r( pcStrOrder, gcaNumStr  , &pucCh)) != NULL)
	{	
	strcpy(gsCmd.caCmd, pStrTok);
	}
else
	{
	*gsCmd.caCmd = 0;
	};
gsCmd.caCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10

gsCmd.fCmdVal_1 = 0;
gsCmd.fCmdVal_2 = 0;
gsCmd.fCmdVal_3 = 0;
gsCmd.fCmdVal_4 = 0;

if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)//Hole nun einen Value nach COMMAND,VALUE
	{
	gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	};

if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)//Hole nun einen Value nach COMMAND,VALUE
	{
	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	};

if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)//Hole nun einen Value nach COMMAND,VALUE
	{
	gsCmd.fCmdVal_3 = atof(pStrTok);// Und dann TO Float	
	};

if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)//Hole nun einen Value nach COMMAND,VALUE
	{
	gsCmd.fCmdVal_4 = atof(pStrTok);// Und dann TO Float	
	};
	
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)
	{
	strcpy(gcaStr, pStrTok);
	};

//========================================================================================

if( !strcasecmp_P( gsCmd.caCmd, PSTR("PING"))  )    //ping
	{	
	Print_PStrCR( PSTR("Pong") );
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("RR") )  ) 
	{
	gu8aTTL74595[0] = 0;
	gu8aTTL74595[1] = 0;
	gu8aTTL74595[2] = 0;
	gu8aTTL74595[3] = 0;
	gu8aExt_TTL74595[0] = 0;
	gu8aExt_TTL74595[1] = 0;
	gu8aExt_TTL74595[2] = 0;
	gu8aExt_TTL74595[3] = 0;
	//MatrixConvertierung(); nicht notwendig
	Ext_Write_OUT74HC595( gu8aExt_TTL74595 );	
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("FF") )  ) 
	{	
	gu8aTTL74595[0] = 0XFF;
	gu8aTTL74595[1] = 0XFF;
	gu8aTTL74595[2] = 0XFF;
	gu8aTTL74595[3] = 0XFF;
	gu8aExt_TTL74595[0] = 0XFF;
	gu8aExt_TTL74595[1] = 0XFF;
	gu8aExt_TTL74595[2] = 0XFF;
	gu8aExt_TTL74595[3] = 0XFF;	
	//MatrixConvertierung(); nicht notwendig
	Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("LD") )  ) 
	{
	if( (uint8_t)gsCmd.fCmdVal_1 < NUMBER_OF_74595 )
		{
		gu8aTTL74595[(uint8_t)gsCmd.fCmdVal_1] = (uint8_t)gsCmd.fCmdVal_2;
		//PrintLongCR( (uint8_t)gsCmd.fCmdVal_2 );
		MatrixConvertierung();
		Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
		};
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("LDALL") )  ) 
	{
	gu8aTTL74595[0] = (uint8_t)gsCmd.fCmdVal_1;
	gu8aTTL74595[1] = (uint8_t)gsCmd.fCmdVal_2;
	gu8aTTL74595[2] = (uint8_t)gsCmd.fCmdVal_3;
	gu8aTTL74595[3] = (uint8_t)gsCmd.fCmdVal_4;
	MatrixConvertierung();
	Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
	};

//SET
if( !strcasecmp_P( gsCmd.caCmd, PSTR("AA") )  )
	{
	if( (uint8_t)gsCmd.fCmdVal_1 < 8 )
		{
		gu8aTTL74595[0] |= _BV((uint8_t)gsCmd.fCmdVal_1);
		MatrixConvertierung();
		Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
		};
	};
if( !strcasecmp_P( gsCmd.caCmd, PSTR("BB") )  )
	{
	if( (uint8_t)gsCmd.fCmdVal_1 < 8 )
		{	
		gu8aTTL74595[1] |= _BV((uint8_t)gsCmd.fCmdVal_1);
		MatrixConvertierung();
		Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
		};
	};
if( !strcasecmp_P( gsCmd.caCmd, PSTR("CC") )  )
	{	
	if( (uint8_t)gsCmd.fCmdVal_1 < 8 )
		{
		gu8aTTL74595[2] |= _BV((uint8_t)gsCmd.fCmdVal_1);
		MatrixConvertierung();
		Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
		};
	};
if( !strcasecmp_P( gsCmd.caCmd, PSTR("DD") )  )
	{
	if( (uint8_t)gsCmd.fCmdVal_1 < 8 )
		{
		gu8aTTL74595[3] |= _BV((uint8_t)gsCmd.fCmdVal_1);
		MatrixConvertierung();
		Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
		};
	};


//CLEAR
if( !strcasecmp_P( gsCmd.caCmd, PSTR("CLA") )  ) 
	{
	CLEAR_A();
	MatrixConvertierung();
	Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
	};
if( !strcasecmp_P( gsCmd.caCmd, PSTR("CLB") )  ) 
	{
	CLEAR_B();
	MatrixConvertierung();
	Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
	};
if( !strcasecmp_P( gsCmd.caCmd, PSTR("CLC") )  ) 
	{
	CLEAR_C();
	MatrixConvertierung();
	Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
	};
if( !strcasecmp_P( gsCmd.caCmd, PSTR("CLD") )  ) 
	{
	CLEAR_D();
	MatrixConvertierung();
	Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
	};

// ----------------- CLEAR ------------------------------
if( !strcasecmp_P( gsCmd.caCmd, PSTR("CA") )  )
	{	
	if( (uint8_t)gsCmd.fCmdVal_1 < 8 )
		{
		gu8aTTL74595[0] &= ~ _BV((uint8_t)gsCmd.fCmdVal_1);
		MatrixConvertierung();
		Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
		};
	};
if( !strcasecmp_P( gsCmd.caCmd, PSTR("CB") )  )
	{	
	if( (uint8_t)gsCmd.fCmdVal_1 < 8 )
		{
		gu8aTTL74595[1] &= ~ _BV((uint8_t)gsCmd.fCmdVal_1);
		MatrixConvertierung();
		Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
		};
	};
if( !strcasecmp_P( gsCmd.caCmd, PSTR("CC") )  )
	{	
	if( (uint8_t)gsCmd.fCmdVal_1 < 8 )
		{
		gu8aTTL74595[2] &= ~ _BV((uint8_t)gsCmd.fCmdVal_1);
		MatrixConvertierung();
		Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
		};
	};
if( !strcasecmp_P( gsCmd.caCmd, PSTR("CD") )  )
	{
	if( (uint8_t)gsCmd.fCmdVal_1 < 8 )
		{	
		gu8aTTL74595[3] &= ~ _BV((uint8_t)gsCmd.fCmdVal_1);
		MatrixConvertierung();
		Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
		};
	};

//get information ,. ist Relais gesetzt, wenn nix, dann 0
if( !strcasecmp_P( gsCmd.caCmd, PSTR("GA") )  )
	{
	PrintLongCR( gu8aTTL74595[0] );	
	};
if( !strcasecmp_P( gsCmd.caCmd, PSTR("GB") )  )
	{
	PrintLongCR( gu8aTTL74595[1] );	
	};
if( !strcasecmp_P( gsCmd.caCmd, PSTR("GC") )  )
	{
	PrintLongCR( gu8aTTL74595[2] );	
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("GD") )  )
	{
	PrintLongCR( gu8aTTL74595[3] );	
	};
	

if( !strcasecmp_P( gsCmd.caCmd, PSTR("TT") )  )
	{
	PrintLongCR( gu32_Ticks );
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("??") )  )
	{
	Print_PStrCR(PSTR("Mnemonics-Menue:"));
	Print_PStrCR(PSTR("{X}= A,B,C,D"));	
	Print_PStrCR(PSTR("PING"));	
	Print_PStrCR(PSTR("RR=Clear-All"));	
	Print_PStrCR(PSTR("FF=Set-All"));	
	Print_PStrCR(PSTR("{XX},{0..7} =SetBit"));	
	Print_PStrCR(PSTR("C{X},{0..7} =ClearBit"));	
	Print_PStrCR(PSTR("LD,{0..3},{0..255}"));	
	Print_PStrCR(PSTR("LDA,{A},{B},{C},{D} ->{0..255}"));	
	Print_PStrCR(PSTR("CL{X} = Clear A/B/C/D"));	
	Print_PStrCR(PSTR("G{X} =Get-Info"));	
	Print_PStrCR(PSTR("TT =Timestamp"));	
	};
		
//Write_OUT74HC595( gu8aTTL74595 ); // Immer Vernderungen sofort ausfhren
//PrintCR();
};//ENDE ORDER FUNC.


// *******************************************************************
void MatrixConvertierung(void)
// *******************************************************************
{// 1. Nipple ist Y Row ZUordnung als Aufzhlung 0..7 2. Nipple ist BitPosition als Aufzhlung 0..7
uint8_t u8Row,u8Col, u8Matrix;
cli(); // Weil immmer wieder Auf A90..D0 die Relais aktiviert wurden
for(u8Row=0;u8Row < 4;u8Row++)
	{
	for(u8Col=0;u8Col < 8;u8Col++)
		{
		u8Matrix = pgm_read_byte(&(MCA_MATRIX[u8Row][u8Col]));
		
		if( gu8aTTL74595[u8Row]  & _BV(u8Col) )
			{
			gu8aExt_TTL74595[((u8Matrix & 0xF0) >> 4)] |= _BV(u8Matrix & 0x0F);	 // ((u8Matrix & 0xF0) >> 3) 						
			}
		else
			{
			gu8aExt_TTL74595[((u8Matrix & 0xF0) >> 4)] &= ~_BV(u8Matrix & 0x0F);	 // ((u8Matrix & 0xF0) >> 3) 			
			};
		};
sei();
};	
/*
PrintLongCR(	gu8aExt_TTL74595[0] );		
PrintLongCR(	gu8aExt_TTL74595[1] );		
PrintLongCR(	gu8aExt_TTL74595[2] );		
PrintLongCR(	gu8aExt_TTL74595[3] );		
PrintCR();
*/
};

// *******************************************************************
int main(void)
// *******************************************************************
{
uint8_t u8Scan;

//uint32_t u32NN;
//uint16_t u16NN;
//uint32_t ulTimeCompare; //Schneller millisekunden zeitvergleich;
//INITS
cli();//The global interrupt flag is maintained in the I bit of the status register (SREG).  
wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//Wichtige Schritte.. so bald wie mglich

//INIT HARDWARE
//USing of PORTOUTS  1=OUT, 0=IN

//Print_PStrCR( PSTR("X") );
DDRB = PORTB_OUTMASK;
PORTB = PORTB_PRESET_PULLMASK;
//-----------
DDRC = PORTC_OUTMASK;
PORTC = PORTC_PRESET_PULLMASK;
//-----------
DDRD = PORTD_OUTMASK;	
PORTD = PORTD_PRESET_PULLMASK;

TTL74595_INITDIRREG();

#ifdef TIMER2_USED
StartTickTimer();	//8 Bit Timer 2 = MS Tick Counter
#endif

// ZUM LESEN IMMER PINx verwenden
//Pointer and Strings init
wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE
//ACSR |= ACD;

#ifdef UART_USE_ENABLED
ResetRxBuff();
// Initialize UART library, pass baudrate and avr cpu clock
// with the macro UART_BAUD_SELECT()
uart_init( UART_BAUD_SELECT( UART_BAUD_RATE, F_CPU) );// !! Init UART interface
sei();
#endif

gu32_Ticks;
//Print_PStrCR( PSTR("Relais Schaltbox") );


//Clear all Shift Register
gu8aTTL74595[0] = 0;
gu8aTTL74595[1] = 0;
gu8aTTL74595[2] = 0;
gu8aTTL74595[3] = 0;
gu8aExt_TTL74595[0] = 0;
gu8aExt_TTL74595[1] = 0;
gu8aExt_TTL74595[2] = 0;
gu8aExt_TTL74595[3] = 0;
//MatrixConvertierung(); nicht notwendig
Ext_Write_OUT74HC595( gu8aExt_TTL74595 );	

Print_PStrCR( PSTR(FUNKTION) );
//Print_PStrCR( PSTR(PROJEKTNAME) );
Print_PStrCR( PSTR(INSTITUT) );
Print_PStrCR( PSTR(AUTOR) );
Print_PStrCR( PSTR(VERSION) );
Print_PStrCR( PSTR(DATUM) );
Print_PStrCR( PSTR(BAUDRATE) );

u8Scan = 0;
gu16TickSpeed = TICK_SEKUNDE;


// ************ MAIN LOOP *********************
for(;;)  /* loop forever */
   {
	sei();
	wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	if( !(gu32_Ticks) % gu16TickSpeed )  //TICK_500MS
		{		

		MatrixConvertierung();
		Ext_Write_OUT74HC595( gu8aExt_TTL74595 );
/*	
		PrintLongCR( u32TimeNow );
		//PrintCR();
		//PrintLongCR( gu8aTTL74595[0] );
		//PrintLongCR( gu8aTTL74595[1] );
		//PrintLongCR( gu8aTTL74595[3] );
		//PrintLongCR( gu8aTTL74595[4] );
*/
		};//TICK

		
#ifdef UART_USE_ENABLED
	UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
#endif
	}; // main   END END *************
};

	// ******************* MAIN END ********************************************
