

#define VERSION "\n V1.1 SoftPWM\r"
#define DaTUM "\n 05.09.2017 \r"
#define AUTOR	" Christof Ermer \r"
#define ORGANISATION	"\n Universitt Regensburg \r"

/*
Geschichte:
V1.0 Org UART rausgenommen und UART1
v1.0 Org modifiziert mit UART1 Text eingabe
V1.1   Soft PWM Movement durch Zielvorgabe ( einstellbar bewegung 
100usTimer  T2 = Stopwatch wird auch Tickcounter
10000 = 1 Sekunde Ticks.
uint8_t gu16aSollPWM[PWM_CHANNELS]; // 7 PWMs#

Baustelle
uint16_t  gau16Servos[PWM_CHANNEL];
gau16Servos[0] = OCR1A;
*/


/* 
 * ****************************************************************************
 * Robotarm v3 - ROBOT BASE EXAMPLES
 * ****************************************************************************
 * Example: Robotarm keyboard
 * Author(s): Hein wielink
			  Huy Nguyen 
 * ****************************************************************************
 * Description:
 * In this program you can control the Robotarm with an external keyboard
 *
 * ############################################################################
 * ATTENTION: Make sure you have calibrated the Robotarm or else you
 * can damage de servos!!!
 * You can calibrate the servos with the selftest program. (press c)
 * ############################################################################
 * ****************************************************************************
 */
 
/*****************************************************************************/
// Includes:

#include <avr/pgmspace.h>

#include "RobotArmBaseLib.h"// The Robotarm Robot Library.
							// Always needs to be included!

#include "main.h"
#include "uartU01.h"
#include "TxtFuncU1.h"

static volatile uint32_t gu32Tick_MoveOld;
volatile uint16_t gu16Movespeed;
volatile uint8_t gu8aDirecton_Flags; // // Bit = SerVONr
volatile uint8_t gu8ProgFlag;
volatile uint8_t gu8ServoActiveFlag;		// Speicher fr actives Servos (BIT) 0=Servo1/0
uint16_t gu16aSollPWM[ PWM_CHANNELS ]; // 6 PWMs#
uint16_t gau16Servos[ PWM_CHANNELS ];

//Idee 6 Pointerarray auf Register PWM_CHANNELS, WAR NIX !!


int speed = 2;

void Event( int x )
{
	switch(x){
	    case 0: { setLEDs(0b0000); break;} // Nothing happend!
		case 1: { Pos_Servo_1--; sleep(speed); break;}
		case 2: { Pos_Servo_1++; sleep(speed); break;}
		case 3: { Pos_Servo_2--; sleep(speed); break;}
		case 4: { Pos_Servo_2++; sleep(speed); break;}
		case 5: { Pos_Servo_3--; sleep(speed); break;}
		case 6: { Pos_Servo_3++; sleep(speed); break;}
		case 7: { Pos_Servo_4--; sleep(speed); break;}
		case 8: { Pos_Servo_4++; sleep(speed); break;}
		case 9: { Pos_Servo_5--; sleep(speed);break;}
		case 10: {  Pos_Servo_5++; sleep(speed);break;}
		case 11: {  Pos_Servo_6--; sleep(speed);break;}
		case 12: {  Pos_Servo_6++; sleep(speed);break;}
		case 13: 
			uart1_puts_p( PSTR("\n SPEED INCREASE +++\r") ); 
			speed--; 
			if(speed < 2) speed = 1;
			setLEDs(0b0001); 
			mSleep(500);
			break;
		case 14: 
			uart1_puts_p( PSTR("\n SPEED DECREASE ---\r")); 
			speed++; 
			if(speed > 150) speed = 150;
			setLEDs(0b0010); 
			mSleep(500);
			break;
		case 15: 
			uart1_puts_p( PSTR("\n SPEED INCREASE +++\r")); 
			speed--; 
			if(speed < 2) speed = 1;
			setLEDs(0b0100); 
			mSleep(500);
			break;
		case 16: 
			uart1_puts_p( PSTR("\n SPEED DECREASE ---\r")); 
			speed++; 
			if(speed > 150) speed = 150;
			setLEDs(0b1000); 
			mSleep(500);
			break;
	}
}


// ******************************
void  CheckOrder(void )
//**********************
{
uint8_t u8PWMs;
if( gu8UartStatusFlags & UART_CMD_EVENT_FLAG)
	{
	gu8UartStatusFlags &= ~UART_CMD_EVENT_FLAG;		
	
		
	if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("DSPWM"))  ) //DiRekT SINGLE
		{		
		switch( (uint8_t)gsCmd.u16CmdVal_1 )
			{
			case 0:
				{
				Pos_Servo_1 = (uint16_t)gsCmd.u16CmdVal_2;
				break;
				};
			case 1:
				{
				Pos_Servo_2 = (uint16_t)gsCmd.u16CmdVal_2;
				break;
				};
			case 2:
				{
				Pos_Servo_3 = (uint16_t)gsCmd.u16CmdVal_2;
				break;
				};
			case 3:
				{
				Pos_Servo_4 = (uint16_t)gsCmd.u16CmdVal_2;
				break;
				};
			case 4:
				{
				Pos_Servo_5 = (uint16_t)gsCmd.u16CmdVal_2;
				break;
				};
			case 5:
				{
				Pos_Servo_6 = (uint16_t)gsCmd.u16CmdVal_2;
				break;
				};
			uart1_puts_p( PSTR("\nOK>\r") );
			};				
		return;
		};	
	
	if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("DAPWM"))  )    //DIRECT, ALL
		{	
		Pos_Servo_1 = gsCmd.u16CmdVal_1;
		Pos_Servo_2 = gsCmd.u16CmdVal_2;
		Pos_Servo_3 = gsCmd.u16CmdVal_3;
		Pos_Servo_4 = gsCmd.u16CmdVal_4;
		Pos_Servo_5 = gsCmd.u16CmdVal_5;
		Pos_Servo_6 = gsCmd.u16CmdVal_6;
		uart1_puts_p( PSTR("\n OK>\r") );
		
		return;
		};


//gu16aSollPWM
	if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("MSPEED"))  )    
		{	
		gu16Movespeed = gsCmd.u16CmdVal_1;	// ~50..100--1000	
		uart1_puts_p( PSTR("\n  MSPEED OK>\r") );	
		return;
		};	
		

	if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("MOVEONE"))  )    //MOVEONE, [0..5], [0.255]
		{				
//Ermittele Richtung.
		
		gau16Servos[0] = OCR1A;
		gau16Servos[1] = OCR1B;
		gau16Servos[2] = OCR1C;
		gau16Servos[3] = OCR3A;
		gau16Servos[4] = OCR3B;
		gau16Servos[5] = OCR3C;

		gu16aSollPWM[ (uint8_t)gsCmd.u16CmdVal_1 ] = gsCmd.u16CmdVal_2;  // Speichere Val
		
		gsCmd.u16CmdVal_1 %= PWM_CHANNELS;		//Limitiere (Gefahr Arrayberschreitung)
		//Soll[ Nr ]= WERT
		
		if( gau16Servos[ (uint8_t)gsCmd.u16CmdVal_1 ]  != gu16aSollPWM[ (uint8_t)gsCmd.u16CmdVal_1 ] )
			{
			if( gu16aSollPWM[ (uint8_t)gsCmd.u16CmdVal_1 ] > gau16Servos[ (uint8_t)gsCmd.u16CmdVal_1 ] )
				{						
				gu8aDirecton_Flags |= (1 << (uint8_t)gsCmd.u16CmdVal_1);	//Setze parallel dazu das BIT
				}
			else
				{
				gu8aDirecton_Flags &= ~(1 << (uint8_t)gsCmd.u16CmdVal_1);
				};
			gu8ServoActiveFlag |= (1 << (uint8_t)gsCmd.u16CmdVal_1); // Setze synchron das ActiveBit
			};
		uart1_puts_p( PSTR("\n MoveOne OK>\r") );
		return;
		};		


	if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("MOVEALL"))  )    //ping
		{				
//Ermittele Richtung.
		//SPIEGELE INHALT DER PWM TIMER
		gau16Servos[0] = OCR1A;
		gau16Servos[1] = OCR1B;
		gau16Servos[2] = OCR1C;
		gau16Servos[3] = OCR3A;
		gau16Servos[4] = OCR3B;
		gau16Servos[5] = OCR3C;
//Schreib SOLL				
		gu16aSollPWM[ 0 ]  = gsCmd.u16CmdVal_1;
		gu16aSollPWM[ 1 ]  = gsCmd.u16CmdVal_2;
		gu16aSollPWM[ 2 ]  = gsCmd.u16CmdVal_3;
		gu16aSollPWM[ 3 ]  = gsCmd.u16CmdVal_4;
		gu16aSollPWM[ 4 ]  = gsCmd.u16CmdVal_5;
		gu16aSollPWM[ 5 ]  = gsCmd.u16CmdVal_6;
		
		for( u8PWMs=0; u8PWMs < PWM_CHANNELS; u8PWMs++)
			{				
			if( gau16Servos[ u8PWMs ] != gu16aSollPWM[ u8PWMs ] )
				{
				if( gau16Servos[ u8PWMs ] < gu16aSollPWM[ u8PWMs ] )
					{						
					gu8aDirecton_Flags |= (1 << u8PWMs);	//Setze parallel dazu das BIT
					}
				else
					{
					gu8aDirecton_Flags &= ~(1 << u8PWMs);
					};
				gu8ServoActiveFlag |= (1 << u8PWMs); // NUr wenn !=
				};					
			};
		uart1_puts_p( PSTR("\n MoveAll OK>\r") );
		return;
		};	

	
	if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("?"))  )    //ping
		{
		uart1_puts_p( PSTR( ORGANISATION ) );
		uart1_puts_p( PSTR( VERSION ) );
		uart1_puts_p( PSTR( DaTUM ) );
		uart1_puts_p( PSTR( AUTOR ) );	 		
		uart1_puts_p( PSTR( "\nTT\r") );
		uart1_puts_p( PSTR( "\nSON\r") );
		uart1_puts_p( PSTR( "\nSOFF\r") );
		uart1_puts_p( PSTR( "\n Zhle Servos von 0..5\r") );
		uart1_puts_p( PSTR( "\nMSPEED,~~30\r") );
		uart1_puts_p( PSTR( "\nMOVEONE,ServoNr{0..5},Servo1Value[0.255}\r") );
		uart1_puts_p( PSTR( "\nMOVEALL,Servo0Value.,Servo1Value...Serv5Value\r") );
		uart1_puts_p( PSTR( "\nDSPWM,ServoNr,Value\r") );
		uart1_puts_p( PSTR( "\nDAWM,Servo0Value.,Servo1Value...Serv5Value\r") );
		return;
		};	
		
		
	if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TT"))  )    //ping
		{	
		PrintULongCR( gu32T2_Ticks );
		return;
		};	

	if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SON"))  )
		{
		SERVOS_ON();
		uart1_puts_p( PSTR("\nSERVOS_ON OK>\r") );
		return;
		};	
	if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SOFF"))  )
		{
		SERVOS_OFF();
		uart1_puts_p( PSTR("\nSERVOS_OFF OK>\r") );
		return;
		};
	};
// **************************************************************************************	
};

/*****************************************************************************/
// Main function - The program starts here:

int main(void)
{
uint8_t u8PWMs;
uint32_t u32CPULoops=0;
uint32_t u32TckComp_1=0;
//uint32_t u32TckComp_2=0;

	// correctly otherwise.		 
	portInit_v3()
	gu16Movespeed = MOVESPEED_DEFAULT;

	
	initRobotBase(); 	// Always call this first! The Processor will not work
	mSleep(500); 
						// correctly otherwise.	

	uart1_puts_p( PSTR( ORGANISATION ) );
	uart1_puts_p( PSTR( VERSION ) );
	uart1_puts_p( PSTR( DaTUM ) );
	uart1_puts_p( PSTR( AUTOR ) );	 	
	
	uart1_puts_p( PSTR( "\nKey Board Control+TEXT Command XPWM, SPWM, Press a Key!\n\n\r") );

	uart1_puts_p( PSTR( "\nTT\r") );
	uart1_puts_p( PSTR( "\nSON\r") );
	uart1_puts_p( PSTR( "\nSOFF\r") );
	uart1_puts_p( PSTR( "\nMSPEED, ~~30\r") );
	uart1_puts_p( PSTR( "\n Zhle Servos von 0..5\r") );
	
	uart1_puts_p( PSTR( "\nMOVEONE,ServoNr{0..5},Servo1Value[0.255}\r") );
	uart1_puts_p( PSTR( "\nMOVEALL,Servo0Value.,Servo1Value...Serv5Value\r") );
	uart1_puts_p( PSTR( "\nDSPWM,ServoNr,Value\r") );
	uart1_puts_p( PSTR( "\nDAPWM,Servo0Value.,Servo1Value...Serv5Value\r") );

	Servo_Power_And_Start();  //Use this function to power the servos and set them in the center position. 
	//Servo_Power_And_Start_Default(); //MEINE LANGSAM START 
			 //When you want to power off the servos, you need to call function Power_Off_Servos();  

	speed = 2; //Speed for servo from '0'(fast) - '10'(slow)
	//initRobotBase(); 	// Always call this first! The Processor will not work
	mSleep(500);        // delay 1s

	//Servo_Power_And_Start(); // This powers on the servos and moves them to
							 // the start position. 
							 // When you want to power off the servos, 
							 // you need to call the function Power_Off_Servos();
	
	mSleep(800);  
	setLEDs(0b0000);
	
// ---------------------------------------
	// Main loop:
	while( 1 )
	{	
	u32CPULoops++;  //MESSE DURCHLAUF
//if(getStopwatch1() > 100) // have we reached AT LEAST 100ms = 0.1s?

//CPU SPEED ANZEIGE 
/*
	if( (gu32T2_Ticks - u32TckComp_1) > PULS_1SEC_TICK)  //10000UL = SEKUNDE
		{
		u32TckComp_1 = gu32T2_Ticks;
		PrintLongCR( u32CPULoops );
		u32CPULoops=0;
		//uart1_putc('*');
		//uart1_putc(13);
		}	
	
*/
	if( (gu32T2_Ticks - u32TckComp_1) > PULS_1SEC_TICK)  //10000UL = SEKUNDE
		{
		u32TckComp_1 = gu32T2_Ticks;
//		PrintLongCR( u32CPULoops );
//		u32CPULoops=0;
		uart1_putc('*');
		//uart1_putc(13);
		}	


	UART_TXRX_Check();
	if( gu8UartStatusFlags & UART_CMD_EVENT_FLAG)
		{			
		CheckOrder();
		};

	Event(scan_keyboard());
		//mSleep(1);
	
/*
	if( (gu32T2_Ticks - u32TckComp_2) > PULS_20stel_TICK)  //10000UL = SEKUNDE
		{
		u32TckComp_2 = gu32T2_Ticks;
		};
		
*/
	if( (gu32T2_Ticks - gu32Tick_MoveOld) > gu16Movespeed )
		{
		gu32Tick_MoveOld = gu32T2_Ticks;
	//gu8ProgFlag |= PROG_SERVOMOVE_TICK_EVENT;
			
//* SINGEL_PWM * SINGEL_PWM * SINGEL_PWM * SINGEL_PWM *SINGEL_PWM *	
		if( gu8ServoActiveFlag &  PWM_CHANNELS_BITMASK) // Ist berhaupt irgendwas akive
			{
			//SPIEGELE INHALT DER PWM TIMER
			gau16Servos[0] = OCR1A;
			gau16Servos[1] = OCR1B;
			gau16Servos[2] = OCR1C;
			gau16Servos[3] = OCR3A;
			gau16Servos[4] = OCR3B;
			gau16Servos[5] = OCR3C;
			
			for( u8PWMs=0; u8PWMs < PWM_CHANNELS; u8PWMs++)
				{
				if( gu8ServoActiveFlag & (1 << u8PWMs) )	//wer ist aktive
					{
					if(gu8aDirecton_Flags & (1 << u8PWMs) ) //ermittle Richtung
						{
						if( gau16Servos[ u8PWMs ] < gu16aSollPWM[ u8PWMs ] ) // RAUFZHLEN solange <
							{
							gau16Servos[ u8PWMs ]++;	
							}
						else
							{
							gau16Servos[ u8PWMs ] = gu16aSollPWM[ u8PWMs ];	//gleich
							gu8ServoActiveFlag &= ~(1 << ( u8PWMs ));	//Clear flag
							}
					
						}
					else
						{
						if( gau16Servos[ u8PWMs ] > gu16aSollPWM[ u8PWMs ] ) // RUNTERZHLEN solange <
							{
							gau16Servos[ u8PWMs ]--;	
							}
						else
							{
							gau16Servos[ u8PWMs ] = gu16aSollPWM[ u8PWMs ];	//gleich
							gu8ServoActiveFlag &= ~(1 << ( u8PWMs ));	//Clear flag
							};							

						};
					} //Direction?				
				
				}; //Wer Active ? 0..5
			// und zurckschreiben
			OCR1A = gau16Servos[0];
			OCR1B = gau16Servos[1];
			OCR1C = gau16Servos[2];
			OCR3A = gau16Servos[3];
			OCR3B = gau16Servos[4];
			OCR3C = gau16Servos[5];
			}; // irgendwas was aktive?
			
		}// PROG_SERVOMOVE_TICK_EVENT

	// End of main loop!		
	// ---------------------------------------
	}
	return 0;
}
