
#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include <string.h>
//#include <math.h>
#include <stdlib.h>
#include "main.h"
#include "uartU01.h"
#include "TxtFuncU1.h"

#ifdef UART_USE_ENABLED

// GLOBALE VARIABLEN
uint8_t gu8UartStatusFlags; // NEU fr Transport in MAIN
char* gpcRxPars;
char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
char gcaNumStr[NUMMAX + 1]; //+1 for the 0
char gcaStr[STRMAX + 1]; //+1 for the 0
COMMAND_TYPE gsCmd;

//Funktionen Definition
// *******************************************************************
void UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;

uiRxUart = uart1_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!

if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#ifdef USE_ERROR_MSG
	if ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart1_init( UART_BAUD_SELECT( UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		uart1_puts_p(  PSTR("\nUartErr\n") );
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 10: // nix machen
				{				
				break;
				};	           				
			case 13: // order!! from Terminal
				{
				TokensRXStr( gcaRxStr); //gcaRxStr = accumulated str		
				ResetRxBuff();
				gu8UartStatusFlags |= UART_CMD_EVENT_FLAG;
				//Jetzt in Main ausgelagtert damit Int frei ist 
				//CheckOrder();		
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x0FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}// if (pcRxPars < (gcaRxStr + RXSTRMAX))
	else  // To much data Rx, than clear simple all
		{
	 //overflow of RX clears all
		ResetRxBuff();	// Clear Rx Parspointer in Buff an terminate RxStr with 0
		};//if(gpcRxPars < (gcaRxStr + RXSTRMAX))
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};



// *******************************************************************
void ResetRxBuff(void)
// *******************************************************************
{
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};



// *******************************************************************
void TokensRXStr(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
//uint16_t uiCnt =0;
char caDelimiter[]=",";
char * pStrTok; // fr strtok_r
char * pucCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*

if( (pStrTok = strtok_r( pcStrOrder, caDelimiter , &pucCh)) != NULL) // Trenne 1.Token in Command
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}
else
	{
	*gsCmd.ucaCmd = 0;
	return;
	};	
gsCmd.ucaCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10

gsCmd.u16CmdVal_1 = PWM_SERVO_MITTE_MS;
gsCmd.u16CmdVal_2 = PWM_SERVO_MITTE_MS;
gsCmd.u16CmdVal_3 = PWM_SERVO_MITTE_MS;
gsCmd.u16CmdVal_4 = PWM_SERVO_MITTE_MS;
gsCmd.u16CmdVal_5 = PWM_SERVO_MITTE_MS;
gsCmd.u16CmdVal_6 = PWM_SERVO_MITTE_MS;

if( (pStrTok = strtok_r( NULL,  caDelimiter, &pucCh)) != NULL)
	{
	gsCmd.u16CmdVal_1 = (uint16_t)atoi(pStrTok);// Und dann TO Float	
//	gsCmd.u16CmdVal_1 = atof(pStrTok);// Und dann TO Float	
	}
else
	{
	return;
	}
	
if( (pStrTok = strtok_r( NULL,  caDelimiter, &pucCh)) != NULL)
	{
	gsCmd.u16CmdVal_2 = (uint16_t)atoi(pStrTok);// Und dann TO Float	
//	gsCmd.u16CmdVal_2 = atof(pStrTok);// Und dann TO Float	
	}
else
	{
	return;
	}

if( (pStrTok = strtok_r( NULL,  caDelimiter, &pucCh)) != NULL)
	{
	gsCmd.u16CmdVal_3 = (uint16_t)atoi(pStrTok);// Und dann TO Float	
	}
else
	{
	return;
	}

if( (pStrTok = strtok_r( NULL,  caDelimiter, &pucCh)) != NULL)
	{
	gsCmd.u16CmdVal_4 = (uint16_t)atoi(pStrTok);// Und dann TO Float	
	}
else
	{
	return;
	}

if( (pStrTok = strtok_r( NULL,  caDelimiter, &pucCh)) != NULL)
	{
	gsCmd.u16CmdVal_5 = (uint16_t)atoi(pStrTok);// Und dann TO Float	
	}
else
	{
	return;
	}

if( (pStrTok = strtok_r( NULL,  caDelimiter, &pucCh)) != NULL)
	{
	gsCmd.u16CmdVal_6 = (uint16_t)atoi(pStrTok);// Und dann TO Float	
	}
else
	{
	return;
	};
};


#define FLOAT_PRAEDIGITS_MAX	4 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);
#define FLOAT_DIGITS_MAX		1 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);

// *******************************************************************
void PrintStrCR(const char* pStr)
// *******************************************************************
{
uart1_puts(pStr);
uart1_putc( 13 );
};


// *******************************************************************
void Print_PStrCR(PGM_P pmStr)
// *******************************************************************
{
uart1_puts_p(pmStr);
uart1_putc( 13 );
};

// **********************************************
void FloatToNumStr(double fVal)
// *************
{
dtostrf(fVal, FLOAT_PRAEDIGITS_MAX, FLOAT_DIGITS_MAX, gcaNumStr ); //[-]d.ddd
};

// **********************************************
void LongToNumStr(int32_t lVal)
// **********************************************
{ 
ltoa(lVal, gcaNumStr, 10 );
};

// **********************************************
void ULongToNumStr(uint32_t ulVal)
// **********************************************
{ 
ultoa(ulVal, gcaNumStr, 10 );
};


// *******************************************************************
void PrintLongCR(int32_t lVal)
// *******************************************************************
{
LongToNumStr(lVal); PrintStrCR(gcaNumStr);
};

// *******************************************************************
void PrintULongCR(uint32_t ulVal)
// *******************************************************************
{
ULongToNumStr(ulVal); PrintStrCR(gcaNumStr);
};

// *******************************************************************
void PrintFloatCR(double fVal)
// *******************************************************************
{
FloatToNumStr(fVal); PrintStrCR(gcaNumStr);
};
#endif //UART_USE_ENABLED













