

#ifndef MAIN_HEADER  //Prevents multiple includes
#define MAIN_HEADER

#define FLEURY_USED
#define UART_USE_ENABLED
//sfr |= _BV(bit)  ---  sfr &= ~(_BV(bit))
// TIMER 2 = 16MHZ/8 / 204 = 100uSec
#define PULS_1SEC_TICK		10000UL
#define PULS_20stel_TICK	2000UL
#define PULS_100stel_TICK	100UL


//========================================================================

#define WDTO_2S   7 //WatchDog
//SOFTWARE USED DEFINES

#define  PROG_TIMER_TICK_EVENT	0x01
	//gu8ProgFlag;

#define ASC_CR	13
#define ASC_LF	10


#define  PWM_LINKS_ANSCHLAG_MS		1
#define  PWM_RECHTS_SANSCHLAG_MS	2
// HIER PROJEKTSPEZIFISCHES
//*******************************
//MULTI PWM
//*******************************
#define PWM_CHANNELS	6
//#define PWM_1_5MS_VAL	1500 // 1500
#define PWM_SERVO_MITTE_MS 1500
#define PWM_PAUSEVERLAENEGUNGSFAKT 5


#define START_STOP_DDRX		DDRC
#define START_STOP_PINX		PINC
#define START_STOP_RESET_BIT	(1<<4)
#define START_STOP_RESET_IN()	(START_STOP_PINX & START_STOP_RESET_BIT)

#define SERVO_EN_PRT	PORTG
#define SERVO_EN_DDRX	DDRG
#define SERVO_EN_BIT	(1<<4)

#define SERVOS_ON() (SERVO_EN_PRT |= SERVO_EN_BIT)
#define SERVOS_OFF() (SERVO_EN_PRT &= ~SERVO_EN_BIT)

#define SERVO1_3PORT	PORTB
#define SERVO1_3DDRX	DDRB
#define SERVO4_6PORT	PORTE
#define SERVO4_6DDRX	DDRE

#define SERVO_1_3_MSK	0xE0
#define SERVO_4_7_MSK	0x38

#define SERVO1_BIT (1<<5)	//PD
#define SERVO2_BIT (1<<6)
#define SERVO3_BIT (1<<7)
#define SERVO4_BIT (1<<3)	//PE
#define SERVO5_BIT (1<<4)
#define SERVO6_BIT (1<<5)


#define MULTI_SERVO_1_ON()  (PORTB |= SERVO1_BIT)
#define MULTI_SERVO_1_OFF()  (PORTB &= ~SERVO1_BIT)

#define MULTI_SERVO_2_ON()  (PORTB |=SERVO2_BIT)
#define MULTI_SERVO_2_OFF()  (PORTB &= ~SERVO2_BIT)

#define MULTI_SERVO_3_ON()  (PORTB |= SERVO3_BIT)
#define MULTI_SERVO_3_OFF()  (PORTB &= ~SERVO3_BIT)

#define MULTI_SERVO_4_ON()  (PORTE |= SERVO4_BIT)
#define MULTI_SERVO_4_OFF()  (PORTE &= ~SERVO4_BIT)

#define MULTI_SERVO_5_ON()  (PORTE |= SERVO5_BIT)
#define MULTI_SERVO_5_OFF()  (PORTE &= ~SERVO5_BIT)

#define MULTI_SERVO_6_ON()  (PORTE |= SERVO6_BIT)
#define MULTI_SERVO_6_OFF()  (PORTE &= ~SERVO6_BIT)

/*
#define PREDEF_PWM_0 127
#define PREDEF_PWM_1 127
#define PREDEF_PWM_2 127
#define PREDEF_PWM_3 127
#define PREDEF_PWM_4 127
#define PREDEF_PWM_5 127
#define PREDEF_PWM_6 127
*/

#define  PROG_TIMER_TICK_EVENT		0x01
#define  PROG_SERVOMOVE_TICK_EVENT	0x02
	//gu8ProgFlag;
#define MOVESPEED_DEFAULT 30 //= 1/100^-6  = 100us/pusl

#define PWM_CHANNELS_BITMASK 0x3F //gu8ServoActiveFlag

extern volatile uint32_t gu32T2_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings
extern volatile uint8_t gu8ProgFlag;
extern void CheckOrder(void);
extern volatile uint16_t gu16Movespeed;
extern volatile uint8_t gu8aDirecton_Flags; // // Bit = SerVONr
extern volatile uint8_t gu8ServoActiveFlag;
extern uint16_t gu16aSollPWM[ PWM_CHANNELS ]; // 6 PWMs#
extern uint16_t gau16Servos[ PWM_CHANNELS ];

#endif  //MAIN_HEADER
