
/* 
BEFEHLE 
30.7.2015

Befelsform:
Kommando,u16Val-1,u16Val-2<13>  <13>  //<13> = CR = \r = 13
Bsp:
Motor,123,34<CR>
Ping<CR>
GetSW>CR>

Diese Datei dient zum einfachen Auffinden und Zufgen der Befehle.
Deshalb wurden die Bfehle in diese Datei ausgelagert.
*/

#include <stdint.h>
#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

//#include <stdio.h>
#include <math.h>
#include <stdlib.h>
//#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>
#include <avr\wdt.h>
#include <util\delay.h>


//#include "avr_register.h"	//with Hardware assigns
#include "main.h"			//with Hardware assigns
#include "uart.h"
#include "Befehle.h"
//#include "debug.h"


/*
EIne Besonderheit des AVR Mikrocontrollers ist die unterschiedliche Bheandklung von Zeichen=Strings, 
die entweder im Flash-Speicher  Stehen, und somit von dort gelesen werden,
oder die im RAM stehen,
Es gibt also also C-Funktionen die Strings behandeln doppelt.
einmal mit "Programm Memmory Handling" und
quasi Normal: ohen besonderem, dafr RAM-Verbrauchende Stringbehandlung.

Hier liegt musterglitig ein "const cahr" string , d
der aber im "Programm-Flash" abgespeichert wird und nicht im "RAM".
*/

//	\r return
//	\r\n return, line fedd
//	\r\n \t  return, line fedd, tabulator


// GLOBALE VARIABLEN

#ifdef UART_USE_ENABLED
char* gpcRxPars;
char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
#endif
COMMAND_TYPE gsCmd;

//Rckgabevariablen
unsigned int u16Value;		// UINT 16 Bit
unsigned int u16aData[2];	// 2*INT Array

//CONSTANTEN
const char MCA_TRENNLINIE[] PROGMEM = "-------------\r";
//const char MCA_STOP[] PROGMEM	= "Stop mit: SS\r\n";


// **************************
void ClearUartRxBuff(void) // neu, 26.08.2014
// **************************
{
while( !(uart_getc() & UART_NO_DATA) ) {wdt_reset();};
};

// **************************
void ResetRxBuff(void)
// **************************
{
ClearUartRxBuff();
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};


#ifdef UART_USE_ENABLED
//Funktionen Definition
// *******************************************************************
void UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#ifdef USE_ERROR_MSG
	if ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		uart_puts_p(  PSTR("UartErr\r") );
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 10: // LF raus=nix machen
				{				
				break;
				};	           				
			case 13: // order!! from Terminal
				{
				CheckOrder( gcaRxStr );//gcaRxStr = accumulated str
				ResetRxBuff();
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x00FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}
	else  // To much data Rx, than clear simple all
		{
		//overflow of RX clears all
		ResetRxBuff();
		};
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};

#endif // UART_USE_ENABLED


/* Diese Funktion zerlegt den Befehls-String in einzelne Module */
// *******************************************************************
void TokensRXStr(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
//uint16_t uiCnt =0;
const char caDelimiter[]=",";
char * pStrTok; // fr strtok_r
char * pcCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*

if( (pStrTok = strtok_r( pcStrOrder, caDelimiter , &pcCh)) != NULL) // Trenne 1.Token in Command
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}
else
	{
	*gsCmd.ucaCmd = 0;
	};
gsCmd.ucaCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10

//fr 2 fVal Variablen nach dem Kommando
gsCmd.i16CmdVal_1 = 0;
gsCmd.i16CmdVal_2 = 0;
if( (pStrTok = strtok_r( NULL,  caDelimiter, &pcCh)) != NULL)
	{
	//gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	gsCmd.i16CmdVal_1 = atoi(pStrTok);
	};

if( (pStrTok = strtok_r( NULL,  caDelimiter, &pcCh)) != NULL)
	{
//	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	gsCmd.i16CmdVal_2 = atoi(pStrTok);
	};
};




// *********************************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// *********************************
{//Input von der Seriellen Schnittstlle, in der Form:  "BEFEHL,WERT" BSP: "SFR,1000"
//========================
TokensRXStr(pcStrOrder);   //TxtFunc.h
//========================
ResetRxBuff();

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("DEVICE")))  // GET
	{
	uart_puts_p( PSTR("Blumento Pferde\r") );
	return;
	};



#ifdef ADC_USED_ENABLED	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("ADC") )  )    //ADC,0..3
	{	
	uart_puts( itoa( ADC_AT16_10Bit(gsCmd.i16CmdVal_1), gcaStr, 10 ) );
	uart_putc( 13 );
	return;
	};
#endif	
	
/*
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("")))
	{
	};
*/	
 }; // ORDER

