

#include <avr\io.h>
#include <ctype.h>
#include <inttypes.h>
#include <string.h>
#include <avr\interrupt.h>
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms
#include <avr\wdt.h>
#include <math.h>


#include "avr_register.h"
#include "main.h"
#include "debounce.h"

//Global

KEYSTRUCT_TYPE gsKey;

#ifdef KEY_INTERRUPT_USED
#ifdef KEY_USE_INT0
//************************	****************************************
ISR( INT0_vect ) //SIGNAL(SIG_INTERRUPT01)
//*******************************************************************
{
if( gsKey.u8KeyFlag & KEY_RELEASED )
	{
	GICR &= ~(1 << INT0); // deaktiviert external  INT 0 ();
//1. TEIL. PRESSED SECTION
	gsKey.u8KeyFlag = KEY_INT_EVENT  | KEY_PRESS_DETECT; //Tastenzustand merken und sofort AKTION AUSLSEN...
	gsKey.u8Key = READ_ALL_KEYS();
	gsKey.u32KeyEventTick = gu32_Ticks;
	};
GIFR |= (1 << INTF0) ; //alten Intevent lschen . notwendig ?
};
#endif

#ifdef KEY_USE_INT1
//************************	****************************************
ISR( INT1_vect ) //SIGNAL(SIG_INTERRUPT01)
//*******************************************************************
{
if( gsKey.u8KeyFlag & KEY_RELEASED )
	{
	GICR &= ~(1 << INT1); // deaktiviert external  INT 0 ();
//1. TEIL. PRESSED SECTION
	gsKey.u8KeyFlag = KEY_INT_EVENT | KEY_PRESS_DETECT; //Tastenzustand merken und sofort AKTION AUSLSEN...
	gsKey.u8Key = READ_ALL_KEYS();
	gsKey.u32KyEventTick = gu32_Ticks;
	};
GIFR |= (1 << INTF1) ; //alten Intevent lschen . notwendig ?
};
#endif
#endif



// ***********************************
void Init_Key(void)
// ***********************************
{
INIT_KEYDIR();
INIT_KEYPULLUPS();	

// AKTIVIERE INT0 an PD2 mit falling Edge und Interrupt
// PD2 = INT0 Pin
KEY_DDRX &= ~TASTEN_MASKE; //PD2 auf INPUT
#ifdef KEY_PULLUP_USED
KEY_PULLUP_PORT |= KEY_PULLUP_MSK; // PULLUP ON 
#endif

#ifdef KEY_INTERRUPT_USED
#ifdef KEY_USE_INT0
MCUCR |= _BV ( ISC01 ) ;;// Setze dem Modus des INT0 Pins auf fallende Flanke
MCUCR &= ~_BV( ISC00 ) ;;// Setze dem Modus des INT0 Pins auf fallende Flanke
GIFR |= _BV( INTF0 );	// Lsche anstehende InterrruptFlags
GICR |= _BV( INT0 );	// Aktiviere den INT0 Interrrupt		
#endif
#ifdef KEY_USE_INT1
MCUCR |= _BV ( ISC11 ) ;;// Setze dem Modus des INT1 Pins auf fallende Flanke
MCUCR &= ~_BV( ISC10 ) ;;// Setze dem Modus des INT1 Pins auf fallende Flanke
GIFR |= _BV( INTF1 );	// Lsche anstehende InterrruptFlags
GICR |= _BV( INT1 );	// Aktiviere den INT1 Interrrupt		
#endif
#endif
};


// ***********************************
void Check_Switch(void)
// ***********************************
{	
//1.Fall: Taste wurde gerade gedrckt
//Nun, es passiert irgendwas!, irgendwann! ..
//Und wir warten auf einen evtl. Tastendruck
if( (READ_ALL_KEYS() != KEY_VALUE_UNPRESSED) //Ungleich ungedrckt = Taste
&& (gsKey.u8KeyFlag & KEY_RELEASED) //Release Situation mu aktiv sein!
)
{
gsKey.u8KeyFlag &= KEY_STATUSCLEAR_MASK; //Lsche alte Flags
gsKey.u8KeyFlag |= KEY_PRESS_DETECT; //Press Detect Zustand merken!
gsKey.u8Key = READ_ALL_KEYS(); // nur Bit 2 lesen //Taste lesen
gsKey.u32KeyEventTick = gu32_Ticks; //Zeit merken
};

//2.Fall
//Suche nach Tastenprell-Lese Unterschied und setze Zeit neu
if( ( READ_ALL_KEYS() != gsKey.u8Key ) //falls ungleicher Lesewert Vergleich..
&& (gsKey.u8KeyFlag & KEY_PRESS_DETECT) //Press Detect Situation aktiv!)
)
{
gsKey.u8Key = READ_ALL_KEYS(); //Taste(n) NEU lesen
gsKey.u32KeyEventTick = gu32_Ticks; //Zeit NEU merken
};

//3.Fall
//Suche nach Ende der Debounce-Zeit und gltiger Taste
if( (gsKey.u8KeyFlag & KEY_PRESS_DETECT) //Presed Detect Situation aktiv!
&& ( READ_ALL_KEYS() == gsKey.u8Key ) // immer noch gleich ?
&& ( (gu32_Ticks - gsKey.u32KeyEventTick) > 10 ) // sichere Zeit abgelaufen
)
{
gsKey.u8KeyFlag = KEY_VALID | KEY_PRESSED; //lsche alle anderen Flags
};


//4. TEIL. RELEASE DETECT SECTION
if( (READ_ALL_KEYS() == KEY_VALUE_UNPRESSED) //Tasten nicht gedrckt Zustand erfllt ?
&& !(gsKey.u8KeyFlag & KEY_RELEASED) //noch nicht als Released erkannt !
&& !(gsKey.u8KeyFlag & KEY_RELEASED_DETECT) //noch nicht als Released Detect erkannt !
)
{
gsKey.u8KeyFlag &= KEY_STATUSCLEAR_MASK; //Lsche alte Flags
gsKey.u8KeyFlag |= KEY_RELEASED_DETECT; // Released Detect Zustand merken.
gsKey.u32KeyEventTick = gu32_Ticks; //Zeit merken
};

//5.Teile suche nach RELEASED Situation
if( (READ_ALL_KEYS() == KEY_VALUE_UNPRESSED ) //Tasten nicht gedrckt Zustand erfllt ?
&& (gsKey.u8KeyFlag & KEY_RELEASED_DETECT) //noch nicht als Released Detect erkannt !
&& !(gsKey.u8KeyFlag & KEY_RELEASED) //noch nicht als Released erkannt !
&& ((gu32_Ticks - gsKey.u32KeyEventTick) > 120)
)
{
gsKey.u8KeyFlag &= KEY_STATUSCLEAR_MASK; // Released Detect Zustand merken.
gsKey.u8KeyFlag |= KEY_RELEASED; // Released Detect Zustand merken.
//INTerrupt wieder scharf machen
Init_Key(); // Alles da drin...
};

};

// in main.c 
// 		gsKey.u8KeyFlag &= ~(KEY_VALID | KEY_INT_EVENT);

