
#ifndef DEBOUNCE_HEADER
#define DEBOUNCE_HEADER

#define KEY_INTERRUPT_USED

#define KEY_PULLUP_USED  // AKTIVIEREN WENN PULLUP
#define KEY_PULLUP_MSK	0x04 //WICHTIG, an hardware anpassen

#define KEY_USE_INT0
//#define KEY_USE_INT1 //FALLING EDGE, sonst umprogrammieren


#define TASTEN_MASKE		0x04
#define KEY_VALUE_UNPRESSED 0x04 //Bsp: Nur eine Taste an PD2

#define KEY_DDRX		DDRD
#define KEY_PINX		PIND
#define KEY_PULLUP_PORT	PORTD
	
	
#define KEY_PRESS_DETECT	0x01 // Beachte die Bitaufzhlung
#define KEY_PRESSED 		0x02
#define KEY_RELEASED_DETECT 0x04
#define KEY_RELEASED 		0x08
#define KEY_VALID 			0x10
#define KEY_INT_EVENT 		0x20
#define KEY_STATUSCLEAR_MASK 0xF0 // verunden Maske

#define SWITCH_SWITCH_RELEASE_DELAY_TICKS	24	//~1/5 Sek1INTERRUPTS_PER_SEC_T2 244
#define SWITCH_SWITCH_PRESSED_DELAY_TICKS	10	//Beuetet 5MS mus mindest der selbe Wert gelesen sein.


#define INIT_KEYDIR()		(KEY_DDRX &=  ~TASTEN_MASKE)
#define INIT_KEYPULLUPS()	(KEY_PULLUP_PORT |= TASTEN_MASKE)

#define READ_ALL_KEYS()	(KEY_PINX & TASTEN_MASKE)


//Globals
typedef struct stKey
	{
	uint8_t u8Key;
	uint8_t u8KeyFlag;
	uint32_t u32KeyEventTick;
	}KEYSTRUCT_TYPE;


extern void Check_Switch(void);
extern void Init_Key(void);
extern KEYSTRUCT_TYPE gsKey;
#endif //DEBONCE_HEADER
