
//http://www.roboternetz.de/wissen/index.php/RC5-Decoder_f%C3%BCr_ATMega
//RC5 = Phillips code = 36 kHz

#ifndef _RC5_H_
#define _RC5_H_

#include <inttypes.h>

//INT0 //EINGEFUEGT Christof Ermer
#define RC5_INT0	0
#define RC5_INT1	1
#define RC5_ALL 0xFF

typedef struct
{
	uint8_t code;
	uint8_t addr;
	volatile signed char flip;
	uint8_t u8RC5_State_Flags;
	uint32_t u32EventTime;	
} rc5_t;

extern rc5_t  gstRC5;

extern void rc5_init(uint8_t addr);

extern void ToggleTEST_BIT(uint8_t ucCnt); // main.c

//MEINE DEFINTION CHRISTOF
// Fernbedienungs-Kommandos:
#define IR_NULL		0
#define IR_EINS		1
#define IR_ZWEI		2
#define IR_DREI		3
#define IR_VIER		4
#define IR_FUENF	5
#define IR_SECHS	6
#define IR_SIEBEN	7
#define IR_ACHT		8
#define IR_NEUN		9
#define PROG_CHANNEL	11
#define STANDBYOFF_KEY		12
#define STUMM		13
#define NORMAL_KEY	14
#define DISPLAY		15
#define VOLUME_P	16
#define VOLUME_N	17
#define VOLUME_M 	17
#define BRIGHT_P	18
#define BRIGHT_M		19
#define COLOUR_SATURATION_P	20
#define COLOUR_SATURATION_M	21
#define TIEFEN_P	22
#define TIEFEN_M	23
#define HOEHEN_P	24
#define HOEHEN_M	25
#define BALANCE_P	26
#define BALANCE_M	27
#define SUCHLAUF_MARKE_VOR	30
#define SUCHLAUF_MARKE_BACK	31
#define SUCHLAUF_LANGSAM_BACK	39
#define SUCHLAUF_LANGSAM_VOR	40
#define BILDSUCHLAUF_ZURUECK	44
#define EJEKT					45
#define BILDSUCHLAUF_VORWAERTS	46
#define LAUF_FAST_BACK			50
#define LAUF_FAST_FORWARD		52
#define START	53
#define STOP	54
#define RECORD	55
#define STANDBY	61



//rc5_t.u8RC5_State_Flags
//rc5_t.u32EventTime
#define RC5_READY_FLAG		0x01	//Bereit fr neuen IR Event.
#define RC5_EVENT_FLAG		0x02
#define RC5_EVENT_DONE_FLAG	0x04
//#define RC5_VALID_FLAG	0x04
//#define RC5_RELEASED_FLAG	0x10

#define IR_RELEASE_WAIT_TIME_TICKS	 100 //4mS * 25 = 100mS
#endif /* _RC5_H_ */
