/*
Historie..
Erweitert und verndert fr den ATMEGA328
5
Regsitertausch
GIFR = EIFR
GICR = EIMSK
TIFR = TIFR0
TIMSK = TIMSK0
MCUCR --> EICRA

*/


/*
//EICRA = EICRA_INT1_FALLING_EDGE; //ISC00=0;  FALLING EDGE --> INT0, INT1   //NICHT mit MCUCSR verwechseln !
rc5_init(RC5_ALL);
gstRC5.u8RC5_State_Flags = RC5_READY_FLAG;
gstRC5.u8RC5_State_Flags = RC5_EVENT_DONE_FLAG;
gstRC5.u32EventTime = gu32_Ticks;

*/

// Bearbeitet 04.04.2014 Christof Ermer
// Rueckname der Registerdefintionen..wieder ( 1<<xxx)

//http://www.roboternetz.de/wissen/index.php/RC5-Decoder_f%C3%BCr_ATMega
//RC5 = Phillips code = 36 kHz

#include <avr/sfr_defs.h> //CE
#include <avr/io.h>
#include <avr/interrupt.h>

#include "rc5_ATM328.h"
//#include "main.h"

#ifndef RC5_INT
	#define RC5_INT	RC5_INT0 // Hier wird der INT gewhlt  alternative RC5_INT1
#endif  /* RC5_INT */
  
#ifndef RC5_PRESCALE
#define RC5_PRESCALE 1024
#endif  /* RC5_PRESCALE */

#include "main.h"
//#include "avr_register.h"//with Hardware assigns

/* ******************************************************************************** */

rc5_t gstRC5;

/* ******************************************************************************** */

#ifndef F_CPU
#error Please define F_CPU
#endif /* !F_CPU */

/* s for a whole bit of RC5 (first & second part) */
#define RC5_BIT_US   (64*27)

#define RC5_TICKS \
        ((uint8_t) ((uint32_t) (F_CPU / 1000 * RC5_BIT_US / 1000 / RC5_PRESCALE)))
        
#define RC5_DELTA \
        (RC5_TICKS / 6)
        
typedef union 
{
        uint16_t w;
        uint8_t  b[2];
} code_t;

static code_t gstCode;
static uint8_t gu8RC5_Addr;

/* TCCR0 =  */
/* Number of Interrupts occured so far */
static uint8_t gu8NBits;
static uint8_t gu8Nint;

/* ******************************************************************************** */
void rc5_init(uint8_t addr)
{
        gu8Nint = 0;
		gu8NBits = 0;
        gstRC5.flip = -1;        
        gu8RC5_Addr = addr;
        
#if (RC5_PRESCALE == 1024)
        TCCR0B = (1 << CS02) | (1 << CS00);
//        TCCR0 = (1 << CS02) | (1 << CS00);
#elif   (RC5_PRESCALE==256)
		TCCR0B = (1 << CS02);
//		TCCR0 = (1 << CS02);
#elif   (RC5_PRESCALE==64)
        TCCR0B = (1 << CS01) | (1 << CS00);
//        TCCR0 = (1 << CS01) | (1 << CS00);
#else
#error This RC5_PRESCALE is not supported
#endif /* RC5_PRESCALE */
        
        /* INTx on falling edge */
        /* clear pending INTx */
        /* enable INTx interrupt */
#if (RC5_INT == RC5_INT0)               
        EICRA &= ~(1<<ISC00) ;
        EICRA |= (1<<ISC01);
        EIFR |= (1<<INTF0) ;
        EIMSK |= (1<<INT0);
//        GIFR |= (1<<INTF0) ;
//        GICR |= (1<<INT0);
#elif (RC5_INT == RC5_INT1)             
        EICRA &= ~(1<<ISC10) ;
        EICRA |= (1<<ISC11);
        EIFR |= (1<<INTF1);
        EIMSK |= (1<<INT1);
//        GIFR |= (1<<INTF1);
//        GICR |= (1<<INT1);
#else
#error please define RC5_INT
#endif /* RC5_INT */
}

/* ******************************************************************************** */
 
ISR(TIMER0_OVF_vect)  //ISR (SIG_OVERFLOW0)
{
		uint8_t u8Sreg;

		cli();
		u8Sreg = SREG;
        TIMSK0 &= ~(1<<TOIE0);
//      TIMSK &= ~(1<<TOIE0);
        
        uint8_t _nbits = gu8NBits;
        code_t _code = gstCode;
        if (26 == _nbits)
        {
                _nbits++;
                _code.w <<= 1;
        }
        
        if (27 == _nbits	&&
			_code.b[1] >= 0x30 && /* AGC == 3 */
			0 > gstRC5.flip
		)
        {
                uint8_t _rc5_code;
                uint8_t  _rc5_addr;
                /* we do the bit manipulation stuff by hand, because of code size */
                _rc5_code = _code.b[0] & 0x3f; /* 0b00111111 : #0..#5 */
                _code.w <<= 2;
                _rc5_addr = _code.b[1] & 0x1f; /* 0b00011111 : #6..#10 */
                
                if( ((gu8RC5_Addr & 0x80) || (gu8RC5_Addr == _rc5_addr))						
				)
                {
                        gstRC5.code = _rc5_code;
                        gstRC5.addr = _rc5_addr;
                        signed char flip = 0;
                        if( (_code.b[1] & 0x20) 	/* 0b00100000 : #11 */
							
						)
							{							
							flip = 1;							
							};
                        gstRC5.flip = flip;
                }
        }
        
        gu8Nint = gu8NBits = 0;
		        
        /* INTx on falling edge */
        /* clear pending INTx */
        /* enable INTx interrupt */
#if (RC5_INT == RC5_INT0)               
        EICRA &= ~(1<<ISC00) ;
        EICRA |= (1<<ISC01);
        EIFR |= (1<<INTF0);
        EIMSK |= (1<< INT0);
//        GIFR |= (1<<INTF0);
//        GICR |= (1<< INT0);
#elif (RC5_INT == RC5_INT1)             
        EICRA &= ~(1<<ISC10);
        EICRA |= (1<<ISC11);
        EIFR |= (1<<INTF1);
        EIMSK |= (1<<INT1);
//        GIFR |= (1<<INTF1);
//        GICR |= (1<<INT1);
#endif
SREG = u8Sreg;
sei();
};

/* ***************************************/

#if (RC5_INT == RC5_INT0)               
ISR (INT0_vect)  //ISR (SIG_INTERRUPT0)
#elif (RC5_INT == RC5_INT1)
ISR (INT1_vect)  //ISR (SIG_INTERRUPT1)
#endif /* RC5_INT */
{
        uint8_t u8Sreg;
		code_t _code = gstCode;		
        uint8_t _nint = gu8Nint;
        
        uint8_t tcnt0 = TCNT0;
        TCNT0 = 0;
//ToggleTEST_BIT(4);       
        if (!(_nint) )
        {
		cli();
		u8Sreg = SREG;
                /* INTx on both edges */
#if (RC5_INT == RC5_INT0)               
             EICRA = (EICRA | (1 << ISC00)) & ~ (1 << ISC01);
#elif (RC5_INT == RC5_INT1)             
             EICRA = (EICRA | (1 << ISC10)) & ~ (1 << ISC11);
#endif /* RC5_INT */
        TIFR0 |= (1<<TOV0);
        TIMSK0 |= (1<<TOIE0);
//        TIFR |= (1<<TOV0);
//        TIMSK |= (1<<TOIE0);
		
		SREG = u8Sreg;
		sei();
        _code.w = 0;
        }
        else
        {
                /* Number of bits of the just elapsed period */
                uint8_t n = 1;
         
                /* Bits received so far */
                uint8_t _nbits = gu8NBits;
        
                /* is TCNT0 close to RC5_TICKS or RC5_TICKS/2 ? */
                if (tcnt0 > RC5_TICKS + RC5_DELTA)
                        goto invalid;
                else if (tcnt0 < RC5_TICKS/2 - RC5_DELTA)
                        goto invalid;
                else if (tcnt0 > RC5_TICKS - RC5_DELTA)
                        n = 2;
                else if (tcnt0 > RC5_TICKS/2 + RC5_DELTA)
                        goto invalid;
                
                /* store the just received 1 or 2 bits */
                do
                {
                        _nbits++;
                        if (_nbits & 1)
                        {
                                _code.w <<= 1;
                                _code.b[0] |= _nint & 1;
                        }
                } 
                while (--n);
                
                if (0)
                {
                        invalid:
                        
                        /* disable INTx, run into Overflow0 */

		cli();
		u8Sreg = SREG;
 #if (RC5_INT == RC5_INT0)               
                        EIMSK &= ~(1 << INT0);
//                      GICR &= ~(1 << INT0);
#elif (RC5_INT == RC5_INT1)             
                        EIMSK &= ~(1 << INT1);
//                        GICR &= ~(1 << INT1);
#endif /* RC5_INT */
			SREG = u8Sreg;
			sei(); 
                        _nbits = 0;
                }
                
                gu8NBits = _nbits;
        }

        gstCode = _code;
        gu8Nint = 1+_nint;
};
