


#ifndef MIDI_HEADER	//1. Headereinbindung
#define MIDI_HEADER

#include <inttypes.h>

#define MIDI_USED

#define DEFAULT_INSTRUMENT	12
#define DEFAULT_CHANNEL		0
#define DEFAULT_VELOCITY	0x7F

#define KLAVIERTOENE_BYTES 5 	//Bestimmt Zahl der TneBytes * *8; 5*8=40 Tne


#define MIDISTAT_OFF	0x80
#define MIDISTAT_ON		0x90
#define MIDICTRL_CONTROLLER		0xB0
//Legt das fr den angegebenen Kanal zu spielende Instrument fest (pp = Program Number)
#define MIDIPROG_ChANGE	0xC0	//0xCn pp	

#define KLAVIER_MITTENTON_OFFSET	( KLAVIERTOENE_BYTES * 4) // X*8 / 2
#define MIDDLE_C_NOTE	0x3C		// offset von 0 
#define KLAVIER_BASS_STARTNOTE	(MIDDLE_C_NOTE - KLAVIER_MITTENTON_OFFSET)

#define STATUS_CHROMATISCH	0x01
#define STATUS_DUR			0x02
#define STATUS_MOLL			0x04
#define STATUS_CLEAR_TONLEITER_INVMASK	0xF0
#define CLEAR_TONLEITER() (gu8status &= STATUS_CLEAR_TONLEITER_INVMASK) 
//STATUSTBYTE  gu8MidiStatus



typedef struct stKeyState
	{
	uint64_t	u64Note;	//Now
	uint64_t u64OldState;	//zum Vergleich
	//uint64_t u64KlavierPressed;
	}KLAVIER_TYPE;
//gsKlavier


typedef struct stMidi
	{
	uint8_t u8Channel;
	uint8_t u8Intrument;
	uint8_t		u8Dynamic;
	//uint8_t u8Stat;	// Status   1000 + Chanel
	//uint8_t u8Note;	// Note 0.127		0vvvvvvvvv
	//uint8_t u8Veloc;	// Velocity 0..127	0vvvvvvv
	}MIDI_TYPE;  
//gstMidi


// extern Prototypes
void SendMidi_ON( uint8_t u8Note);
void SendMidi_OFF( uint8_t u8Note);
void SetMidiChannel(uint8_t u8Cannel);

void TXMidi(uint8_t u8Stat, uint8_t u8Note, uint8_t u8Veloc );
void ScanKlavier(void);

//externs
#ifdef MIDI_USED
//GLOBALS
//Extern Globals
extern KLAVIER_TYPE gsKlavier;
extern MIDI_TYPE gstMidi;
extern int16_t gi16SWUart_Status;
extern void ScanKlavier(void);

extern void TxMidi_ProgChange(uint8_t u8Prog);
extern uint8_t gu8MidiStatus;

//extern uint8_t gau8MultiPWM[ PWM_CHANNELS ]; // 7 PWMs


//uint8_t gau8MultiPWM[ PWM_CHANNELS ]; // 7 PWMs
#endif


#endif //MIDI_HEADER
